/* --------------------------------------------------------------------------------------------------- 
 * BuildTool - App Builder
 * 
 * @author	AppResponsive <http://robinbonnes.nl/>
 * @version	1.5
 *
 * Copyright (C) 2013 - 2014 AppResponsive. All rights reserved.
 * 
 * -------------------------------------------------------------------------------------------------- */

var first_run = true;

$(document).ready(function()
{
	/*
	 * Form Validation
	 */
	$('#database_form :input, #login_form :input, #addtemplate_form :input').not("#db_password").addClass('required');
	$('#adduser_form :input, #edituser_form :input').not("#account_password, #account_passwordrepeat").addClass('required');
	$("#database_form, #login_form, #addtemplate_form, #addapp_form, #edituser_form, #adduser_form").validate(
	{
		errorClass: "error",
		validClass: "success",
		errorPlacement: function( error, element )
		{
			return true;
		},
		highlight: function( element, errorClass, validClass )
		{
			$(element).addClass(errorClass).removeClass(validClass);
		},
		unhighlight: function( element, errorClass, validClass )
		{
			$(element).removeClass(errorClass).addClass(validClass);
		}
	});
	
	/*
	 * Input Triggers
	 */
	$('input[id=template_package]').change(function()
	{
		$('#package_name').val($(this).val());
	});
	
	$('input[id=android-keystore-input]').change(function()
	{
		$('#android-keystore').val($(this).val());
	});
	
	$('input[id=ios-p12-input]').change(function()
	{
		$('#ios-p12').val($(this).val());
	});
	
	$('input[id=ios-provisioning-input]').change(function()
	{
		$('#ios-provisioning').val($(this).val());
	});

	$('input[id=blackberry-csk-input]').change(function()
	{
		$('#blackberry-csk').val($(this).val());
	});
	
	$('input[id=blackberry-db-input]').change(function()
	{
		$('#blackberry-db').val($(this).val());
	});
	
	$("#image-input").change(function()
	{
		previewImage(this);
	});

	/*
	 * Tooltips
	 */
	 $('.tooltip').qtip(
	 {
		hide:
		{
			fixed: true,
			delay: 200
		},
		style:
		{
			classes: 'qtip-tipsy qtip-shadow'
		},
		position:
		{
			my: 'bottom left',
			at: 'top right'
		}
	});
	
	/*
	 * Tabs
	 */
    $('.tabs').tabulous();  

	/*
	 * Build/Download Button
	 */
	$('.build_button').click(function (e)
	{
        e.preventDefault();
        return false;
    });
	
	/*
	 * Update Button
	 */
	$('.update').click(function (e)
	{
		$.get('./index.php?getupdate', function(data)
		{
			$('#update_content').empty().append(data);
			window.location.hash = 'update';
		});
    });
	
});

function togglePushAndroid()
{
	console.log($("#push_android_enable"));
	$("#push_android_enable").attr("checked", !$("#push_android_enable").attr("checked"));
	if($("#push_android_enable").attr('checked'))
	{
		// Enable inputs
		$('#push_android_senderid').attr("disabled", false);
		$('#push_android_apikey').attr("disabled", false);
		
		// Add Push Notifications Plugin if not already done so
		var found = false;
		$("#plugins_management > tbody > tr").each(function()
		{
			var name = $(this).children().eq(0).text();
			if(name == "com.phonegap.plugins.pushplugin")
			{
				found = true;
			}
		});
		
		if(!found)
		{
			$('#plugins_management > tbody').append('<tr>' +
				'<td>com.phonegap.plugins.pushplugin</td>' +
				'<td>' +
					'<a class="button button-rounded button-primary" href="#plugins" onclick="editItem(this)"><i class="icon-cog"></i></a> ' + 
					'<a class="button button-rounded button-caution" href="#plugins" onclick="deleteItem(this)"><i class="icon-trash"></i></a>' +
				'</td>' +
				'<input type="hidden" name="plugins[com.phonegap.plugins.pushplugin]" value>' +
			'</tr>');
		}
	}
	else
	{
		// Disabled inputs
		$('#push_android_senderid').attr("disabled", true);
		$('#push_android_apikey').attr("disabled", true);
		
		// Remove Push Notifications Plugin if iOS push is disabled too
		if(!$('#push_ios_enable').is(':checked'))
		{
			$("#plugins_management > tbody > tr").each(function()
			{
				var name = $(this).children().eq(0).text();
				if(name == "com.phonegap.plugins.pushplugin")
				{
					$(this).remove();
				}
			});
		}
	}
}

function togglePushIOS()
{
	$("#push_ios_enable").attr("checked", !$("#push_ios_enable").attr("checked"));
	if($("#push_ios_enable").attr('checked'))
	{
		// Enable inputs
		$('#push_ios_certificate_button').removeClass("disabled");
		$('#push_ios_privatekey_button').removeClass("disabled");
		$('#push_ios_privatekey_password').attr("disabled", false);
		
		// Add Push Notificatiosn Plugin if not already done so
		var found = false;
		$("#plugins_management > tbody > tr").each(function()
		{
			var name = $(this).children().eq(0).text();
			if(name == "com.phonegap.plugins.pushplugin")
			{
				found = true;
			}
		});
		
		if(!found)
		{
			$('#plugins_management > tbody').append('<tr>' +
				'<td>com.phonegap.plugins.pushplugin</td>' +
				'<td>' +
					'<a class="button button-rounded button-primary" href="#plugins" onclick="editItem(this)"><i class="icon-cog"></i></a> ' + 
					'<a class="button button-rounded button-caution" href="#plugins" onclick="deleteItem(this)"><i class="icon-trash"></i></a>' +
				'</td>' +
				'<input type="hidden" name="plugins[com.phonegap.plugins.pushplugin]" value>' +
			'</tr>');
		}
	}
	else
	{
		// Disabled inputs
		$('#push_ios_certificate_button').addClass("disabled");
		$('#push_ios_privatekey_button').addClass("disabled");
		$('#push_ios_privatekey_password').attr("disabled", true);
		
		// Remove Push Notifications Plugin if iOS push is disabled too
		if(!$('#push_android_enable').is(':checked'))
		{
			$("#plugins_management > tbody > tr").each(function()
			{
				var name = $(this).children().eq(0).text();
				if(name == "com.phonegap.plugins.pushplugin")
				{
					$(this).remove();
				}
			});
		}
	}
}

function toggleStats()
{
	$("#stats_ga_enable").attr("checked", !$("#stats_ga_enable").attr("checked"));
	if($("#stats_ga_enable").attr('checked'))
	{
		// Enable inputs
		$('#stats_ga_accountid').attr("disabled", false);
		$('#stats_ga_accountuser').attr("disabled", false);
		$('#stats_ga_accountpass').attr("disabled", false);
		
		// Add Google Analytics Plugin if not already done so
		var found = false;
		$("#plugins_management > tbody > tr").each(function()
		{
			var name = $(this).children().eq(0).text();
			if(name == "com.adobe.plugins.gaplugin")
			{
				found = true;
			}
		});
		
		if(!found)
		{
			$('#plugins_management > tbody').append('<tr>' +
				'<td>com.adobe.plugins.gaplugin</td>' +
				'<td>' +
					'<a class="button button-rounded button-primary" href="#plugins" onclick="editItem(this)"><i class="icon-cog"></i></a> ' + 
					'<a class="button button-rounded button-caution" href="#plugins" onclick="deleteItem(this)"><i class="icon-trash"></i></a>' +
				'</td>' +
				'<input type="hidden" name="plugins[com.adobe.plugins.gaplugin]" value>' +
			'</tr>');
		}
	}
	else
	{
		// Disable inputs
		$('#stats_ga_accountid').attr("disabled", true);
		$('#stats_ga_accountuser').attr("disabled", true);
		$('#stats_ga_accountpass').attr("disabled", true);
		
		// Remove Google Analytics Plugin if overlay is disabled
		$("#plugins_management > tbody > tr").each(function()
		{
			var name = $(this).children().eq(0).text();
			if(name == "com.adobe.plugins.gaplugin")
			{
				$(this).remove();
			}
		});
	}
}

function toggleStatusbarstyle()
{
	$("#specific_ios_overlaystatusbar").attr("checked", !$("#specific_ios_overlaystatusbar").attr("checked"));
	if($("#specific_ios_overlaystatusbar").attr('checked'))
	{
		// Enable inputs
		$('#specific_ios_statusbarstyle').attr("disabled", false);
		$('#specific_ios_statusbarstyle').parent().attr("disabled", false);
		
		// Add Statusbar Plugin if not already done so
		var found = false;
		$("#plugins_management > tbody > tr").each(function()
		{
			var name = $(this).children().eq(0).text();
			if(name == "com.phonegap.plugin.statusbar")
			{
				found = true;
			}
		});
		
		if(!found)
		{
			$('#plugins_management > tbody').append('<tr>' +
				'<td>com.phonegap.plugin.statusbar</td>' +
				'<td>' +
					'<a class="button button-rounded button-primary" href="#plugins" onclick="editItem(this)"><i class="icon-cog"></i></a> ' + 
					'<a class="button button-rounded button-caution" href="#plugins" onclick="deleteItem(this)"><i class="icon-trash"></i></a>' +
				'</td>' +
				'<input type="hidden" name="plugins[com.phonegap.plugin.statusbar]" value>' +
			'</tr>');
		}
	}
	else
	{
		// Disable inputs
		$('#specific_ios_statusbarstyle').attr("disabled", true);
		$('#specific_ios_statusbarstyle').parent().attr("disabled", true);
		
		// Remove Statusbar Plugin if overlay is disabled
		$("#plugins_management > tbody > tr").each(function()
		{
			var name = $(this).children().eq(0).text();
			if(name == "com.phonegap.plugin.statusbar")
			{
				$(this).remove();
			}
		});
	}
}

function toggleAds()
{
	$("#ads_iads_enable").attr("checked", !$("#ads_iads_enable").attr("checked"));
	if($("#ads_iads_enable").attr('checked'))
	{
		// Enable inputs
		$('#ads_iads_position').attr("disabled", false);
		$('#ads_iads_position').parent().attr("disabled", false);
		
		// Add iAds Plugin if not already done so
		var found = false;
		$("#plugins_management > tbody > tr").each(function()
		{
			var name = $(this).children().eq(0).text();
			if(name == "com.rjfun.cordova.plugin.iad")
			{
				found = true;
			}
		});
		
		if(!found)
		{
			$('#plugins_management > tbody').append('<tr>' +
				'<td>com.rjfun.cordova.plugin.iad</td>' +
				'<td>' +
					'<a class="button button-rounded button-primary" href="#plugins" onclick="editItem(this)"><i class="icon-cog"></i></a> ' + 
					'<a class="button button-rounded button-caution" href="#plugins" onclick="deleteItem(this)"><i class="icon-trash"></i></a>' +
				'</td>' +
				'<input type="hidden" name="plugins[com.rjfun.cordova.plugin.iad]" value>' +
			'</tr>');
		}
	}
	else
	{
		// Disable inputs
		$('#ads_iads_position').attr("disabled", true);
		$('#ads_iads_position').parent().attr("disabled", true);
		
		// Remove iAds Plugin if disabled
		$("#plugins_management > tbody > tr").each(function()
		{
			var name = $(this).children().eq(0).text();
			if(name == "com.rjfun.cordova.plugin.iad")
			{
				$(this).remove();
			}
		});
	}
}

function checkUpdates()
{
	$.get('?page=dashboard&getupdatestatus', function(data)
	{
		if(data == "update_available")
		{
			$.get('?page=dashboard&getupdateinfo', function(data)
			{
				$('#update_content').empty().append(data);
				$('#update_content').append('<div class="divider"></div><a href="?page=dashboard&getupdate" class="button button-rounded button-primary"><i class="icon-cloud-download"></i> GET UPDATE</a>');
				window.location.hash = 'update';
			});
		}
	});
}

function getTemplateOptions(template, active_template)
{
	var templateid = template.value;
	var change = true;
	var old_value = $("#app_templateid").val();
	
	if(active_template != "")
	{
		if(!first_run)
		{
			if (confirm('Are you sure you want to change the template? You will lose advanced settings and current artwork.'))
			{
				change = true;
			}
			else
			{
				change = false;
				$("#app_templateid").val($.data(this, 'current'));
			}
		}
		$.data(this, 'current', $("#app_templateid").val());
		first_run = false;
	}
	
	if(change)
	{
		$("#loader").fadeIn();
		
		// Options
		$.get('./index.php?page=apps&data=options&templateid=' + templateid + '&edit=' + active_template, function(data)
		{
			$('#template_settings').empty().append(data).hide().fadeIn('slow');
			
			// Enable tooltips on options
			$('.fullwidth_tooltip').qtip(
			{
				hide:
				{
					fixed: true,
					delay: 200
				},
				style:
				{
					classes: 'qtip-tipsy qtip-shadow'
				},
				position:
				{
					my: 'bottom left',
					at: 'top right'
				}
			});
		});
		
		// Features
		$.get('./index.php?page=apps&data=features&templateid=' + templateid + '&edit=' + active_template, function(data)
		{
			$('#features_management > tbody').empty().append(data);
		});
		
		// Preferences
		$.get('./index.php?page=apps&data=preferences&templateid=' + templateid + '&edit=' + active_template, function(data)
		{
			$('#preferences_management > tbody').empty().append(data);
		});
		
		// Plugins
		$.get('./index.php?page=apps&data=plugins&templateid=' + templateid + '&edit=' + active_template, function(data)
		{
			$('#plugins_management > tbody').empty().append(data);
		});
		
		// Icons
		$.get('./index.php?page=apps&data=icons&templateid=' + templateid + '&edit=' + active_template, function(data)
		{
			$('#icons_management > tbody').empty().append(data);
		});
		
		// Splashscreens
		$.get('./index.php?page=apps&data=splashscreens&templateid=' + templateid + '&edit=' + active_template, function(data)
		{
			$('#splashscreen_management > tbody').empty().append(data);
			$("#loader").hide();
		});
	}
}

function previewImage(obj)
{
	var preffered_width = 0;
	var preffered_height = 0;
	var given_width = 0;
	var given_height = 0;
	
	if (obj.files && obj.files[0])
	{
		// Get Preffered width/height
		preffered_width = $(obj).parent().parent().find('img').attr('width');
		preffered_height = $(obj).parent().parent().find('img').attr('height');
		
		var reader = new FileReader();
		reader.onload = function(e)
		{
			// Get given width/height
			var image = new Image();
			image.src = e.target.result;
			image.onload = function()
			{
				given_width = this.width;
				given_height = this.height;
				
				// Check size
				if((preffered_width > given_width) || (preffered_height > given_height))
				{
					alert("The provided image is smaller then preffered size. It will be scaled up and the image quality will be lower.");
				}
				
				// Check ratio
				if((preffered_width/preffered_height) != (given_width/given_height))
				{
					alert("The provided image is in wrong proportions. It will be scaled.");
				}
								
				// Set preview
				$(obj).parent().parent().find('img').attr('src', e.target.result);
			}
        }
        reader.readAsDataURL(obj.files[0]);
		$(obj).parent().find('.remove_artwork').val('false');
    }
}

function deleteItem(obj)
{
	$(obj).parent().parent().remove();
	return false;
}

function editItem(obj)
{
	var old_name = $(obj).parent().parent().find('input').attr('name');
	var start_pos = old_name.indexOf('[') + 1;
	var end_pos = old_name.indexOf(']',start_pos);
	var name = old_name.substring(start_pos,end_pos);
	var value = $(obj).parent().parent().find('input').attr('value');
	var type = $(obj).parent().parent().parent().parent().attr('id');
	
	if(type == "features_management")
	{
		var type_name = "features";
	}
	if(type == "preferences_management")
	{
		var type_name = "preferences";
	}
	if(type == "plugins_management")
	{
		var type_name = "plugins";
	}

	if(type_name == "plugins")
	{
		$(obj).parent().parent().parent().parent().parent().next().empty().html('Edit:' +
		'<a class="right" href="#' + type_name + '" onClick="closeEdit(this, \'' + type_name + '\')">&times;</a>' +
		'<div class="field">' +
			'<label for="name">Name:</label>' +
			'<input type="text" id="name" name="name" value="' + name + '">' +
			'<input type="hidden" id="value" name="value" value="' + value + '">' +
			'<a href="#' + type_name + '" onClick="editItem2(this, \'' + type + '\', \'' + type_name + '\', \'' + name + '\', \'' + old_name + '\')" id="add-button" class="button button-rounded button-flat-action">' +
			'<i class="icon-plus"></i> EDIT</a>' +
		'</div>');
	}
	else
	{
		$(obj).parent().parent().parent().parent().parent().next().empty().html('Edit:' +
		'<a class="right" href="#' + type_name + '" onClick="closeEdit(this, \'' + type_name + '\')">&times;</a>' +
		'<div class="field">' +
			'<label for="name">Name:</label>' +
			'<label id="value-label" for="value">Value:</label>' +
			'<br><br>' +
			'<input type="text" id="name" name="name" value="' + name + '">' +
			'<input type="text" id="value" name="value" value="' + value + '">' +
			'<a href="#' + type_name + '" onClick="editItem2(this, \'' + type + '\', \'' + type_name + '\', \'' + name + '\', \'' + old_name + '\')" id="add-button" class="button button-rounded button-flat-action">' +
			'<i class="icon-plus"></i> EDIT</a>' +
		'</div>');
	}
}

function editItem2(obj, type, type_name, name, old_name)
{
	var new_name = $(obj).parent().find('input[name="name"]').val();
	var new_value = $(obj).parent().find('input[name="value"]').val();

	if(type_name == "plugins")
	{
		// Add
		$('#' + type + ' > tbody').find('input[name="' + old_name + '"]').parent().empty().html('<td>' + new_name + '</td>' +
					'<td>' +
						'<a class="button button-rounded button-primary" href="#' + type_name + '" onclick="editItem(this)"><i class="icon-cog"></i></a> ' + 
						'<a class="button button-rounded button-caution" href="#' + type_name + '" onclick="deleteItem(this)"><i class="icon-trash"></i></a>' +
					'</td>' +
					'<input type="hidden" name="' + type_name + '[' + new_name + ']" value="' + new_value + '">');
			
		// Close
		$(obj).parent().parent().empty().html('Add:' +
		'<div class="field">' +
			'<label for="name">Plugin:</label>' +
			'<input type="text" id="name" name="name">' +
			'<input type="hidden" id="value" name="value">' +
			'<a href="#' + type_name + '" onClick="addItem(this)" id="add-button" class="button button-rounded button-flat-action"><i class="icon-plus"></i> ADD</a>' +
		'</div>');
	}
	else
	{
		// Add
		$('#' + type + ' > tbody').find('input[name="' + old_name + '"]').parent().empty().html('<td>' + new_name + '</td>' +
					'<td>' + new_value + '</td>' +
					'<td>' +
						'<a class="button button-rounded button-primary" href="#' + type_name + '" onclick="editItem(this)"><i class="icon-cog"></i></a> ' + 
						'<a class="button button-rounded button-caution" href="#' + type_name + '" onclick="deleteItem(this)"><i class="icon-trash"></i></a>' +
					'</td>' +
					'<input type="hidden" name="' + type_name + '[' + new_name + ']" value="' + new_value + '">');
					
		// Close
		$(obj).parent().parent().empty().html('Add:' +
		'<div class="field">' +
			'<label for="name">Name:</label>' +
			'<label id="value-label" for="value">Value:</label>' +
			'<br><br>' +
			'<input type="text" id="name" name="name">' +
			'<input type="text" id="value" name="value">' +
			'<a href="#' + type_name + '" onClick="addItem(this)" id="add-button" class="button button-rounded button-flat-action"><i class="icon-plus"></i> ADD</a>' +
		'</div>');
	}
	
}

function closeEdit(obj, type_name)
{
	if(type_name == "plugins")
	{
		$(obj).parent().empty().html('Add:' +
		'<div class="field">' +
			'<label for="name">Plugin:</label>' +
			'<input type="text" id="name" name="name">' +
			'<input type="hidden" id="value" name="value">' +
			'<a href="#' + type_name + '" onClick="addItem(this)" id="add-button" class="button button-rounded button-flat-action"><i class="icon-plus"></i> ADD</a>' +
		'</div>');
	}
	else
	{
		$(obj).parent().empty().html('Add:' +
		'<div class="field">' +
			'<label for="name">Name:</label>' +
			'<label id="value-label" for="value">Value:</label>' +
			'<br><br>' +
			'<input type="text" id="name" name="name">' +
			'<input type="text" id="value" name="value">' +
			'<a href="#' + type_name + '" onClick="addItem(this)" id="add-button" class="button button-rounded button-flat-action"><i class="icon-plus"></i> ADD</a>' +
		'</div>');
	}
}

function addItem(obj)
{
	var name = $(obj).parent().find('input[name="name"]').val();
	var value = $(obj).parent().find('input[name="value"]').val();
	var type = $(obj).parent().parent().parent().parent().attr('id');

	if(type == "plugins")
	{
		$('#' + type + '_management > tbody').append('<tr>' +
			'<td>' + name + '</td>' +
			'<td>' +
				'<a class="button button-rounded button-primary" href="#' + type + '" onclick="editItem(this)"><i class="icon-cog"></i></a> ' + 
				'<a class="button button-rounded button-caution" href="#' + type + '" onclick="deleteItem(this)"><i class="icon-trash"></i></a>' +
			'</td>' +
			'<input type="hidden" name="' + type + '[' + name + ']" value="' + value + '">' +
		'</tr>');
	}
	else
	{
		$('#' + type + '_management > tbody').append('<tr>' +
			'<td>' + name + '</td>' +
			'<td>' + value + '</td>' +
			'<td>' +
				'<a class="button button-rounded button-primary" href="#' + type + '" onclick="editItem(this)"><i class="icon-cog"></i></a> ' + 
				'<a class="button button-rounded button-caution" href="#' + type + '" onclick="deleteItem(this)"><i class="icon-trash"></i></a>' +
			'</td>' +
			'<input type="hidden" name="' + type + '[' + name + ']" value="' + value + '">' +
		'</tr>');
		$(obj).parent().find('input[name="value"]').val("");
	}
	
	$(obj).parent().find('input[name="name"]').val("");
	$(obj).parent().parent().parent().find(".modal-content").animate({ scrollTop: $('.modal-content > table')[0].scrollHeight}, 1200);
}

function getDownloads(appid)
{
	$("#loader").fadeIn();
	$.get('./index.php?page=apps&data=downloads&appid=' + appid, function(data)
	{
		if(data == "limit")
		{
			if(confirm('It seems you\'ve reached your app limit at PhoneGap Build. Would you like BuildTool to delete your last app in the build queue at PhoneGap, and build this one? (Don\'t worry, you can rebuild your other apps whenever you want)'))
			{
				$.get('./index.php?page=apps&data=downloads&appid=' + appid + '&force', function(data)
				{
					$('#build_downloads').empty().append(data);
					window.location.hash = 'build';
					$("#loader").hide();
				});
			}
			else
			{
				$("#loader").hide();
			}
		}
		else
		{
			$('#build_downloads').empty().append(data);
			window.location.hash = 'build';
			$("#loader").hide();
		}
	});
}

function removeCert(platform)
{
	if(platform == "android")
	{
		$('input[name=android-certificate-title]').val('');
		$('input[name=android-certificate-alias]').val('');
		$('input[name=android-certificate-keypass]').val('');
		$('input[name=android-certificate-keystorepass]').val('');
		$('input[name=android-keystore-input]').val('');
		$('input[name=android-keystore]').val('');
	}
	
	if(platform == "ios")
	{
		$('input[name=ios-certificate-title]').val('');
		$('input[name=ios-certificate-pass]').val('');
		$('input[name=ios-p12-input]').val('');
		$('input[name=ios-p12]').val('');
		$('input[name=ios-provisioning-input]').val('');
		$('input[name=ios-provisioning]').val('');
	}
	
	if(platform == "blackberrry")
	{
		$('input[name=blackberry-certificate-title]').val('');
		$('input[name=blackberry-certificate-pass]').val('');
		$('input[name=blackberry-csk-input]').val('');
		$('input[name=blackberry-csk]').val('');
		$('input[name=blackberry-db-input]').val('');
		$('input[name=blackberry-db]').val('');
	}
	
	window.location.hash = '!';
}

function removeArtwork(obj)
{
	var artwork = $(obj).parent().parent().parent().parent().attr('id');
	
	if(artwork == "icons_management")
	{
		$(obj).parent().parent().find('img').attr('src', './assets/images/icons/default_icon.png');
	}
	else
	{
		$(obj).parent().parent().find('img').attr('src', './assets/images/icons/default_splash.png');
	}
	
	$(obj).parent().find('.remove_artwork').val('true');
}
