<?php
/* --------------------------------------------------------------------------------------------------- 
 * BuildTool - App Builder
 * 
 * @author	AppResponsive <http://robinbonnes.nl/>
 * @version	1.5
 *
 * Copyright (C) 2013 - 2014 AppResponsive. All rights reserved.
 * 
 * -------------------------------------------------------------------------------------------------- */

/* Check access */
if(!defined('access') or !access) die('This file cannot be directly accessed.');

class Detect
{
	var $apacheVersion;
	var $phpVersion;
	var $countErrors = 0;
	
	function hasApache()
	{
		if(isset($_SERVER["SERVER_SOFTWARE"]) && (preg_match( "!Apache/([a-z0-9\.]+)!ism", $_SERVER["SERVER_SOFTWARE"], $matches ) || strpos($_SERVER["SERVER_SOFTWARE"],'Apache') !== false))
		{
			if( isset($matches[1]) )
			{
				$this->apacheVersion = $matches[1];
			}
			else
			{
				$this->apacheVersion = $_SERVER["SERVER_SOFTWARE"];
			}
			
			return true;
		}
		
		$this->countErrors++;
		return false;
	}
	
	function hasPHP()
	{
		$this->phpVersion = phpversion();
		
		if(version_compare(PHP_VERSION, '5.1.9', '>'))
		{
			return true;
		}
		
		$this->countErrors++;
		return false;
	}
	
	function hasMySQL()
	{
		if(class_exists('PDO'))
		{
			return true;
		}
		
		$this->countErrors++;
		return false;
	}
	
	function hasGD()
	{
		if(in_array('gd', get_loaded_extensions() ) && function_exists("imagecreatefromjpeg") && function_exists("imagecreatefrompng") && function_exists("imagecreatefromgif"))
		{
			return true;
		}

		$this->countErrors++;
		return false;
	}
	
	function hasCURL()
	{
		if(function_exists("curl_version"))
		{
			return true;
		}
		
		$this->countErrors++;
		return false;
	}
	
	function checkWritable($path)
	{
		if(is_writable( $path ))
		{
			return true;
		}
		
		@chmod( $path, 0777 );
		
		if(is_writable( $path ))
		{
			return true;
		}
		
		$this->countErrors++;
		return false;
	}
}

?>