<?php

/* --------------------------------------------------------------------------------------------------- 
 * BuildTool - App Builder
 * 
 * @author	AppResponsive <http://robinbonnes.nl/>
 * @version	1.5
 *
 * Copyright (C) 2013 - 2014 AppResponsive. All rights reserved.
 * 
 * -------------------------------------------------------------------------------------------------- */

/* Check access */
if(!defined('access') or !access) die('This file cannot be directly accessed.');

class Template {

	/* Template File */
    protected $template;

	/* Constructor */
    public function __construct($template_name)
	{
		// Render Template
        if (!is_file(__TEMPLATE_DIR__ . $template_name))
		{
			//throw new FileNotFoundException("File not found: $template_name");
		}
		elseif (!is_readable(__TEMPLATE_DIR__ . $template_name))
		{
			//throw new IOException("Could not access: $template_name");
		}
		else
		{
			$this->template = __TEMPLATE_DIR__ . $template_name;
		}
    }
    
	/* Set data */
    public function set($var, $content)
	{
        $this->$var = $content;
    }
    
	/* Render / Output content on screen */
	public function render($output = true)
	{
		ob_start();
		require $this->template;
		$content = ob_get_clean();
		echo $content;
	}
	
	/* Parse content */
	public function parse()
	{
		ob_start();
		require $this->template;
		$content = ob_get_clean();
		return $content;
	}

}
?>