<?php

/* --------------------------------------------------------------------------------------------------- 
 * BuildTool - App Builder
 * 
 * @author	AppResponsive <http://robinbonnes.nl/>
 * @version	1.5
 *
 * Copyright (C) 2013 - 2014 AppResponsive. All rights reserved.
 * 
 * -------------------------------------------------------------------------------------------------- */

/* Check access */
if(!defined('access') or !access) die('This file cannot be directly accessed.');

class Apps {

	/* Database connection */
	private $db;
	
	/* Apps array */
	public $apps;
	
	/* Icons array */
	public $icons = array
	(
		// name, width, height, platform, density, role, src, state, show width/height
		array("Default", "57", "57", "", "", "", "", "", false),
		array("iPhone & iPod Touch non retina iOS6", "57", "57", "ios", "", "", "", "", true),
		array("iPad non retina iOS6", "72", "72", "ios", "", "", "", "", true),
		array("iPad non retina iOS7", "76", "76", "ios", "", "", "", "", true),
		array("iPhone & iPod Touch retina iOS6", "114", "114", "ios", "", "", "", "", true),
		array("iPhone & iPod Touch retina iOS7", "120", "120", "ios", "", "", "", "", true),
		array("iPad retina iOS6", "144", "144", "ios", "", "", "", "", true),
		array("iPad retina iOS7", "152", "152", "ios", "", "", "", "", true),
		array("Android LDPI", "36", "36", "android", "ldpi", "", "", "", false),
		array("Android MDPI", "48", "48", "android", "mdpi", "", "", "", false),
		array("Android HDPI", "72", "72", "android", "hdpi", "", "", "", false),
		array("Android XHDPI", "96", "96", "android", "xhdpi", "", "", "", false),
		array("Android XXHDPI", "144", "144", "android", "xxhdpi", "", "", "", false),
		array("Android XXXHDPI", "152", "152", "android", "xxxhdpi", "", "", "", false),
		array("Blackberry", "80", "80", "blackberry", "", "", "", "", false),
		array("Blackberry Hover", "80", "80", "blackberry", "", "", "", "hover", false),
		array("Windows Phone", "57", "57", "winphone", "", "", "", "", false),
		array("Windows Phone (Background tile)", "72", "72", "winphone", "", "background", "", "", false),
		array("Web OS", "64", "64", "webos", "", "", "", "", false),
		array("Web OS Mini", "32", "32", "webos", "", "mini", "", "", false)
	);
	
	/* Splashscreens array */
	public $splashscreens = array
	(
		// name, width, height, platform, density, src, show width/height
		array("Default (Portrait)", "320", "480", "", "", "", false),
		array("iPhone & iPod Touch non retina portrait", "320", "480", "ios", "", "", true),
		array("iPhone & iPod Touch retina 4- portrait", "640", "960", "ios", "", "", true),
		array("iPhone & iPod Touch retina 5+ portrait", "640", "1136", "ios", "", "", true),
		array("iPad portrait", "768", "1024", "ios", "", "", true),
		array("iPad retina portrait ", "1536", "2048", "ios", "", "", true),
		array("iPhone landscape", "480", "320", "ios", "", "", true),
		array("iPhone retina 4- landscape", "960", "640", "ios", "", "", true),
		array("iPhone retina 5+ landscape", "1136", "640", "ios", "", "", true),
		array("iPad landscape", "1024", "768", "ios", "", "", true),
		array("iPad retina landscape", "2048", "1536", "ios", "", "", true),
		array("Android Small", "200", "320", "android", "ldpi", "", false),
		array("Android Normal", "320", "480", "android", "mdpi", "", false),
		array("Android Large", "480", "800", "android", "hdpi", "", false),
		array("Android XLarge", "720", "1280", "android", "xhdpi", "", false),
		array("Blackberry (Portrait)", "640", "960", "blackberry", "", "", false),
		array("Windows Phone (Portrait)", "480", "800", "winphone", "", "", false)
	);
	
	/* Delete queue */
	public $deletequeue = array();
	
	/* Constructor */
	public function __construct()
	{		
		/* Assign Database */
		$this->db = Database::getInstance();
		
		/* Check if POST/GET is done. */
		$this->check();
		
		/* Show App Overview. */
		$this->showAppOverview();
	}
	
	/* Check if some post is done. */
	private function check()
	{
		if(isset($_GET['logout']))
		{
			// Destroy Session
			session_destroy();
			$host	=	"http://" . $_SERVER["HTTP_HOST"] . rtrim(dirname($_SERVER['PHP_SELF']), '/\\');
			header("Location: $host");
		}
		
		if(isset($_GET['data']))
		{
			if($_GET['data'] == "options")
			{
				$zip = new ZipArchive;

				if(isset($_GET['edit']) && $_GET['edit'] != "")
				{
					$this->db->prepare("SELECT * FROM apps WHERE id = ?");
					$this->db->bindParam(1, $_GET['edit']);
					$this->db->execute();
					$temp = $this->db->fetch();
					
					if($temp['app_templateid'] == $_GET['templateid'])
					{
						$res = $zip->open(__UPLOAD_DIR__ . "apps/" . $temp['app_identifier'] . ".zip");
					}
					else
					{
						$this->db->prepare("SELECT * FROM templates WHERE id = ?");
						$this->db->bindParam(1, $_GET['templateid']);
						$this->db->execute();
						$temp = $this->db->fetch();
						$res = $zip->open(__UPLOAD_DIR__ . "templates/" . $temp['template_package']);
					}
				}
				else
				{
					$this->db->prepare("SELECT * FROM templates WHERE id = ?");
					$this->db->bindParam(1, $_GET['templateid']);
					$this->db->execute();
					$temp = $this->db->fetch();
					$res = $zip->open(__UPLOAD_DIR__ . "templates/" . $temp['template_package']);
				}
			
				// Check content
				if($res === TRUE)
				{
					$xmlDoc = new DOMDocument('1.0', 'utf-8'); 
					$xmlDoc->formatOutput = true;
					$xmlDoc->preserveWhiteSpace = false;
					if(is_numeric($zip->locateName("www/config.xml")))
					{
						$xmlDoc->loadXML($zip->getFromName('www/config.xml'));
					}
					elseif(is_numeric($zip->locateName("config.xml")))
					{
						$xmlDoc->loadXML($zip->getFromName('config.xml'));
					}

					$elements = $xmlDoc->getElementsByTagName( "option" );
					
					if($elements->length > 0)
					{
						echo '<div class="divider"></div>';
						echo '<div class="message"><b>Template Settings</b><br><br>Please fill in the template options.</div>';
						echo '<div class="divider"></div>';
					}
					
					foreach( $elements as $element ) 
					{
						$option_name 		=	$element->getAttribute('name');
						$option_required 	=	$element->getAttribute('required');
						$option_type	 	=	$element->getAttribute('type');
						$option_value	 	=	$element->getAttribute('value');
						$option_tooltip		=	$element->getAttribute('tooltip');
						
						$div	=	'<div class="field">';
						
						if($option_required == "true")
						{
							$div 	.=	'<label class="fullwidth_label" for="' . $option_name . '">' . $option_name . '*:';
						}
						else
						{
							$div 	.=	'<label class="fullwidth_label" for="' . $option_name . '">' . $option_name . ':';
						}
					
						if(!empty($option_tooltip))
						{
							$div 	.=	'<a href="#" class="fullwidth_tooltip" title="' . $option_tooltip . '"><i class="icon-question-sign"></i></a>';
						}
						
						$div	.= '</label>';
						
						if($option_type == "textfield")
						{
							if($option_required == "true")
							{
								$div .= '<input type="text" class="required" id="' . $option_name . '" name="' . $option_name . '" value="' . $option_value . '">';
							}
							else
							{
								$div .= '<input type="text" id="' . $option_name . '" name="' . $option_name . '" value="' . $option_value . '">';
							}
						}
						if($option_type == "textarea")
						{
							if($option_required == "true")
							{
								$div .= '<textarea class="required" id="' . $option_name . '" name="' . $option_name . '">' . $option_value . '</textarea>';
							}
							else
							{
								$div .= '<textarea id="' . $option_name . '" name="' . $option_name . '">' . $option_value . '</textarea>';
							}
						}
						if($option_type == "select")
						{
							$option_options		=	$element->getAttribute('options');
							$div .= '<span class="dropdown"><select class="required" id="' . $option_name . '" name="' . $option_name . '">';
							
								$values = explode("|", $option_options);
								reset($values);
								foreach ($values as $option)
								{
									if($option == $option_value)
									{
										$div .= '<option value="' . $option .'" selected>' . $option .'</option>';
									}
									else
									{
										$div .= '<option value="' . $option .'">' . $option .'</option>';
									}
								}
								
							$div .= '</select></span>';
						}
						if($option_type == "checkbox")
						{
							if($option_value == "1")
							{
								$div .= '<div class="toggle fullwidth_toggle"><input type="checkbox" id="' . $option_name . '" name="' . $option_name . '" checked><b class="b switch"></b><b class="b track"></b></div>';
							}
							else
							{
								$div .= '<div class="toggle fullwidth_toggle"><input type="checkbox" id="' . $option_name . '" name="' . $option_name . '"/><b class="b switch"></b><b class="b track"></b></div>';
							}
						}

						$div .=	'</div>';
						
						echo $div;
					}
					$zip->close();
				}
			}
			
			// Features are not necessary (yet) in Phonegap Build	
			/* if($_GET['data'] == "features")
			{
				$zip = new ZipArchive;

				if(isset($_GET['edit']) && $_GET['edit'] != "")
				{
					$this->db->prepare("SELECT * FROM apps WHERE id = ?");
					$this->db->bindParam(1, $_GET['edit']);
					$this->db->execute();
					$temp = $this->db->fetch();
					
					if($temp['app_templateid'] == $_GET['templateid'])
					{
						$res = $zip->open(__UPLOAD_DIR__ . "apps/" . $temp['app_identifier'] . ".zip");
					}
					else
					{
						$this->db->prepare("SELECT * FROM templates WHERE id = ?");
						$this->db->bindParam(1, $_GET['templateid']);
						$this->db->execute();
						$temp = $this->db->fetch();
						$res = $zip->open(__UPLOAD_DIR__ . "templates/" . $temp['template_package']);
					}
				}
				else
				{
					$this->db->prepare("SELECT * FROM templates WHERE id = ?");
					$this->db->bindParam(1, $_GET['templateid']);
					$this->db->execute();
					$temp = $this->db->fetch();
					$res = $zip->open(__UPLOAD_DIR__ . "templates/" . $temp['template_package']);
				}
			
				// Check content
				if($res === TRUE)
				{
					$xmlDoc = new DOMDocument('1.0', 'utf-8'); 
					$xmlDoc->formatOutput = true;
					$xmlDoc->preserveWhiteSpace = false;
					if(is_numeric($zip->locateName("www/config.xml")))
					{
						$xmlDoc->loadXML($zip->getFromName('www/config.xml'));
					}
					elseif(is_numeric($zip->locateName("config.xml")))
					{
						$xmlDoc->loadXML($zip->getFromName('config.xml'));
					}

					$elements = $xmlDoc->getElementsByTagName("feature");
					
					if(!count($elements))
					{
						echo '<b>No features available for this template!</b>';
					}
					else
					{
						foreach( $elements as $element ) 
						{
							$child = $element->getElementsByTagName("param");
							if($child->length > 0)
							{
								if($child->item(0)->hasAttribute('value'))
								{
									$name 	=	$element->getAttribute('name');
									$value	=	$child->item(0)->getAttribute('value');
									$div	=	'<tr>';
									$div 	.=	'<td>' . $name . '</td>';
									$div	.=	'<td>' . $value . '</td>';
									$div	.=	'<td><a class="button button-rounded button-primary" href="#features" onClick="editItem(this)"><i class="icon-cog"></i></a> ';
									$div	.=	'<a class="button button-rounded button-caution" href="#features" onClick="deleteItem(this)"><i class="icon-trash"></i></a></td>';
									$div	.=	'<input type="hidden" name="features[' . $name . ']" value="' . $value . '">';
									$div	.=	'</tr>';
									echo $div;
								}
							}
						}
					}
					$zip->close();
				}
			} */
			
			if($_GET['data'] == "preferences")
			{
				$zip = new ZipArchive;

				if(isset($_GET['edit']) && $_GET['edit'] != "")
				{
					$this->db->prepare("SELECT * FROM apps WHERE id = ?");
					$this->db->bindParam(1, $_GET['edit']);
					$this->db->execute();
					$temp = $this->db->fetch();
					
					if($temp['app_templateid'] == $_GET['templateid'])
					{
						$res = $zip->open(__UPLOAD_DIR__ . "apps/" . $temp['app_identifier'] . ".zip");
					}
					else
					{
						$this->db->prepare("SELECT * FROM templates WHERE id = ?");
						$this->db->bindParam(1, $_GET['templateid']);
						$this->db->execute();
						$temp = $this->db->fetch();
						$res = $zip->open(__UPLOAD_DIR__ . "templates/" . $temp['template_package']);
					}
				}
				else
				{
					$this->db->prepare("SELECT * FROM templates WHERE id = ?");
					$this->db->bindParam(1, $_GET['templateid']);
					$this->db->execute();
					$temp = $this->db->fetch();
					$res = $zip->open(__UPLOAD_DIR__ . "templates/" . $temp['template_package']);
				}
			
				// Check content
				if($res === TRUE)
				{
					$xmlDoc = new DOMDocument('1.0', 'utf-8'); 
					$xmlDoc->formatOutput = true;
					$xmlDoc->preserveWhiteSpace = false;
					if(is_numeric($zip->locateName("www/config.xml")))
					{
						$xmlDoc->loadXML($zip->getFromName('www/config.xml'));
					}
					elseif(is_numeric($zip->locateName("config.xml")))
					{
						$xmlDoc->loadXML($zip->getFromName('config.xml'));
					}

					$elements = $xmlDoc->getElementsByTagName("preference");
					
					if(!count($elements))
					{
						echo '<b>No preferences available for this template!</b>';
					}
					else
					{
						foreach( $elements as $element ) 
						{
							if($element->hasAttribute('name') && $element->hasAttribute('value'))
							{
								$name 	=	$element->getAttribute('name');
								$value	=	$element->getAttribute('value');
								$div	=	'<tr>';
								$div 	.=	'<td>' . $name . '</td>';
								$div	.=	'<td>' . $value . '</td>';
								$div	.=	'<td><a class="button button-rounded button-primary" href="#preferences" onClick="editItem(this)"><i class="icon-cog"></i></a> ';
								$div	.=	'<a class="button button-rounded button-caution" href="#preferences" onClick="deleteItem(this)"><i class="icon-trash"></i></a></td>';
								$div	.=	'<input type="hidden" name="preferences[' . $name . ']" value="' . $value . '">';
								$div	.=	'</tr>';
								echo $div;
							}
						}
					}
					$zip->close();
				}
			}
			
			if($_GET['data'] == "plugins")
			{
				$zip = new ZipArchive;

				if(isset($_GET['edit']) && $_GET['edit'] != "")
				{
					$this->db->prepare("SELECT * FROM apps WHERE id = ?");
					$this->db->bindParam(1, $_GET['edit']);
					$this->db->execute();
					$temp = $this->db->fetch();
					
					if($temp['app_templateid'] == $_GET['templateid'])
					{
						$res = $zip->open(__UPLOAD_DIR__ . "apps/" . $temp['app_identifier'] . ".zip");
					}
					else
					{
						$this->db->prepare("SELECT * FROM templates WHERE id = ?");
						$this->db->bindParam(1, $_GET['templateid']);
						$this->db->execute();
						$temp = $this->db->fetch();
						$res = $zip->open(__UPLOAD_DIR__ . "templates/" . $temp['template_package']);
					}
				}
				else
				{
					$this->db->prepare("SELECT * FROM templates WHERE id = ?");
					$this->db->bindParam(1, $_GET['templateid']);
					$this->db->execute();
					$temp = $this->db->fetch();
					$res = $zip->open(__UPLOAD_DIR__ . "templates/" . $temp['template_package']);
				}
			
				// Check content
				if($res === TRUE)
				{
					$xmlDoc = new DOMDocument('1.0', 'utf-8');
					$xmlDoc->formatOutput = true;
					$xmlDoc->preserveWhiteSpace = false;
					if(is_numeric($zip->locateName("www/config.xml")))
					{
						$xmlDoc->loadXML($zip->getFromName('www/config.xml'));
					}
					elseif(is_numeric($zip->locateName("config.xml")))
					{
						$xmlDoc->loadXML($zip->getFromName('config.xml'));
					}

					$elements = $xmlDoc->getElementsByTagName("plugin");
					
					if(!count($elements))
					{
						echo '<b>No plugins available for this template!</b>';
					}
					else
					{
						foreach( $elements as $element ) 
						{
							if($element->hasAttribute('name'))
							{
								$name 	=	$element->getAttribute('name');
								$div	=	'<tr>';
								$div 	.=	'<td>' . $name . '</td>';
								$div	.=	'<td><a class="button button-rounded button-primary" href="#plugins" onClick="editItem(this)"><i class="icon-cog"></i></a> ';
								$div	.=	'<a class="button button-rounded button-caution" href="#plugins" onClick="deleteItem(this)"><i class="icon-trash"></i></a></td>';
								$div	.=	'<input type="hidden" name="plugins[' . $name . ']" value="">';
								$div	.=	'</tr>';
								echo $div;
							}
						}
					}
					$zip->close();
				}
			}
			
			if($_GET['data'] == "getimage")
			{
				$zip = new ZipArchive;

				if(isset($_GET['edit']) && $_GET['edit'] != "")
				{
					$this->db->prepare("SELECT * FROM apps WHERE id = ?");
					$this->db->bindParam(1, $_GET['edit']);
					$this->db->execute();
					$temp = $this->db->fetch();
					
					if($temp['app_templateid'] == $_GET['templateid'])
					{
						$res = $zip->open(__UPLOAD_DIR__ . "apps/" . $temp['app_identifier'] . ".zip");
					}
					else
					{
						$this->db->prepare("SELECT * FROM templates WHERE id = ?");
						$this->db->bindParam(1, $_GET['templateid']);
						$this->db->execute();
						$temp = $this->db->fetch();
						$res = $zip->open(__UPLOAD_DIR__ . "templates/" . $temp['template_package']);
					}
				}
				else
				{
					$this->db->prepare("SELECT * FROM templates WHERE id = ?");
					$this->db->bindParam(1, $_GET['templateid']);
					$this->db->execute();
					$temp = $this->db->fetch();
					$res = $zip->open(__UPLOAD_DIR__ . "templates/" . $temp['template_package']);
				}
				
				// Check content
				if($res === TRUE)
				{
					// Check if image exists in ziparchive
					$stat = $zip->statName($_GET['image']);
					$fp   = $zip->getStream($_GET['image']);
					$filetype = substr(strrchr($_GET['image'],'.'),1);
					
					if(!$fp)
					{
						$stat = $zip->statName(__ASSETS_DIR__ . 'images/icons/default_' . $_GET['type'] . '.png');
						$fp   = $zip->getStream(__ASSETS_DIR__ . 'images/icons/default_' . $_GET['type'] . '.png');
						$filetype = substr(strrchr($_GET['image'],'.'),1);
					}

					header('Content-Type: image/' . $filetype);
					header('Content-Length: ' . $stat['size']);
					fpassthru($fp);
				}
			}
			
			if($_GET['data'] == "icons")
			{
				$zip = new ZipArchive;

				if(isset($_GET['edit']) && $_GET['edit'] != "")
				{
					$this->db->prepare("SELECT * FROM apps WHERE id = ?");
					$this->db->bindParam(1, $_GET['edit']);
					$this->db->execute();
					$temp = $this->db->fetch();
					
					if($temp['app_templateid'] == $_GET['templateid'])
					{
						$res = $zip->open(__UPLOAD_DIR__ . "apps/" . $temp['app_identifier'] . ".zip");
					}
					else
					{
						$this->db->prepare("SELECT * FROM templates WHERE id = ?");
						$this->db->bindParam(1, $_GET['templateid']);
						$this->db->execute();
						$temp = $this->db->fetch();
						$res = $zip->open(__UPLOAD_DIR__ . "templates/" . $temp['template_package']);
					}
				}
				else
				{
					$this->db->prepare("SELECT * FROM templates WHERE id = ?");
					$this->db->bindParam(1, $_GET['templateid']);
					$this->db->execute();
					$temp = $this->db->fetch();
					$res = $zip->open(__UPLOAD_DIR__ . "templates/" . $temp['template_package']);
				}
			
				// Check content
				if($res === TRUE)
				{
					$xmlDoc = new DOMDocument('1.0', 'utf-8');
					$xmlDoc->formatOutput = true;
					$xmlDoc->preserveWhiteSpace = false;
					$location = "";
					
					if(is_numeric($zip->locateName("www/config.xml")))
					{
						$xmlDoc->loadXML($zip->getFromName('www/config.xml'));
						$location = "www/";
					}
					elseif(is_numeric($zip->locateName("config.xml")))
					{
						$xmlDoc->loadXML($zip->getFromName('config.xml'));
					}

					$elements = $xmlDoc->getElementsByTagName("icon");
					
					if(!count($elements))
					{
						foreach ($this->icons as $icondata)
						{
							$div = '<tr>';
							$div .= '<td><img src="assets/images/icons/default_icon.png" width="' . $icondata[1] . '" height="' . $icondata[2] . '"></td>';
							$div .= '<td>' . $icondata[0] . '</td>';
							$div .= '<td>' . $icondata[1] . 'x' . $icondata[2] . '</td>';
							$div .= '<td>';
							$div .= '<a onclick="removeArtwork(this)" class="remove_button button button-rounded button-flat-caution"><i class="icon-remove"></i></a>';
							$div .= '<input type="hidden" class="remove_artwork" id="icon-remove-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icondata[0]) . '" name="icon-remove-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icondata[0]) . '" value="false">';
							$div .= '<input type="file" accept="image/*" onchange="previewImage(this);" id="icon-input-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icondata[0]) . '" name="icon-input-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icondata[0]) . '" class="hidden">';
							$div .= '<a onclick="$(\'input[id=icon-input-' . preg_replace("/[^A-Za-z0-9-]+/", "-", $icondata[0]) . ']\').click();" class="upload_button button button-rounded button-flat-action"><i class="icon-upload"></i></a>';
							$div .= '</td>';
							$div .= '</tr>';
							echo $div;
						}
					}
					else
					{
						$config_icons = array();
						foreach( $elements as $element ) 
						{
							$src		=	$element->getAttribute('src');
							$width		=	$element->getAttribute('width');
							$height		=	$element->getAttribute('height');
							$platform	=	$element->getAttribute('gap:platform');
							$density	=	$element->getAttribute('gap:density');
							$role		=	$element->getAttribute('gap:role');
							$state		=	$element->getAttribute('gap:state');
							$config_icons[] = array("", $width, $height, $platform, $density, $role, $src, $state);
						}

						foreach($this->icons as $icon)
						{
							// Check if icon exists in config array
							$found = false;
							foreach($config_icons as $config_icon)
							{
								// Check if icon has width and height and platform
								if(!empty($icon[1]) && !empty($icon[2]) && !empty($icon[3]) && $icon[8])
								{
									// Check if matches on width and height and platform and role and state
									if($icon[1] == $config_icon[1] && $icon[2] == $config_icon[2] && $icon[3] == $config_icon[3] && $icon[5] == $config_icon[5] && $icon[7] == $config_icon[7])
									{
										$found = true;
									}
								}
								
								// Check if icon has platform and density
								else if(!empty($icon[4]) && !empty($icon[3]) && !$icon[8])
								{
									// Check if matches on density and platform and role and state
									if($icon[4] == $config_icon[4] && $icon[3] == $config_icon[3] && $icon[5] == $config_icon[5] && $icon[7] == $config_icon[7])
									{
										$found = true;
									}
								}
								
								// Check if icon has platform
								else if(!empty($icon[3]) && !$icon[8])
								{
									// Check if matches on platform and role and state
									if($icon[3] == $config_icon[3] && $icon[5] == $config_icon[5] && $icon[7] == $config_icon[7])
									{
										$found = true;
									}
								}
								
								// Check if icon is default
								else if(!empty($icon[1]) && !empty($icon[2]) && !$icon[8])
								{
									if(!empty($config_icon[6]))
									{
										$found = true;
									}
								}
								
								if($found)
								{
									$div = '<tr>';
									
									// Check if image exists in ziparchive
									$stat = $zip->statName($location . $config_icon[6]);
									$fp   = $zip->getStream($location . $config_icon[6]);
									$filetype = substr(strrchr($config_icon[6],'.'),1);
									
									if(!$fp)
									{
										$div .= '<td><img src="assets/images/icons/default_icon.png" width="' . $icon[1] . '" height="' . $icon[2] . '"></td>';
									}
									else
									{
										$div .= '<td><img src="./index.php?page=apps&data=getimage&edit=' . $_GET['edit'] . '&templateid=' . $_GET['templateid'] . '&image=' . $location . $config_icon[6] . '&type=splash" width="' . $icon[1] . '" height="' . $icon[2] . '"></td>';
									}
									
									$div .= '<td>' . $icon[0] . '</td>';
									$div .= '<td>' . $icon[1] . 'x' . $icon[2] . '</td>';
									$div .= '<td>';
									$div .= '<a onclick="removeArtwork(this)" class="remove_button button button-rounded button-flat-caution"><i class="icon-remove"></i></a>';
									$div .= '<input type="hidden" class="remove_artwork" id="icon-remove-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icon[0]) . '" name="icon-remove-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icon[0]) . '" value="false">';
									$div .= '<input type="file" accept="image/*" onchange="previewImage(this);" id="icon-input-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icon[0]) . '" name="icon-input-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icon[0]) . '" class="hidden">';
									$div .= '<a onclick="$(\'input[id=icon-input-' . preg_replace("/[^A-Za-z0-9-]+/", "-", $icon[0]) . ']\').click();" class="upload_button button button-rounded button-flat-action"><i class="icon-upload"></i></a>';
									$div .= '</td>';
									$div .= '</tr>';
									echo $div;
									break;
								}
							}

							if(!$found)
							{
								$div = '<tr>';
								$div .= '<td><img src="assets/images/icons/default_icon.png" width="' . $icon[1] . '" height="' . $icon[2] . '"></td>';
								$div .= '<td>' . $icon[0] . '</td>';
								$div .= '<td>' . $icon[1] . 'x' . $icon[2] . '</td>';
								$div .= '<td>';
								$div .= '<a onclick="removeArtwork(this)" class="remove_button button button-rounded button-flat-caution"><i class="icon-remove"></i></a>';
								$div .= '<input type="hidden" class="remove_artwork" id="icon-remove-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icon[0]) . '" name="icon-remove-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icon[0]) . '" value="false">';
								$div .= '<input type="file" accept="image/*" onchange="previewImage(this);" id="icon-input-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icon[0]) . '" name="icon-input-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icon[0]) . '" class="hidden">';
								$div .= '<a onclick="$(\'input[id=icon-input-' . preg_replace("/[^A-Za-z0-9-]+/", "-", $icon[0]) . ']\').click();" class="upload_button button button-rounded button-flat-action"><i class="icon-upload"></i></a>';
								$div .= '</td>';
								$div .= '</tr>';
								echo $div;
							}
						}
					}
					$zip->close();
				}
			}
			
			if($_GET['data'] == "splashscreens")
			{
				$zip = new ZipArchive;

				if(isset($_GET['edit']) && $_GET['edit'] != "")
				{
					$this->db->prepare("SELECT * FROM apps WHERE id = ?");
					$this->db->bindParam(1, $_GET['edit']);
					$this->db->execute();
					$temp = $this->db->fetch();
					
					if($temp['app_templateid'] == $_GET['templateid'])
					{
						$res = $zip->open(__UPLOAD_DIR__ . "apps/" . $temp['app_identifier'] . ".zip");
					}
					else
					{
						$this->db->prepare("SELECT * FROM templates WHERE id = ?");
						$this->db->bindParam(1, $_GET['templateid']);
						$this->db->execute();
						$temp = $this->db->fetch();
						$res = $zip->open(__UPLOAD_DIR__ . "templates/" . $temp['template_package']);
					}
				}
				else
				{
					$this->db->prepare("SELECT * FROM templates WHERE id = ?");
					$this->db->bindParam(1, $_GET['templateid']);
					$this->db->execute();
					$temp = $this->db->fetch();
					$res = $zip->open(__UPLOAD_DIR__ . "templates/" . $temp['template_package']);
				}
			
				// Check content
				if($res === TRUE)
				{
					$xmlDoc = new DOMDocument('1.0', 'utf-8');
					$xmlDoc->formatOutput = true;
					$xmlDoc->preserveWhiteSpace = false;
					$location = "";
					
					if(is_numeric($zip->locateName("www/config.xml")))
					{
						$xmlDoc->loadXML($zip->getFromName('www/config.xml'));
						$location = "www/";
					}
					elseif(is_numeric($zip->locateName("config.xml")))
					{
						$xmlDoc->loadXML($zip->getFromName('config.xml'));
					}

					$elements = $xmlDoc->getElementsByTagName("splash");
					
					if(!count($elements))
					{
						foreach ($this->splashscreens as $splashdata)
						{
							if($splashdata[1] > $splashdata[2])
							{
								$splashimage = "default_splash_landscape.png";
							}
							else
							{
								$splashimage = "default_splash.png";
							}
							
							$div = '<tr>';
							$div .= '<td><img src="assets/images/icons/' . $splashimage . '" width="' . $splashdata[1]/10 . '" height="' . $splashdata[2]/10 . '"></td>';
							$div .= '<td>' . $splashdata[0] . '</td>';
							$div .= '<td>' . $splashdata[1] . 'x' . $splashdata[2] . '</td>';
							$div .= '<td>';
							$div .= '<a onclick="removeArtwork(this)" class="remove_button button button-rounded button-flat-caution"><i class="icon-remove"></i></a>';
							$div .= '<input type="hidden" class="remove_artwork" id="splash-remove-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splashdata[0]) . '" name="splash-remove-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splashdata[0]) . '" value="false">';
							$div .= '<input type="file" accept="image/*" onchange="previewImage(this);" id="splash-input-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splashdata[0]) . '" name="icon-input-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splashdata[0]) . '" class="hidden">';
							$div .= '<a onclick="$(\'input[id=splash-input-' . preg_replace("/[^A-Za-z0-9-]+/", "-", $splashdata[0]) . ']\').click();" class="upload_button button button-rounded button-flat-action"><i class="icon-upload"></i></a>';
							$div .= '</td>';
							$div .= '</tr>';
							echo $div;
						}
					}
					else
					{
						$config_splashscreens = array();
						foreach( $elements as $element ) 
						{
							$src		=	$element->getAttribute('src');
							$width		=	$element->getAttribute('width');
							$height		=	$element->getAttribute('height');
							$platform	=	$element->getAttribute('gap:platform');
							$density	=	$element->getAttribute('gap:density');
							$config_splashscreens[] = array("", $width, $height, $platform, $density, $src);
						}

						foreach($this->splashscreens as $splash)
						{
							// Check if splash exists in config array
							$found = false;
							
							if($splash[1] > $splash[2])
							{
								$splashimage = "default_splash_landscape.png";
							}
							else
							{
								$splashimage = "default_splash.png";
							}
							
							foreach($config_splashscreens as $config_splash)
							{	
								// Check if splash has width and height and platform
								if(!empty($splash[1]) && !empty($splash[2]) && !empty($splash[3]) && $splash[6])
								{
									// Check if matches on width and height and platform
									if($splash[1] == $config_splash[1] && $splash[2] == $config_splash[2] && $splash[3] == $config_splash[3])
									{
										$found = true;
									}
								}
								
								// Check if splash has platform and density
								else if(!empty($splash[4]) && !empty($splash[3]) && !$splash[6])
								{
									// Check if matches on density and platform
									if($splash[4] == $config_splash[4] && $splash[3] == $config_splash[3])
									{
										$found = true;
									}
								}
								
								// Check if splash has platform
								else if(!empty($splash[3]) && !$splash[6])
								{
									// Check if matches on platform
									if($splash[3] == $config_splash[3])
									{
										$found = true;
									}
								}
								
								// Check if splash is default
								else if(!empty($splash[1]) && !empty($splash[2]) && !$splash[6])
								{
									if(!empty($config_splash[5]))
									{
										$found = true;
									}
								}
								
								if($found)
								{
									$div = '<tr>';
									
									// Check if image exists in ziparchive
									$stat = $zip->statName($location . $config_splash[5]);
									$fp   = $zip->getStream($location . $config_splash[5]);
									$filetype = substr(strrchr($config_splash[5],'.'),1);
									
									if(!$fp)
									{
										$div .= '<td><img src="assets/images/icons/' . $splashimage .'" width="' . $splash[1]/10 . '" height="' . $splash[2]/10 . '"></td>';
									}
									else
									{
										$div .= '<td><img src="./index.php?page=apps&data=getimage&edit=' . $_GET['edit'] . '&templateid=' . $_GET['templateid'] . '&image=' . $location . $config_splash[5] . '&type=icon" width="' . $splash[1]/10 . '" height="' . $splash[2]/10 . '"></td>';
									}
									
									$div .= '<td>' . $splash[0] . '</td>';
									$div .= '<td>' . $splash[1] . 'x' . $splash[2] . '</td>';
									$div .= '<td>';
									$div .= '<a onclick="removeArtwork(this)" class="remove_button button button-rounded button-flat-caution"><i class="icon-remove"></i></a>';
									$div .= '<input type="hidden" class="remove_artwork" id="splash-remove-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splash[0]) . '" name="splash-remove-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splash[0]) . '" value="false">';
									$div .= '<input type="file" accept="image/*" onchange="previewImage(this);" id="splash-input-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splash[0]) . '" name="splash-input-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splash[0]) . '" class="hidden">';
									$div .= '<a onclick="$(\'input[id=splash-input-' . preg_replace("/[^A-Za-z0-9-]+/", "-", $splash[0]) . ']\').click();" class="upload_button button button-rounded button-flat-action"><i class="icon-upload"></i></a>';
									$div .= '</td>';
									$div .= '</tr>';
									echo $div;
									break;
								}
							}

							if(!$found)
							{
								$div = '<tr>';
								$div .= '<td><img src="assets/images/icons/' . $splashimage . '" width="' . $splash[1]/10 . '" height="' . $splash[2]/10 . '"></td>';
								$div .= '<td>' . $splash[0] . '</td>';
								$div .= '<td>' . $splash[1] . 'x' . $splash[2] . '</td>';
								$div .= '<td>';
								$div .= '<a onclick="removeArtwork(this)" class="remove_button button button-rounded button-flat-caution"><i class="icon-remove"></i></a>';
								$div .= '<input type="hidden" class="remove_artwork" id="splash-remove-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splash[0]) . '" name="splash-remove-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splash[0]) . '" value="false">';
								$div .= '<input type="file" accept="image/*" onchange="previewImage(this);" id="splash-input-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splash[0]) . '" name="splash-input-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splash[0]) . '" class="hidden">';
								$div .= '<a onclick="$(\'input[id=splash-input-' . preg_replace("/[^A-Za-z0-9-]+/", "-", $splash[0]) . ']\').click();" class="upload_button button button-rounded button-flat-action"><i class="icon-upload"></i></a>';
								$div .= '</td>';
								$div .= '</tr>';
								echo $div;
							}
						}
					}
					$zip->close();
				}
			}
			
			if($_GET['data'] == "downloads")
			{
				if(isset($_GET['appid']) && $_GET['appid'] != "")
				{
					// Get User Settings
					$this->db->prepare("SELECT * FROM users WHERE username = ?");
					$this->db->bindParam(1, $_SESSION['user']);
					$this->db->execute();
					$user = $this->db->fetch();
					$username = $user['username'];
					$user_email = $user['email'];
					$user_id = $user['id'];
					$user_type = $user['type'];
					
					// Get App ID
					$this->db->prepare("SELECT * FROM apps WHERE id = ?");
					$this->db->bindParam(1, $_GET['appid']);
					$this->db->execute();
					$app = $this->db->fetch();
				
					// Get PhoneGap Settings
					$this->db->prepare("SELECT * FROM settings");
					$this->db->execute();
					$settings = $this->db->fetchAll();
					include(__CLASSES_DIR__ . 'phonegap.class.php');
					
					$phonegap_token = "";
					$phonegap_username = "";
					$phonegap_password = "";
					
					foreach($settings as $setting )
					{
						if($setting['setting'] == "phonegap_token")
						{
							$phonegap_token = $setting['value'];
						}
						if($setting['setting'] == "phonegap_username")
						{
							$phonegap_username = $setting['value'];
						}	
						if($setting['setting'] == "phonegap_password")
						{
							$phonegap_password = $setting['value'];
						}						
					}
					
					// Login
					if(!empty($phonegap_token))
					{
						$phonegap = new Phonegap($phonegap_token);
					}
					else
					{
						$phonegap = new Phonegap($phonegap_username, $phonegap_password);
					}

					$login = $phonegap->checkLogin();
					$debug = $app['app_debug'];
					
					if(isset($_GET['force']))
					{
						$force = true;
					}
					else
					{
						$force = false;
					}
					$active_appid = "";
					$div = "<table>\r\n<thead>\r\n<tr>\r\n<th>OS</th>\r\n<th>Status</th>\r\n<th>Action</th>\r\n</tr>\r\n</thead>\r\n<tbody>\r\n";
					
					// Check login
					if($login)
					{
						// Upload iOS Certificate					
						if(file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_ios_certificate_p12.p12") && file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_ios_certificate_provisioning.mobileprovision"))
						{						
							$p12_file = __UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_ios_certificate_p12.p12";
							$prov_file = __UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_ios_certificate_provisioning.mobileprovision";
							$title = $app['ios_cert_title'];
							$password = $app['ios_cert_password'];
							$phonegap->uploadIOSCertificate($p12_file, $prov_file, $title, $password);
						}
						
						// Upload Android Certificate
						if(file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_android_certificate_keystore.keystore") && !$debug)
						{
							$keystore_file = __UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_android_certificate_keystore.keystore";
							$title = $app['android_cert_title'];
							$alias = $app['android_cert_alias'];
							$key_pw = $app['android_cert_keypass'];
							$keystore_pw = $app['android_cert_keystorepass'];
							$phonegap->uploadAndroidCertificate($keystore_file, $title, $alias, $key_pw, $keystore_pw);
						}
						
						// Upload BlackBerry Certificate
						if(file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_blackberry_certificate_csk.csk") && file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_blackberry_certificate_db.db"))
						{
							$db_file = __UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_blackberry_certificate_db.db";
							$csk_file = __UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_blackberry_certificate_csk.csk";
							$title = $app['blackberry_cert_title'];
							$password = $app['blackberry_cert_pass'];
							$phonegap->uploadBlackBerryCertificate($db_file, $csk_file, $title, $password);
						}
						
						// Upload app
						$active_appid = $phonegap->uploadApp(__UPLOAD_DIR__ . "apps/" . $app['app_identifier'] . ".zip", $app['app_identifier'], $app['app_name'], $debug, $force);

						if(!empty($active_appid))
						{
							// Check if limit is reached
							if($active_appid == "limit")
							{
								// Show warning for admins
								if($user_type == "admin")
								{
									die("limit");
								}
								else
								{
									// Suppress warning for clients and force download
									$active_appid = $phonegap->uploadApp(__UPLOAD_DIR__ . "apps/" . $app['app_identifier'] . ".zip", $app['app_identifier'], $app['app_name'], $debug, true);
								}
							}
							
							// iOS
							if(file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_ios_certificate_p12.p12") && file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_ios_certificate_provisioning.mobileprovision"))
							{
								$div .= '<tr id="download_ios">';
								$div .= '<td>iOS</td>';
								$link = $phonegap->getDownloadLink($active_appid, "ios");
								if(!empty($link))
								{
									$div .= '<td>Ready for download.</td>';
									$div .= '<td><a class="button button-rounded button-primary build_button" href="' . $link . '"><i class="icon-download"></i> Download</a>';
								}
								else
								{
									$div .= '<td>Download unavailable.</td>';
									$div .= '<td><a class="button button-rounded button-primary build_button disabled" href="#build">Unavailable</a></td>';
								}
								$div .= '</tr>';
							}
							else
							{
								$div .= '<tr id="download_ios">';
								$div .= '<td>iOS</td>';
								$div .= '<td>Provide certificates.</td>';
								$div .= '<td><a class="button button-rounded button-primary build_button" href="?page=apps&amp;action=edit&amp;id=' . $_GET['appid'] . '#ios-certificates"><i class="icon-cog"></i> Edit</a></td>';
								$div .= '</tr>';
							}

							// Android
							if(file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_android_certificate_keystore.keystore") || $debug)
							{
								$div .= '<tr id="download_android">';
								$div .= '<td>Android</td>';
								$link = $phonegap->getDownloadLink($active_appid, "android");
								if(!empty($link))
								{
									if($debug)
									{
										$div .= '<td>Ready for download (Debug Mode).</td>';
									}
									else
									{
										$div .= '<td>Ready for download.</td>';
									}
									$div .= '<td><a class="button button-rounded button-primary build_button" href="' . $link . '"><i class="icon-download"></i> Download</a>';
								}
								else
								{
									$div .= '<td>Download unavailable.</td>';
									$div .= '<td><a class="button button-rounded button-primary build_button disabled" href="#build">Unavailable</a></td>';
								}
								$div .= '</tr>';
							}
							else
							{
								$div .= '<tr id="download_android">';
								$div .= '<td>Android</td>';
								$div .= '<td>Provide certificates or enable app debug.</td>';
								$div .= '<td><a class="button button-rounded button-primary build_button" href="?page=apps&amp;action=edit&amp;id=' . $_GET['appid'] . '#android-certificates"><i class="icon-cog"></i> Edit</a></td>';
								$div .= '</tr>';
							}

							// BlackBerry
							if(file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_blackberry_certificate_csk.csk") && file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_blackberry_certificate_db.db"))
							{
								$div .= '<tr id="download_blackberry">';
								$div .= '<td>BlackBerry</td>';
								$link = $phonegap->getDownloadLink($active_appid, "blackberry");
								if(!empty($link))
								{
									$div .= '<td>Ready for download.</td>';
									$div .= '<td><a class="button button-rounded button-primary build_button" href="' . $link . '"><i class="icon-download"></i> Download</a>';
								}
								else
								{
									$div .= '<td>Download unavailable.</td>';
									$div .= '<td><a class="button button-rounded button-primary build_button disabled" href="#build">Unavailable</a></td>';
								}
								$div .= '</tr>';
							}
							else
							{
								$div .= '<tr id="download_blackberry">';
								$div .= '<td>BlackBerry</td>';
								$div .= '<td>Provide certificates.</td>';
								$div .= '<td><a class="button button-rounded button-primary build_button" href="?page=apps&amp;action=edit&amp;id=' . $_GET['appid'] . '#blackberry-certificates"><i class="icon-cog"></i> Edit</a></td>';
								$div .= '</tr>';
							}
							
							// Windows Phone
							$div .= '<tr id="download_winphone">';
							$div .= '<td>Windows Phone</td>';
							$link = $phonegap->getDownloadLink($active_appid, "winphone");
							if(!empty($link))
							{
								$div .= '<td>Ready for download.</td>';
								$div .= '<td><a class="button button-rounded button-primary build_button" href="' . $link . '"><i class="icon-download"></i> Download</a>';
							}
							else
							{
								$div .= '<td>Download unavailable.</td>';
								$div .= '<td><a class="button button-rounded button-primary build_button disabled" href="#build">Unavailable</a></td>';
							}
							$div .= '</tr>';
							
							// Web OS
							$div .= '<tr id="download_webos">';
							$div .= '<td>Web OS</td>';
							$link = $phonegap->getDownloadLink($active_appid, "webos");
							if(!empty($link))
							{
								$div .= '<td>Ready for download.</td>';
								$div .= '<td><a class="button button-rounded button-primary build_button" href="' . $link . '"><i class="icon-download"></i> Download</a>';
							}
							else
							{
								$div .= '<td>Download unavailable.</td>';
								$div .= '<td><a class="button button-rounded button-primary build_button disabled" href="#build">Unavailable</a></td>';
							}
							$div .= '</tr>';
								
							// Symbian
							$div .= '<tr id="download_symbian">';
							$div .= '<td>Symbian</td>';
							$link = $phonegap->getDownloadLink($active_appid, "symbian");
							if(!empty($link))
							{
								$div .= '<td>Ready for download.</td>';
								$div .= '<td><a class="button button-rounded button-primary build_button" href="' . $link . '"><i class="icon-download"></i> Download</a>';
							}
							else
							{
								$div .= '<td>Download unavailable.</td>';
								$div .= '<td><a class="button button-rounded button-primary build_button disabled" href="#build">Unavailable</a></td>';
							}
							$div .= '</tr></tbody></table>';
							
							echo $div;
						}
						else
						{
							echo "No downloads available. Wrong upload.";
						}
					}
					else
					{
						echo "Please provide correct Phonegap login details.";
					}
				}
				else
				{
					echo "No downloads available.";
				}
			}
			die();
		}
				
		// Do action
		if(isset($_GET['action']))
		{
			// Get user
			$this->db->prepare("SELECT * FROM users WHERE username = ?");
			$this->db->bindParam(1, $_SESSION['user']);
			$this->db->execute();
			$user = $this->db->fetch();
			$user_id = $user['id'];
			$user_type = $user['type'];
			
			// Create new app
			if($_GET['action'] == "new")
			{				
				// Check app
				if(isset($_POST['app_name']))
				{
					// Get templates
					$this->db->prepare("SELECT * FROM templates");
					$this->db->execute();
					$templates = $this->db->fetchAll();

					if(file_exists(__UPLOAD_DIR__ . "apps/" . $_POST['app_identifier'] . ".zip"))
					{
						$header = new Template("header.tpl.php");
						$header->set("title", "BuildTool - New App");
						$header->set("subtitle", "Create a new app.");
						$footer = new Template("footer.tpl.php");
						$body = new Template("app_new.tpl.php");
						$body->set("templates", $templates);
						$body = new Template("app_new.tpl.php");
						$body->set("error", "ERROR: App already exists! Change your bundle identifier.");
						$body->set("header", $header->parse());
						$body->set("footer", $footer->parse());
						$body->set("username", $_SESSION["user"]);
						$body->render();
					}
					else
					{
						/* Way to handle new:
							- Set certificates and add to database
							- Copy template and open zip
							- Set Changes
						*/
						
						// Add to database
						$this->db->prepare("INSERT INTO apps(
												clientid,
												app_name,
												app_description,
												app_version,
												app_versioncode,
												app_identifier,
												app_templateid,
												app_debug,
												android_cert_title,
												android_cert_alias,
												android_cert_keypass,
												android_cert_keystorepass,
												ios_cert_title,
												ios_cert_password,
												blackberry_cert_title,
												blackberry_cert_pass,
												push_android_enabled,
												push_android_apikey,
												push_ios_enabled,
												push_ios_keypass,
												push_ios_devmode,
												stats_enabled,
												stats_accountid
											) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
						
						$this->db->bindParam(1, $user_id);
						$this->db->bindParam(2, $_POST['app_name']);
						$this->db->bindParam(3, $_POST['app_description']);
						$this->db->bindParam(4, $_POST['app_version']);
						$this->db->bindParam(5, $_POST['app_versioncode']);
						$this->db->bindParam(6, $_POST['app_identifier']);
						$this->db->bindParam(7, $_POST['app_templateid']);
						
						if(isset($_POST['app_debug']))
						{
							$this->db->bindParam(8, "1");
						}
						else
						{
							$this->db->bindParam(8, "0");
						}
						
						// Set Android Certificates
						if(empty($_POST['android-keystore']))
						{
							$this->db->bindParam(9, '');
							$this->db->bindParam(10, '');
							$this->db->bindParam(11, '');
							$this->db->bindParam(12, '');
							if(file_exists(__UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_android_certificate_keystore.keystore"))
							{
								@unlink(__UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_android_certificate_keystore.keystore");
							}
						}
						else if(isset($_FILES['android-keystore-input']))
						{
							if(isset($_POST['android-certificate-title']))
							{
								$this->db->bindParam(9, $_POST['android-certificate-title']);
							}
							if(isset($_POST['android-certificate-alias']))
							{
								$this->db->bindParam(10, $_POST['android-certificate-alias']);
							}
							if(isset($_POST['android-certificate-keypass']))
							{
								$this->db->bindParam(11, $_POST['android-certificate-keypass']);
							}
							if(isset($_POST['android-certificate-keystorepass']))
							{
								$this->db->bindParam(12, $_POST['android-certificate-keystorepass']);
							}
							if($_FILES['android-keystore-input']["error"] == UPLOAD_ERR_OK)
							{
								$certfile = __UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_android_certificate_keystore.keystore";
								move_uploaded_file($_FILES['android-keystore-input']['tmp_name'], $certfile);
							}
						}
								
						// Set iOS Certificates
						if(empty($_POST['ios-p12']) && empty($_POST['ios-provisioning']))
						{
							$this->db->bindParam(13, '');
							$this->db->bindParam(14, '');
							if(file_exists(__UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_ios_certificate_p12.p12"))
							{
								@unlink(__UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_ios_certificate_p12.p12");
							}
							if(file_exists(__UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_ios_certificate_provisioning.mobileprovision"))
							{
								@unlink(__UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_ios_certificate_provisioning.mobileprovision");
							}
						}
						else if(isset($_FILES['ios-p12-input']) && isset($_FILES['ios-provisioning-input']))
						{
							if(isset($_POST['ios-certificate-title']))
							{
								$this->db->bindParam(13, $_POST['ios-certificate-title']);
							}
							if(isset($_POST['ios-certificate-pass']))
							{
								$this->db->bindParam(14, $_POST['ios-certificate-pass']);
							}
							if($_FILES['ios-p12-input']["error"] == UPLOAD_ERR_OK)
							{
								$certfile = __UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_ios_certificate_p12.p12";
								move_uploaded_file($_FILES['ios-p12-input']['tmp_name'], $certfile);
							}
							if($_FILES['ios-provisioning-input']["error"] == UPLOAD_ERR_OK)
							{
								$certfile = __UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_ios_certificate_provisioning.mobileprovision";
								move_uploaded_file($_FILES['ios-provisioning-input']['tmp_name'], $certfile);
							}
						}
										
						// Set BlackBerry Certificates
						if(empty($_POST['blackberry-csk']) && empty($_POST['blackberry-db']))
						{
							$this->db->bindParam(15, '');
							$this->db->bindParam(16, '');
							if(file_exists(__UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_blackberry_certificate_csk.csk"))
							{
								@unlink(__UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_blackberry_certificate_csk.csk");
							}

							if(file_exists(__UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_blackberry_certificate_db.db"))
							{
								@unlink(__UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_blackberry_certificate_db.db");
							}
						}
						else if(isset($_FILES['blackberry-csk-input']) && isset($_FILES['blackberry-db-input']))
						{
							if(isset($_POST['blackberry-certificate-title']))
							{
								$this->db->bindParam(15, $_POST['blackberry-certificate-title']);
							}
							if(isset($_POST['blackberry-certificate-pass']))
							{
								$this->db->bindParam(16, $_POST['blackberry-certificate-pass']);
							}
							if($_FILES['blackberry-csk-input']["error"] == UPLOAD_ERR_OK)
							{
								$certfile = __UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_blackberry_certificate_csk.csk";
								move_uploaded_file($_FILES['blackberry-csk-input']['tmp_name'], $certfile);
							}
							if($_FILES['blackberry-db-input']["error"] == UPLOAD_ERR_OK)
							{
								$certfile = __UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_blackberry_certificate_db.db";
								move_uploaded_file($_FILES['blackberry-db-input']['tmp_name'], $certfile);
							}
						}
						
						if(isset($_POST['push_android_enable']))
						{
							$this->db->bindParam(17, 1);
						}
						else
						{
							$this->db->bindParam(17, 0);
						}
						
						if(isset($_POST['push_android_apikey']))
						{
							$this->db->bindParam(18, $_POST['push_android_apikey']);
						}
						else
						{
							$this->db->bindParam(18, '');
						}
						
						if(isset($_POST['push_ios_enable']))
						{
							$this->db->bindParam(19, 1);
						}
						else
						{
							$this->db->bindParam(19, 0);
						}
						
						if(isset($_POST['push_ios_privatekey_password']))
						{
							$this->db->bindParam(20, $_POST['push_ios_privatekey_password']);
						}
						else
						{
							$this->db->bindParam(20, '');
						}
						
						if(isset($_POST['push_ios_developmentmode']))
						{
							$this->db->bindParam(21, 1);
						}
						else
						{
							$this->db->bindParam(21, 0);
						}
						
						if(isset($_POST['stats_ga_enable']))
						{
							$this->db->bindParam(22, 1);
						}
						else
						{
							$this->db->bindParam(22, 0);
						}
						
						if(isset($_POST['stats_ga_accountid']))
						{
							$this->db->bindParam(23, $_POST['stats_ga_accountid']);
						}
						else
						{
							$this->db->bindParam(23, '');
						}

						$this->db->execute();
						
						// Locate Template
						$this->db->prepare("SELECT * FROM templates WHERE id = ?");
						$this->db->bindParam(1, $_POST['app_templateid']);
						$this->db->execute();
						$template = $this->db->fetch();

						// Copy Template to App Directory
						@copy(__UPLOAD_DIR__ . "templates/" . $template['template_package'], __UPLOAD_DIR__ . "apps/" . $_POST['app_identifier'] . ".zip");
						
						// Set Changed elements
						$this->setChanges();
					
						// Start output
						$header = new Template("header.tpl.php");
						$header->set("title", "BuildTool - Apps Overview");
						$header->set("subtitle", "Overview of your apps.");
						$footer = new Template("footer.tpl.php");
						$body = new Template("apps.tpl.php");
						$body->set("success", "App succesfully created!");
						$this->getApps();
						$body->set("apps", $this->apps);
						$body->set("header", $header->parse());
						$body->set("footer", $footer->parse());
						$body->set("username", $_SESSION["user"]);
						$body->render();
					}
				}
				else
				{
					// Get templates
					$this->db->prepare("SELECT * FROM templates");
					$this->db->execute();
					$templates = $this->db->fetchAll();
				
					$header = new Template("header.tpl.php");
					$header->set("title", "BuildTool - New App");
					$header->set("subtitle", "Create a new app.");
					$footer = new Template("footer.tpl.php");
					$body = new Template("app_new.tpl.php");
					$body->set("templates", $templates);
					$body->set("icons", $this->icons);
					$body->set("splashscreens", $this->splashscreens);
					$body->set("header", $header->parse());
					$body->set("footer", $footer->parse());
					$body->set("username", $_SESSION["user"]);
					$body->render();
				}
			}
			
			// Edit app
			else if($_GET['action'] == "edit")
			{
				// Check app
				if(isset($_POST['app_name']))
				{
					// Get templates
					$this->db->prepare("SELECT * FROM templates");
					$this->db->execute();
					$templates = $this->db->fetchAll();
				
					/* Way to handle edit:
						- Check Bundle Identifier change
						- Check Template change
						- Update Database settings and certificates
						- Set Changes
					*/
					
					// Get old app info
					$this->db->prepare("SELECT * FROM apps WHERE id = ?");
					$this->db->bindParam(1, $_GET['id']);
					$this->db->execute();
					$app = $this->db->fetch();

					// Check if user is allowed to edit app
					if($user_type == "client")
					{
						if($app['clientid'] != $user_id)
						{
							// Not allowed
							$this->showAppOverview();
						}
					}
					
					// Check if bundle identifier has changed
					if($_POST['app_identifier'] != $app['app_identifier'])
					{
						if(file_exists(__UPLOAD_DIR__ . "apps/" . $_POST['app_identifier'] . ".zip"))
						{
							// Output
							$header = new Template("header.tpl.php");
							$header->set("title", "BuildTool - Apps Overview");
							$header->set("subtitle", "Overview of your apps.");
							$footer = new Template("footer.tpl.php");
							$body = new Template("apps.tpl.php");
							$body->set("error", "App Identifier already exists. Remove the old app or change the app identifier!");
							$this->getApps();
							$body->set("apps", $this->apps);
							$body->set("header", $header->parse());
							$body->set("footer", $footer->parse());
							$body->set("username", $_SESSION["user"]);
							$body->render();
							die();
						}
						else
						{
							// Rename package
							@rename(__UPLOAD_DIR__ . "apps/" . $app['app_identifier'] . ".zip", __UPLOAD_DIR__ . "apps/" . $_POST['app_identifier'] . ".zip");
							
							// Rename certificates if exist
							if(file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_android_certificate_keystore.keystore"))
							{
								@rename(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_android_certificate_keystore.keystore", __UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_android_certificate_keystore.keystore");
							}
							if(file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_ios_certificate_p12.p12"))
							{
								@rename(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_ios_certificate_p12.p12", __UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_ios_certificate_p12.p12");
							}
							if(file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_ios_certificate_provisioning.mobileprovision"))
							{
								@rename(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_ios_certificate_provisioning.mobileprovision", __UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_ios_certificate_provisioning.mobileprovision");
							}
							if(file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_blackberry_certificate_csk.csk"))
							{
								@rename(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_blackberry_certificate_csk.csk", __UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_blackberry_certificate_csk.csk");
							}
							if(file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_blackberry_certificate_db.db"))
							{
								@rename(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_blackberry_certificate_db.db", __UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_blackberry_certificate_db.db");
							}
						}
					}
					
					// Check if template has changed
					if($_POST['app_templateid'] != $app['app_templateid'])
					{
						// Remove package (Artwork, and advanced settings will be lost)
						@unlink(__UPLOAD_DIR__ . "apps/" . $_POST['app_identifier'] . ".zip");
						
						// Get new template
						$this->db->prepare("SELECT * FROM templates WHERE id = ?");
						$this->db->bindParam(1, $_POST['app_templateid']);
						$this->db->execute();
						$template = $this->db->fetch();
						@copy(__UPLOAD_DIR__ . "templates/" . $template['template_package'], __UPLOAD_DIR__ . "apps/" . $_POST['app_identifier'] . ".zip");
					}

					// Update in database
					$this->db->prepare("UPDATE apps SET
											app_name = ?,
											app_description = ?,
											app_version = ?,
											app_versioncode = ?,
											app_identifier = ?,
											app_templateid = ?,
											app_debug = ?,
											android_cert_title = ?,
											android_cert_alias = ?,
											android_cert_keypass = ?,
											android_cert_keystorepass = ?,
											ios_cert_title = ?,
											ios_cert_password = ?,
											blackberry_cert_title = ?,
											blackberry_cert_pass = ?,
											push_android_enabled = ?,
											push_android_apikey = ?,
											push_ios_enabled = ?,
											push_ios_keypass = ?,
											push_ios_devmode = ?,
											stats_enabled = ?,
											stats_accountid = ?
											WHERE id = ?");

					$this->db->bindParam(1, $_POST['app_name']);
					$this->db->bindParam(2, $_POST['app_description']);
					$this->db->bindParam(3, $_POST['app_version']);
					$this->db->bindParam(4, $_POST['app_versioncode']);
					$this->db->bindParam(5, $_POST['app_identifier']);
					$this->db->bindParam(6, $_POST['app_templateid']);

					if(isset($_POST['app_debug']))
					{
						$this->db->bindParam(7, "1");
					}
					else
					{
						$this->db->bindParam(7, "0");
					}
					
					// Set Android Certificates
					if(empty($_POST['android-keystore']))
					{
						
						$this->db->bindParam(8, '');
						$this->db->bindParam(9, '');
						$this->db->bindParam(10, '');
						$this->db->bindParam(11, '');
						if(file_exists(__UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_android_certificate_keystore.keystore"))
						{
							@unlink(__UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_android_certificate_keystore.keystore");
						}
					}
					else if(isset($_FILES['android-keystore-input']))
					{
						if(isset($_POST['android-certificate-title']))
						{
							$this->db->bindParam(8, $_POST['android-certificate-title']);
						}
						if(isset($_POST['android-certificate-alias']))
						{
							$this->db->bindParam(9, $_POST['android-certificate-alias']);
						}
						if(isset($_POST['android-certificate-keypass']))
						{
							$this->db->bindParam(10, $_POST['android-certificate-keypass']);
						}
						if(isset($_POST['android-certificate-keystorepass']))
						{
							$this->db->bindParam(11, $_POST['android-certificate-keystorepass']);
						}
						if($_FILES['android-keystore-input']["error"] == UPLOAD_ERR_OK)
						{
							$certfile = __UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_android_certificate_keystore.keystore";
							move_uploaded_file($_FILES['android-keystore-input']['tmp_name'], $certfile);
						}
					}
										
					// Set iOS Certificates
					if(empty($_POST['ios-p12']) && empty($_POST['ios-provisioning']))
					{
						$this->db->bindParam(12, '');
						$this->db->bindParam(13, '');
						if(file_exists(__UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_ios_certificate_p12.p12"))
						{
							@unlink(__UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_ios_certificate_p12.p12");
						}
						if(file_exists(__UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_ios_certificate_provisioning.mobileprovision"))
						{
							@unlink(__UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_ios_certificate_provisioning.mobileprovision");
						}
					}
					else if(isset($_FILES['ios-p12-input']) && isset($_FILES['ios-provisioning-input']))
					{
						if(isset($_POST['ios-certificate-title']))
						{
							$this->db->bindParam(12, $_POST['ios-certificate-title']);
						}
						if(isset($_POST['ios-certificate-pass']))
						{
							$this->db->bindParam(13, $_POST['ios-certificate-pass']);
						}
						if($_FILES['ios-p12-input']["error"] == UPLOAD_ERR_OK)
						{
							$certfile = __UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_ios_certificate_p12.p12";
							move_uploaded_file($_FILES['ios-p12-input']['tmp_name'], $certfile);
						}
						if($_FILES['ios-provisioning-input']["error"] == UPLOAD_ERR_OK)
						{
							$certfile = __UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_ios_certificate_provisioning.mobileprovision";
							move_uploaded_file($_FILES['ios-provisioning-input']['tmp_name'], $certfile);
						}
					}

					// Set BlackBerry Certificates
					if(empty($_POST['blackberry-csk']) && empty($_POST['blackberry-db']))
					{
						$this->db->bindParam(14, '');
						$this->db->bindParam(15, '');
						if(file_exists(__UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_blackberry_certificate_csk.csk"))
						{
							@unlink(__UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_blackberry_certificate_csk.csk");
						}

						if(file_exists(__UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_blackberry_certificate_db.db"))
						{
							@unlink(__UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_blackberry_certificate_db.db");
						}
					}
					else if(isset($_FILES['blackberry-csk-input']) && isset($_FILES['blackberry-db-input']))
					{
						if(isset($_POST['blackberry-certificate-title']))
						{
							$this->db->bindParam(14, $_POST['blackberry-certificate-title']);
						}
						if(isset($_POST['blackberry-certificate-pass']))
						{
							$this->db->bindParam(15, $_POST['blackberry-certificate-pass']);
						}
						if($_FILES['blackberry-csk-input']["error"] == UPLOAD_ERR_OK)
						{
							$certfile = __UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_blackberry_certificate_csk.csk";
							move_uploaded_file($_FILES['blackberry-csk-input']['tmp_name'], $certfile);
						}
						if($_FILES['blackberry-db-input']["error"] == UPLOAD_ERR_OK)
						{
							$certfile = __UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_blackberry_certificate_db.db";
							move_uploaded_file($_FILES['blackberry-db-input']['tmp_name'], $certfile);
						}
					}

					if(isset($_POST['push_android_enable']))
					{
						$this->db->bindParam(16, 1);
					}
					else
					{
						$this->db->bindParam(16, 0);
					}
					
					if(isset($_POST['push_android_apikey']))
					{
						$this->db->bindParam(17, $_POST['push_android_apikey']);
					}
					else
					{
						$this->db->bindParam(17, '');
					}
					
					if(isset($_POST['push_ios_enable']))
					{
						$this->db->bindParam(18, 1);
					}
					else
					{
						$this->db->bindParam(18, 0);
					}
					
					if(isset($_POST['push_ios_privatekey_password']))
					{
						$this->db->bindParam(19, $_POST['push_ios_privatekey_password']);
					}
					else
					{
						$this->db->bindParam(19, '');
					}
					
					if(isset($_POST['push_ios_developmentmode']))
					{
						$this->db->bindParam(20, 1);
					}
					else
					{
						$this->db->bindParam(20, 0);
					}
					
					if(isset($_POST['stats_ga_enable']))
					{
						$this->db->bindParam(21, 1);
					}
					else
					{
						$this->db->bindParam(21, 0);
					}
					
					if(isset($_POST['stats_ga_accountid']))
					{
						$this->db->bindParam(22, $_POST['stats_ga_accountid']);
					}
					else
					{
						$this->db->bindParam(22, '');
					}

					$this->db->bindParam(23, $_GET['id']);
					$this->db->execute();			

					// Set changed elements
					$this->setChanges();
				
					// Output
					$header = new Template("header.tpl.php");
					$header->set("title", "BuildTool - Apps Overview");
					$header->set("subtitle", "Overview of your apps.");
					$footer = new Template("footer.tpl.php");
					$body = new Template("apps.tpl.php");
					$body->set("success", "App succesfully edited!");
					$this->getApps();
					$body->set("apps", $this->apps);
					$body->set("header", $header->parse());
					$body->set("footer", $footer->parse());
					$body->set("username", $_SESSION["user"]);
					$body->render();
				}
				else
				{
					if(isset($_GET['id']))
					{
						$this->db->prepare("SELECT * FROM apps WHERE id = ?");
						$this->db->bindParam(1, $_GET['id']);
						$this->db->execute();
						$app = $this->db->fetch();
					
						$debug = "";
						if($app['app_debug'] == "1")
						{
							$debug = "checked";
						}
						
						// Get templates
						$this->db->prepare("SELECT * FROM templates");
						$this->db->execute();
						$templates = $this->db->fetchAll();
					
						// Get certificates
						if(file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_android_certificate_keystore.keystore"))
						{
							$android_certificate_keystore = $app['app_identifier'] . "_android_certificate_keystore.keystore";
						}
						else
						{
							$android_certificate_keystore = "";
						}
						if(file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_ios_certificate_p12.p12"))
						{
							$ios_certificate_p12 = $app['app_identifier'] . "_ios_certificate_p12.p12";
						}
						else
						{
							$ios_certificate_p12 = "";
						}
						if(file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_ios_certificate_provisioning.mobileprovision"))
						{
							$ios_certificate_provisioning = $app['app_identifier'] . "_ios_certificate_provisioning.mobileprovision";
						}
						else
						{
							$ios_certificate_provisioning = "";
						}
						if(file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_blackberry_certificate_csk.csk"))
						{
							$blackberry_certificate_csk = $app['app_identifier'] . "_blackberry_certificate_csk.csk";
						}
						else
						{
							$blackberry_certificate_csk = "";
						}
						if(file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_blackberry_certificate_db.db"))
						{
							$blackberry_certificate_db = $app['app_identifier'] . "_blackberry_certificate_db.db";
						}
						else
						{
							$blackberry_certificate_db = "";
						}
						
						$header = new Template("header.tpl.php");
						$header->set("title", "BuildTool - Edit App");
						$header->set("subtitle", "Edit this app.");
						$footer = new Template("footer.tpl.php");
						$body = new Template("app_edit.tpl.php");
						$body->set("templates", $templates);
						$body->set("app_id", $app['id']);
						$body->set("app_name", $app['app_name']);
						$body->set("app_identifier", $app['app_identifier']);
						$body->set("app_description", $app['app_description']);
						$body->set("app_templateid", $app['app_templateid']);
						$body->set("app_version", $app['app_version']);
						$body->set("app_versioncode", $app['app_versioncode']);
						$body->set("app_debug", $debug);
						$body->set("android_certificate_title", $app['android_cert_title']);
						$body->set("android_certificate_alias", $app['android_cert_alias']);
						$body->set("android_certificate_keypass", $app['android_cert_keypass']);
						$body->set("android_certificate_keystorepass", $app['android_cert_keystorepass']);
						$body->set("android_certificate_keystore", $android_certificate_keystore);
						$body->set("ios_certificate_title", $app['ios_cert_title']);
						$body->set("ios_certificate_pass", $app['ios_cert_password']);
						$body->set("ios_certificate_p12", $ios_certificate_p12);
						$body->set("ios_certificate_provisioningprofile", $ios_certificate_provisioning);
						$body->set("blackberry_certificate_title", $app['blackberry_cert_title']);
						$body->set("blackberry_certificate_pass", $app['blackberry_cert_pass']);
						$body->set("blackberry_certificate_csk", $blackberry_certificate_csk);
						$body->set("blackberry_certificate_db", $blackberry_certificate_db);
						$body->set("push_android_enabled", $app['push_android_enabled']);
						$body->set("push_android_apikey", $app['push_android_apikey']);
						$body->set("push_ios_enabled", $app['push_ios_enabled']);
						$body->set("push_ios_keypass", $app['push_ios_keypass']);
						$body->set("push_ios_devmode", $app['push_ios_devmode']);
						$body->set("stats_enabled", $app['stats_enabled']);
						$body->set("stats_accountid", $app['stats_accountid']);
						$body->set("header", $header->parse());
						$body->set("footer", $footer->parse());
						$body->set("username", $_SESSION["user"]);
						$zip = new ZipArchive;
						$res = $zip->open(__UPLOAD_DIR__ . "apps/" . $app['app_identifier'] . ".zip");
	
						// Check content
						if($res === TRUE)
						{
							$xmlDoc = new DOMDocument('1.0', 'utf-8'); 
							$xmlDoc->formatOutput = true;
							$xmlDoc->preserveWhiteSpace = false;
							if(is_numeric($zip->locateName("www/config.xml")))
							{
								$xmlDoc->loadXML($zip->getFromName('www/config.xml'));
							}
							elseif(is_numeric($zip->locateName("config.xml")))
							{
								$xmlDoc->loadXML($zip->getFromName('config.xml'));
							}

							$elements = $xmlDoc->getElementsByTagName( "bt_extra" );
							foreach( $elements as $element ) 
							{
								$name 		=	$element->getAttribute('setting');
								$value	 	=	$element->getAttribute('value');
								$body->set($name, $value);
							}
						}
						
						$certpath = __UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_ios_push_certificate.cer";
						if(file_exists($certpath))
						{
							$body->set("push_ios_certificate", $certpath);
						}
						
						$privatekeypath = __UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_ios_push_privatekey.pem";
						if(file_exists($privatekeypath))
						{
							$body->set("push_ios_privatekey", $privatekeypath);
						}
						
						$body->render();
					}
					else
					{
						$header = new Template("header.tpl.php");
						$header->set("title", "BuildTool - Apps Overview");
						$header->set("subtitle", "Overview of your apps.");
						$footer = new Template("footer.tpl.php");
						$body = new Template("apps.tpl.php");
						$body->set("error", "ERROR: Please specify an app id.");
						$this->getApps();
						$body->set("apps", $this->apps);
						$body->set("header", $header->parse());
						$body->set("footer", $footer->parse());
						$body->set("username", $_SESSION["user"]);
						$body->render();	
					}
				}
			}
			
			// Delete app
			else if($_GET['action'] == "delete")
			{
				// Get app info by id
				$this->db->prepare("SELECT * FROM apps WHERE id = ?");
				$this->db->bindParam(1, $_GET['id']);
				$this->db->execute();
				$app = $this->db->fetch();
				
				// Check if user is allowed to delete app
				if($user_type == "client")
				{
					if($app['clientid'] != $user_id)
					{
						// Not allowed
						$this->showAppOverview();
					}
				}
				
				// Remove from database
				$this->db->prepare("DELETE FROM apps WHERE id = ?");
				$this->db->bindParam(1, $_GET['id']);
				$this->db->execute();
				
				// Delete files
				@unlink(__UPLOAD_DIR__ . "apps/" . $app['app_identifier'] . ".zip");
				if(file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_android_certificate_keystore.keystore"))
				{
					@unlink(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_android_certificate_keystore.keystore");
				}
				
				if(file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_ios_certificate_p12.p12"))
				{
					@unlink(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_ios_certificate_p12.p12");
				}

				if(file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_ios_certificate_provisioning.mobileprovision"))
				{
					@unlink(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_ios_certificate_provisioning.mobileprovision");
				}

				if(file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_blackberry_certificate_csk.csk"))
				{
					@unlink(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_blackberry_certificate_csk.csk");
				}

				if(file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_blackberry_certificate_db.db"))
				{
					@unlink(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_blackberry_certificate_db.db");
				}

				// Output
				$header = new Template("header.tpl.php");
				$header->set("title", "BuildTool - Apps Overview");
				$header->set("subtitle", "Overview of your apps.");
				$footer = new Template("footer.tpl.php");
				$body = new Template("apps.tpl.php");
				$body->set("success", "App <b>" . $app['app_name'] . "</b> succesfully deleted!");
				$this->getApps();
				$body->set("apps", $this->apps);
				$body->set("header", $header->parse());
				$body->set("footer", $footer->parse());
				$body->set("username", $_SESSION["user"]);
				$body->render();
			}
			
			// Manage Push Notifications
			else if($_GET['action'] == "push")
			{
				// Get app info by id
				$this->db->prepare("SELECT * FROM apps WHERE id = ?");
				$this->db->bindParam(1, $_GET['id']);
				$this->db->execute();
				$app = $this->db->fetch();
				
				if($app)
				{
					// Check if user is allowed to send push notifications for this app
					if($user_type == "client")
					{
						if($app['clientid'] != $user_id)
						{
							// Not allowed
							$this->showAppOverview();
						}
					}
					
					if(isset($_POST['push_message']))
					{
						$error = "";
						
						// Check if PEM file exists
						if($app['push_ios_enabled'] == 1)
						{
							if(!file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_ios_push_pem.pem"))
							{
								if(!file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_ios_push_certificate.cer"))
								{
									$error = ".cer file not found. Read the documentation about how to create the .cer file.";
								}
								elseif(!file_exists(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_ios_push_privatekey.pem"))
								{
									$error = ".pem file not found. First upload a private key in pem format (Read the documentation about how to convert from p12 to pem) and try again.";
								}
								else
								{
									// PEM file doesn't exist, so we have to create it from .cer and .pem
									$certificatePEM =  '-----BEGIN CERTIFICATE-----'.PHP_EOL
									.chunk_split(base64_encode(file_get_contents(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_ios_push_certificate.cer")), 64, PHP_EOL)
									.'-----END CERTIFICATE-----'.PHP_EOL;
									$privatePEM = file_get_contents(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_ios_push_privatekey.pem");
									@file_put_contents(__UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_ios_push_pem.pem", $certificatePEM . $privatePEM);
								}
							}
						}
						
						// The message to send
						$message = $_POST['push_message'];
						
						if(empty($message))
						{
							$error = "Please enter a message to send";
						}
						else
						{
							// Get Android devices
							$this->db->prepare("SELECT * FROM push_devices WHERE app_id = ? AND os = ?");
							$this->db->bindParam(1, $_GET['id']);
							$this->db->bindParam(2, "android");
							$this->db->execute();
							$android_devices = $this->db->fetchAll();

							// Get iOS devices
							$this->db->prepare("SELECT * FROM push_devices WHERE app_id = ? AND os = ?");
							$this->db->bindParam(1, $_GET['id']);
							$this->db->bindParam(2, "ios");
							$this->db->execute();
							$ios_devices = $this->db->fetchAll();
							
							$count_android = count($android_devices);
							$count_ios = count($ios_devices);
							$send_android = 0;
							$send_ios = 0;
							
							// Send to Android devices
							if($count_android > 0 && $app['push_android_enabled'] == 1)
							{
								$devices = array();
								foreach($android_devices as $android)
								{
									array_push($devices, $android['device_id']);
								}
								
								$url = 'https://android.googleapis.com/gcm/send';
								$count = 0;
								
								for($i = 0; $i<count($devices); $i++)
								{
									// Send per 1000
									if($count + 1000 == $i)
									{
										$ids = array_slice($devices, $i, $i + 1000);
										$fields = array(
														'registration_ids'  => $ids,
														'data'              => array("message" => $message,
																					  "title" => $app['app_name'],
																					  "msgcnt" => 1)
														);
										$headers = array( 
															'Authorization: key=' . $app['push_android_apikey'],
															'Content-Type: application/json'
														);
										// Send out
										$ch = curl_init();
										curl_setopt( $ch, CURLOPT_URL, $url );
										curl_setopt( $ch, CURLOPT_POST, true );
										curl_setopt( $ch, CURLOPT_HTTPHEADER, $headers);
										curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
										curl_setopt( $ch, CURLOPT_POSTFIELDS, json_encode( $fields ) );
										$result = curl_exec($ch);

										$count = $count + 1000;
									}
									
									// Send last part
									if($i + 1 == count($devices))
									{
										$rest = $i + 1 - $count;
										$ids = array_slice($devices, $i + 1 - $rest, count($devices));
										$fields = array(
														'registration_ids'  => $ids,
														'data'              => array( "message" => $message,
																					  "title" => $app['app_name'],
																					  "msgcnt" => 1)
														);
										$headers = array( 
															'Authorization: key=' . $app['push_android_apikey'],
															'Content-Type: application/json'
														);

										// Send out
										$ch = curl_init();
										curl_setopt( $ch, CURLOPT_URL, $url );
										curl_setopt( $ch, CURLOPT_POST, true );
										curl_setopt( $ch, CURLOPT_HTTPHEADER, $headers);
										curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
										curl_setopt( $ch, CURLOPT_POSTFIELDS, json_encode( $fields ) );
										$result = curl_exec($ch);
									}
								}
								curl_close($ch);
							}
							
							// Send to iOS devices
							if($count_ios > 0 && $app['push_ios_enabled'] == 1)
							{
								if(empty($error))
								{
									$ctx = stream_context_create();
									stream_context_set_option($ctx, 'ssl', 'local_cert', __UPLOAD_DIR__ . "certificates/" . $app['app_identifier'] . "_ios_push_pem.pem");
									stream_context_set_option($ctx, 'ssl', 'passphrase', $app['push_ios_keypass']);
									 
									// Connect with APNS server
									if($app['push_ios_devmode'] == 1)
									{
										$fp = stream_socket_client('ssl://gateway.sandbox.push.apple.com:2195', $err, $errstr, 60, STREAM_CLIENT_CONNECT|STREAM_CLIENT_PERSISTENT, $ctx);
									}
									else
									{
										$fp = stream_socket_client('ssl://gateway.push.apple.com:2195', $err, $errstr, 60, STREAM_CLIENT_CONNECT|STREAM_CLIENT_PERSISTENT, $ctx);
									}
									
									if(!$fp)
									{
										$error = "Can't connect with the APNS Push Server";
									}
									else
									{
										// Payload
										$body['aps'] = array(
											'alert' => $message,
											'badge' => 1,
											'sound' => 'default',
											);
										 
										// Encode to JSON
										$payload = json_encode($body);
										$error = false;
										foreach($ios_devices as $ios)
										{
											// Create binary message
											$msg = chr(0) . pack('n', 32) . pack('H*', $ios['id']) . pack('n', strlen($payload)) . $payload;
											 
											// Send out
											$resultaat = fwrite($fp, $msg, strlen($msg));
										}

										// close connection
										fclose($fp);
									}
								}
							}
						}

						if(!empty($error))
						{
							// Error occurred
							$header = new Template("header.tpl.php");
							$header->set("title", "BuildTool - Push Notifications");
							$header->set("subtitle", "Send out a push notification.");
							$footer = new Template("footer.tpl.php");
							$body = new Template("push_notification.tpl.php");
							$body->set("header", $header->parse());
							$body->set("footer", $footer->parse());
							$body->set("error", $error);
							$body->set("username", $_SESSION["user"]);
							$body->render();
						}
						else
						{
							// Notifications sent!
							$header = new Template("header.tpl.php");
							$header->set("title", "BuildTool - Apps Overview");
							$header->set("subtitle", "Overview of your apps.");
							$footer = new Template("footer.tpl.php");
							$body = new Template("apps.tpl.php");
							$body->set("success", "Push Notification has been sent to " . $count_android . " Android devices and " . $count_ios . " iOS devices!");
							$body->set("header", $header->parse());
							$body->set("footer", $footer->parse());
							$body->set("username", $_SESSION["user"]);
							$this->getApps();
							$body->set("apps", $this->apps);
							$body->render();
						}
					}
					else
					{
						// Output
						$header = new Template("header.tpl.php");
						$header->set("title", "BuildTool - Push Notifications");
						$header->set("subtitle", "Send out a push notification.");
						$footer = new Template("footer.tpl.php");
						$body = new Template("push_notification.tpl.php");
						$body->set("header", $header->parse());
						$body->set("footer", $footer->parse());
						$body->set("username", $_SESSION["user"]);
						$body->render();
					}
				}
				else
				{
					// App not found
					$this->showAppOverview();
				}
			}

			// Error
			else
			{
				$header = new Template("header.tpl.php");
				$header->set("title", "BuildTool - Apps Overview");
				$header->set("subtitle", "Overview of your apps.");
				$footer = new Template("footer.tpl.php");
				$body = new Template("apps.tpl.php");
				$body->set("error", "Wrong action!");
				$this->getApps();
				$body->set("apps", $this->apps);
				$body->set("header", $header->parse());
				$body->set("footer", $footer->parse());
				$body->set("username", $_SESSION["user"]);
				$body->render();
			}
			
			die();
		}
		
		// Load page
		if(isset($_GET['page']))
		{
			if(file_exists(__CONTROLLERS_DIR__ .'/' . $_GET['page'] . '.php'))
			{
				require_once(__CONTROLLERS_DIR__ .'/' . $_GET['page'] . '.php');
				$classname = ucfirst(strtolower($_GET['page']));
				if(get_class($this) != $classname)
				{
					if(isset($_GET[1]))
					{
						new $classname($_GET[1]);
					}
					else
					{
						new $classname();
					}
					die();
				}
			}
			else
			{
				$host	=	"http://" . $_SERVER["HTTP_HOST"] . rtrim(dirname($_SERVER['PHP_SELF']), '/\\');
				header("Location: $host");
			}
		}
		
	}
	
	/* Get all apps */
	private function getApps()
	{
		$this->db->prepare("SELECT * FROM apps");
		$this->db->execute();
		$apps = $this->db->fetchAll();

		// Get user
		$this->db->prepare("SELECT * FROM users WHERE username = ?");
		$this->db->bindParam(1, $_SESSION['user']);
		$this->db->execute();
		$user = $this->db->fetch();
		$user_id = $user['id'];
		$user_type = $user['type'];
		
		foreach ($apps as $apps)
		{
			if($apps['clientid'] == $user_id || $user_type == "admin")
			{
				// App Name
				$app['app_name']				=	$apps['app_name'];
				
				// App Template
				$this->db->prepare("SELECT * FROM templates where id = ?");
				$this->db->bindParam(1, $apps['app_templateid']);
				$this->db->execute();
				$template = $this->db->fetch();
				$app['app_template']			=	$template['template_name'];
				
				// App description
				$app['app_description']			=	$apps['app_description'];

				// App Actions
				$actions 						=	'<a class="button button-rounded button-primary" href="?page=apps&amp;action=edit&amp;id=' . $apps['id'] . '"><i class="icon-cog"></i></a>';
				$actions 						.=	'<a class="button button-rounded button-primary build_button" onclick="getDownloads(\'' . $apps['id'] . '\')" href="#!"><i class="icon-download"></i></a>';

				if($apps['push_android_enabled'] == 1 || $apps['push_ios_enabled'] == 1)
				{
					$actions 					.=	'<a class="button button-rounded button-primary" href="?page=apps&amp;action=push&amp;id=' . $apps['id'] . '"><i class="icon-cloud"></i></a>';
				}
				
				$actions						.=	'<a class="button button-rounded button-caution" href="?page=apps&amp;action=delete&amp;id=' . $apps['id'] . '" onclick="return confirm(\'Are you sure you want to delete this app?\')"><i class="icon-trash"></i></a>';
				$app['app_actions']				=	$actions;
				
				// Add to array									
				$this->apps[]					= 	$app;
			}
		}
	}
	
	/* Show App Overview. */
	private function showAppOverview()
	{
		$header = new Template("header.tpl.php");
		$header->set("title", "BuildTool - Apps Overview");
		$header->set("subtitle", "Overview of your apps.");
		$footer = new Template("footer.tpl.php");
		$body = new Template("apps.tpl.php");
		$body->set("header", $header->parse());
		$body->set("footer", $footer->parse());
		$body->set("username", $_SESSION["user"]);
		$this->getApps();
		$body->set("apps", $this->apps);
		$body->render();
	}
	
	/* Set changed elements. */
	private function setChanges()
	{
		// Get app id
		$this->db->prepare("SELECT * FROM apps WHERE app_identifier = ?");
		$this->db->bindParam(1, $_POST['app_identifier']);
		$this->db->execute();
		$app = $this->db->fetch();
		$appid = $app['id'];
		
		// Get Template as zip
		$zip = new ZipArchive;
		$res = $zip->open(__UPLOAD_DIR__ . "apps/" . $_POST['app_identifier'] . ".zip");

		// Check content
		if ($res === TRUE)
		{
			// Set location of config and index.html
			if(is_numeric($zip->locateName("www/config.xml")))
			{
				$location = "www/";
			}
			elseif(is_numeric($zip->locateName("config.xml")))
			{
				$location = "";
			}

			// Get Config
			$xmlDoc = new DOMDocument('1.0', 'utf-8');
			$xmlDoc->formatOutput = true;
			$xmlDoc->preserveWhiteSpace = false;
			$xmlDoc->loadXML($zip->getFromName($location . 'config.xml'));
			
			// Set ID & Version
			$xmlDoc->getElementsByTagName( "widget" )->item(0)->setAttribute('id', $_POST['app_identifier']);
			$xmlDoc->getElementsByTagName( "widget" )->item(0)->setAttribute('versionCode', $_POST['app_versioncode']);
			$xmlDoc->getElementsByTagName( "widget" )->item(0)->setAttribute('version', $_POST['app_version']);
			
			// Set Name & Description
			$xmlDoc->getElementsByTagName("name")->item(0)->nodeValue = $_POST['app_name'];
			$xmlDoc->getElementsByTagName("description")->item(0)->nodeValue = $_POST['app_description'];

			// Change Options
			$elements = $xmlDoc->getElementsByTagName( "option" );
			if(count($elements))
			{
				foreach( $elements as $element ) 
				{
					$option_name 		=	$element->getAttribute('name');
					if(isset($_POST[$option_name]))
					{
						if($element->getAttribute('type') == "checkbox")
						{
							$option_value	=	"1";
						}
						else
						{
							$option_value	=	$_POST[$option_name];
						}
					}
					else
					{
						$option_value		=	"0";
					}
					$element->setAttribute('value', $option_value);
				}
			}

			// Remove all old bt_extra elements
			$elements = $xmlDoc->getElementsByTagName( "bt_extra" );
			while($elements->length > 0)
			{
				$element = $elements->item(0);
				$pelement = $element->parentNode;
				while($element->firstChild)
				{
					$element->removeChild($element->firstChild);
				}
				$pelement->removeChild($element);
			}
			
			// Add all new bt_extra elements to config
			$new_element = $xmlDoc->createElement("bt_extra");
			$new_element->setAttribute('setting', 'bt_location');
			$new_element->setAttribute('value', __URL__);
			$xmlDoc->getElementsByTagName( "widget" )->item(0)->appendChild($new_element);
			$new_element = $xmlDoc->createElement("bt_extra");
			$new_element->setAttribute('setting', 'bt_app_id');
			$new_element->setAttribute('value', $appid);
			$xmlDoc->getElementsByTagName( "widget" )->item(0)->appendChild($new_element);
			$new_element = $xmlDoc->createElement("bt_extra");
			$new_element->setAttribute('setting', 'push_android_enable');
			$new_element->setAttribute('value', (isset($_POST['push_android_enable']) ? '1' : '0'));
			$xmlDoc->getElementsByTagName( "widget" )->item(0)->appendChild($new_element);
			$new_element = $xmlDoc->createElement("bt_extra");
			$new_element->setAttribute('setting', 'push_android_senderid');
			$new_element->setAttribute('value', (isset($_POST['push_android_senderid']) ? $_POST['push_android_senderid'] : ''));
			$xmlDoc->getElementsByTagName( "widget" )->item(0)->appendChild($new_element);
			$new_element = $xmlDoc->createElement("bt_extra");
			$new_element->setAttribute('setting', 'push_ios_enable');
			$new_element->setAttribute('value', (isset($_POST['push_ios_enable']) ? '1' : '0'));
			$xmlDoc->getElementsByTagName( "widget" )->item(0)->appendChild($new_element);
			$new_element = $xmlDoc->createElement("bt_extra");
			$new_element->setAttribute('setting', 'stats_ga_enable');
			$new_element->setAttribute('value', (isset($_POST['stats_ga_enable']) ? '1' : '0'));
			$xmlDoc->getElementsByTagName( "widget" )->item(0)->appendChild($new_element);	
			$new_element = $xmlDoc->createElement("bt_extra");
			$new_element->setAttribute('setting', 'stats_ga_accountid');
			$new_element->setAttribute('value', (isset($_POST['stats_ga_accountid']) ? $_POST['stats_ga_accountid'] : ''));
			$xmlDoc->getElementsByTagName( "widget" )->item(0)->appendChild($new_element);
			$new_element = $xmlDoc->createElement("bt_extra");
			$new_element->setAttribute('setting', 'ads_iads_enable');
			$new_element->setAttribute('value', (isset($_POST['ads_iads_enable']) ? '1' : '0'));
			$xmlDoc->getElementsByTagName( "widget" )->item(0)->appendChild($new_element);
			$new_element = $xmlDoc->createElement("bt_extra");
			$new_element->setAttribute('setting', 'ads_iads_position');
			$new_element->setAttribute('value', (isset($_POST['ads_iads_position']) ? $_POST['ads_iads_position'] : ''));
			$xmlDoc->getElementsByTagName( "widget" )->item(0)->appendChild($new_element);
			$new_element = $xmlDoc->createElement("bt_extra");
			$new_element->setAttribute('setting', 'specific_ios_showstatusbar');
			$new_element->setAttribute('value', (isset($_POST['specific_ios_showstatusbar']) ? '1' : '0'));
			$xmlDoc->getElementsByTagName( "widget" )->item(0)->appendChild($new_element);
			$new_element = $xmlDoc->createElement("bt_extra");
			$new_element->setAttribute('setting', 'specific_ios_overlaystatusbar');
			$new_element->setAttribute('value', (isset($_POST['specific_ios_overlaystatusbar']) ? '1' : '0'));
			$xmlDoc->getElementsByTagName( "widget" )->item(0)->appendChild($new_element);
			$new_element = $xmlDoc->createElement("bt_extra");
			$new_element->setAttribute('setting', 'specific_ios_statusbarstyle');
			$new_element->setAttribute('value', (isset($_POST['specific_ios_statusbarstyle']) ? $_POST['specific_ios_statusbarstyle'] : ''));
			$xmlDoc->getElementsByTagName( "widget" )->item(0)->appendChild($new_element);
			
			// Upload files if set
			if($_FILES['push_ios_certificate']["error"] == UPLOAD_ERR_OK)
			{
				$certfile = __UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_ios_push_certificate.cer";
				move_uploaded_file($_FILES['push_ios_certificate']['tmp_name'], $certfile);
			}
			if($_FILES['push_ios_privatekey']["error"] == UPLOAD_ERR_OK)
			{
				$certfile = __UPLOAD_DIR__ . "certificates/" . $_POST['app_identifier'] . "_ios_push_privatekey.p12";
				move_uploaded_file($_FILES['push_ios_privatekey']['tmp_name'], $certfile);
			}

			// Inject bt_custom.js to the head of the index.html after phonegap.js
			if(is_numeric($zip->locateName($location . "index.htm")))
			{
				$ext = ".htm";
			}
			elseif(is_numeric($zip->locateName($location . "index.html")))
			{
				$ext = ".html";
			}
			
			$htmlcontent = $zip->getFromName($location . 'index' . $ext);
						
			// jQuery
			if(!(strpos($htmlcontent, 'jquery') !== false))
			{
				$htmlcontent = str_replace('</head>', '<script type="text/javascript" src="js/jquery.min.js"></script>' . PHP_EOL . '</head>', $htmlcontent);
				$zip->addFile(__ASSETS_DIR__ . 'app/jquery.min.js', $location . 'js/jquery.min.js');
			}
			
			// Push Notifications
			if((!(strpos($htmlcontent, 'bt_pushnotifications') !== false)) && isset($_POST['push_android_enable']) || isset($_POST['push_ios_enable']))
			{
				$htmlcontent = str_replace('</head>', '<script type="text/javascript" src="js/bt_pushnotifications.js"></script>' . PHP_EOL . '</head>', $htmlcontent);
				$zip->addFile(__ASSETS_DIR__ . 'app/bt_pushnotifications.js', $location . 'js/bt_pushnotifications.js');
			}
			
			// Google Analytics
			if((!(strpos($htmlcontent, 'bt_gaplugin') !== false)) && isset($_POST['stats_ga_enable']))
			{
				$htmlcontent = str_replace('</head>', '<script type="text/javascript" src="js/bt_gaplugin.js"></script>' . PHP_EOL . '</head>', $htmlcontent);
				$zip->addFile(__ASSETS_DIR__ . 'app/bt_gaplugin.js', $location . 'js/bt_gaplugin.js');
			}
			
			// iAds
			if((!(strpos($htmlcontent, 'bt_iad') !== false)) && isset($_POST['ads_iads_enable']))
			{
				$htmlcontent = str_replace('</head>', '<script type="text/javascript" src="js/bt_iad.js"></script>' . PHP_EOL . '</head>', $htmlcontent);
				$zip->addFile(__ASSETS_DIR__ . 'app/bt_iad.js', $location . 'js/bt_iad.js');
			}
			
			// Statusbar iOS7
			if((!(strpos($htmlcontent, 'bt_statusbar') !== false)) && isset($_POST['specific_ios_overlaystatusbar']) || !isset($_POST['specific_ios_showstatusbar']))
			{
				$htmlcontent = str_replace('</head>', '<script type="text/javascript" src="js/bt_statusbar.js"></script>' . PHP_EOL . '</head>', $htmlcontent);
				$zip->addFile(__ASSETS_DIR__ . 'app/bt_statusbar.js', $location . 'js/bt_statusbar.js');
			}
			
			// Custom Code
			if((!(strpos($htmlcontent, 'bt_custom') !== false)) && !(strpos($htmlcontent, 'bt_custom.js') !== false))
			{
				// Add bt_custom to index
				$htmlcontent = str_replace('</head>', '<script type="text/javascript" src="js/bt_custom.js"></script>' . PHP_EOL . '</head>', $htmlcontent);
				$zip->addFile(__ASSETS_DIR__ . 'app/bt_custom.js', $location . 'js/bt_custom.js');
			}
			
			// Save index to temp
			file_put_contents(__TEMP_DIR__ . 'index' . $ext, $htmlcontent);
		
			// Re-add index to archive
			$zip->addFile(__TEMP_DIR__ . 'index' . $ext, $location . 'index' . $ext);
		
			// Set Features	(not necessary yet in Phonegap Build)						
			/* $elements = $xmlDoc->getElementsByTagName( "feature" );
			while($elements->length > 0)
			{
				$element = $elements->item(0);
				$pelement = $element->parentNode;
				while($element->firstChild)
				{
					$element->removeChild($element->firstChild);
				}
				$pelement->removeChild($element);
			}
			
			if(isset($_POST['features']))
			{
				foreach($_POST['features'] as $name => $value)
				{	
					$new_element_sub = $xmlDoc->createElement("param");
					$new_element_sub->setAttribute('value', $value);
					$new_element = $xmlDoc->createElement("feature");
					$new_element->setAttribute('name', $name);
					$new_element->appendChild($new_element_sub);
					$xmlDoc->getElementsByTagName( "widget" )->item(0)->appendChild($new_element);
				}
			} */
			
			// Set Preferences
			$elements = $xmlDoc->getElementsByTagName("preference");
			while($elements->length > 0)
			{
				$element = $elements->item(0);
				$pelement = $element->parentNode;
				while($element->firstChild)
				{
					$element->removeChild($element->firstChild);
				}
				$pelement->removeChild($element);
			}
			
			foreach($elements as $element) 
			{
				$xmlDoc->getElementsByTagName( "widget" )->item(0)->removeChild($element);
			}
			
			if(isset($_POST['preferences']))
			{
				foreach ($_POST['preferences'] as $name => $value)
				{
					$new_element = $xmlDoc->createElement("preference");
					$new_element->setAttribute('name', $name);
					$new_element->setAttribute('value', $value);
					$xmlDoc->getElementsByTagName( "widget" )->item(0)->appendChild($new_element);
				}
			}
			
			// Set Plugins
			$elements = $xmlDoc->getElementsByTagName( "plugin" );
			while($elements->length > 0)
			{
				$element = $elements->item(0);
				$pelement = $element->parentNode;
				while($element->firstChild)
				{
					$element->removeChild($element->firstChild);
				}
				$pelement->removeChild($element);
			}
			
			if(isset($_POST['plugins']))
			{
				foreach ($_POST['plugins'] as $name => $value)
				{
					$new_element = $xmlDoc->createElement("gap:plugin");
					$new_element->setAttribute('name', $name);
					$xmlDoc->getElementsByTagName( "widget" )->item(0)->appendChild($new_element);
				}
			}
			
			// Set Artwork
			if(isset($_FILES))
			{
				// Include image editor
				include(__CLASSES_DIR__ . 'imageeditor.class.php');
				
				// Get existing icons from config
				$config_icons = array();
				$elements = $xmlDoc->getElementsByTagName( "icon" );
				if(count($elements))
				{
					foreach( $elements as $element ) 
					{
						$src		=	$element->getAttribute('src');
						$width		=	$element->getAttribute('width');
						$height		=	$element->getAttribute('height');
						$platform	=	$element->getAttribute('gap:platform');
						$density	=	$element->getAttribute('gap:density');
						$role		=	$element->getAttribute('gap:role');
						$state		=	$element->getAttribute('gap:state');
						$config_icons[] = array("", $width, $height, $platform, $density, $role, $src, $state);
					}
				}

				// Get existing icons from array
				foreach($this->icons as $icon)
				{
					if(isset($_POST['icon-remove-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icon[0])]) && $_POST['icon-remove-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icon[0])] == "true")
					{
						// Check if splash exists in config array
						$found = false;
						foreach($config_icons as $config_icon)
						{
							// Check if icon has width and height and platform
							if(!empty($icon[1]) && !empty($icon[2]) && !empty($icon[3]) && $icon[8])
							{
								// Check if matches on width and height and platform and role and state
								if($icon[1] == $config_icon[1] && $icon[2] == $config_icon[2] && $icon[3] == $config_icon[3] && $icon[5] == $config_icon[5] && $icon[7] == $config_icon[7])
								{
									$found = true;
								}
							}
							
							// Check if icon has platform and density
							else if(!empty($icon[4]) && !empty($icon[3]) && !$icon[8])
							{
								// Check if matches on density and platform and role and state
								if($icon[4] == $config_icon[4] && $icon[3] == $config_icon[3] && $icon[5] == $config_icon[5] && $icon[7] == $config_icon[7])
								{
									$found = true;
								}
							}
							
							// Check if icon has platform
							else if(!empty($icon[3]) && !$icon[8])
							{
								// Check if matches on platform and role and state
								if($icon[3] == $config_icon[3] && $icon[5] == $config_icon[5] && $icon[7] == $config_icon[7])
								{
									$found = true;
								}
							}
							
							// Check if icon is default
							else if(!empty($icon[1]) && !empty($icon[2]) && !$icon[8])
							{
								if(!empty($config_icon[6]))
								{
									$found = true;
								}
							}
							
							// Existing splash found
							if($found)
							{
								// Remove current image from zip if exists
								$zip->deleteName($location . $config_icon[6]);
								
								// Remove entry from config if exists
								foreach($elements as $element)
								{
									$src = $element->getAttribute('src');
									if($config_icon[6] == $src)
									{
										$xmlDoc->getElementsByTagName( "widget" )->item(0)->removeChild($element);
									}
								}
								break;
							}
						}
					}
					// If current icon that has been submitted is in icon array ...
					else if(isset($_FILES['icon-input-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icon[0])]))
					{
						// ... and correctly uploaded
						if($_FILES['icon-input-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icon[0])]["error"] == UPLOAD_ERR_OK)
						{
							$extension = strtolower(strrchr($_FILES['icon-input-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icon[0])]['name'], '.'));
							$imagename = __TEMP_DIR__ . "temp_" . preg_replace('/[^A-Za-z0-9-]+/', '-', $icon[0]) . $extension;

							// Move the icon to a temporary directory
							if(move_uploaded_file($_FILES['icon-input-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icon[0])]['tmp_name'], $imagename))
							{	
								// Resize to correct size
								$imageeditor = new Imageeditor($imagename);  
								$imageeditor -> resizeImage($icon[1], $icon[2]);
								$imageeditor -> saveImage($imagename);
								
								// Check if icon exists in config array
								$found = false;

								foreach($config_icons as $config_icon)
								{
									// Check if icon has width and height and platform
									if(!empty($icon[1]) && !empty($icon[2]) && !empty($icon[3]) && $icon[8])
									{
										// Check if matches on width and height and platform and role and state
										if($icon[1] == $config_icon[1] && $icon[2] == $config_icon[2] && $icon[3] == $config_icon[3] && $icon[5] == $config_icon[5] && $icon[7] == $config_icon[7])
										{
											$found = true;
										}
									}
									
									// Check if icon has platform and density
									else if(!empty($icon[4]) && !empty($icon[3]) && !$icon[8])
									{
										// Check if matches on density and platform and role and state
										if($icon[4] == $config_icon[4] && $icon[3] == $config_icon[3] && $icon[5] == $config_icon[5] && $icon[7] == $config_icon[7])
										{
											$found = true;
										}
									}
									
									// Check if icon has platform
									else if(!empty($icon[3]) && !$icon[8])
									{
										// Check if matches on platform and role and state
										if($icon[3] == $config_icon[3] && $icon[5] == $config_icon[5] && $icon[7] == $config_icon[7])
										{
											$found = true;
										}
									}
									
									// Check if icon is default
									else if(!empty($icon[1]) && !empty($icon[2]) && !$icon[8])
									{
										if(!empty($config_icon[6]))
										{
											$found = true;
										}
									}
									
									if($found)
									{
										// Remove current image from zip
										$zip->deleteName($location . $config_icon[6]);
										
										// Add temp image to zip (icons/platform/name)
										if(!empty($icon[3]))
										{
											$zip->addFile($imagename, $location . 'icons/' . $icon[3] . '/' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icon[0]) . $extension);
										}
										else
										{
											$zip->addFile($imagename, $location . 'icons/' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icon[0]) . $extension);
										}
										
										// Change element
										foreach($elements as $element)
										{
											$width = $element->getAttribute('width');
											$height = $element->getAttribute('height');
											$platform = $element->getAttribute('gap:platform');
											$density = $element->getAttribute('gap:density');
											$role = $element->getAttribute('gap:role');
											$state = $element->getAttribute('gap:state');
											$src = $element->getAttribute('src');
											
											// Check if config icon has width and height and platform
											if(!empty($config_icon[1]) && !empty($config_icon[2]) && !empty($config_icon[3]))
											{
												// Check if matches on width and height and platform and role and state
												if($width == $config_icon[1] && $height == $config_icon[2] && $platform = $config_icon[3] && $role == $config_icon[5] && $state == $config_icon[7])
												{
													$element->setAttribute('width', $icon[1]);
													$element->setAttribute('height', $icon[2]);
													$element->setAttribute('gap:platform', $icon[3]);
													$element->setAttribute('src', 'icons/' . $icon[3] . '/' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icon[0]) . $extension);
													
													if(!empty($icon[5]))
													{
														$element->setAttribute('gap:role', $icon[5]);
													}
													if(!empty($icon[7]))
													{
														$element->setAttribute('gap:state', $icon[7]);
													}
													break;
												}
											}
											
											// Check if config icon has platform and density
											else if(!empty($config_icon[4]) && !empty($config_icon[3]))
											{
												// Check if matches on density and platform and role and state
												if($density == $config_icon[4] && $platform == $config_icon[3] && $role == $config_icon[5] && $state == $config_icon[7])
												{
													$element->setAttribute('gap:platform', $icon[3]);
													$element->setAttribute('gap:density', $icon[4]);
													$element->setAttribute('src', 'icons/' . $icon[3] . '/' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icon[0]) . $extension);
													
													if(!empty($icon[5]))
													{
														$element->setAttribute('gap:role', $icon[5]);
													}
													if(!empty($icon[7]))
													{
														$element->setAttribute('gap:state', $icon[7]);
													}
													break;
												}
											}
											
											// Check if config has platform
											else if(!empty($config_icon[3]))
											{
												// Check if matches on platform and role and state
												if($platform == $config_icon[3] && $role == $config_icon[5] && $state == $config_icon[7])
												{
													$element->setAttribute('gap:platform', $icon[3]);
													$element->setAttribute('src', 'icons/' . $icon[3] . '/' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icon[0]) . $extension);
													
													if(!empty($icon[5]))
													{
														$element->setAttribute('gap:role', $icon[5]);
													}
													if(!empty($icon[7]))
													{
														$element->setAttribute('gap:state', $icon[7]);
													}
													break;
												}
											}
											
											// Check if config has src (default)
											else if(!empty($config_icon[6]))
											{
												$element->setAttribute('src', 'icons/' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icon[0]) . $extension);
												break;
											}
										}
										break;
									}
								}
								
								if(!$found)
								{
									// Add temp image to zip (icons/platform/name)
									if(!empty($icon[3]))
									{
										$zip->addFile($imagename, $location . 'icons/' . $icon[3] . '/' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icon[0]) . $extension);
									}
									else
									{
										$zip->addFile($imagename, $location . 'icons/' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icon[0]) . $extension);
									}
									
									// Create new element
									$new_element = $xmlDoc->createElement("icon");
																						
									// Check if icon has width and height and platform
									if(!empty($icon[1]) && !empty($icon[2]) && !empty($icon[3]) && $icon[8])
									{
										$new_element->setAttribute('width', $icon[1]);
										$new_element->setAttribute('height', $icon[2]);
										$new_element->setAttribute('gap:platform', $icon[3]);
										$new_element->setAttribute('src', 'icons/' . $icon[3] . '/' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icon[0]) . $extension);
							
										if(!empty($icon[5]))
										{
											$new_element->setAttribute('gap:role', $icon[5]);
										}
										if(!empty($icon[7]))
										{
											$new_element->setAttribute('gap:state', $icon[7]);
										}
										
										// Add new element
										$xmlDoc->getElementsByTagName( "widget" )->item(0)->appendChild($new_element);
									}
									
									// Check if icon has platform and density
									else if(!empty($icon[4]) && !empty($icon[3]) && !$icon[8])
									{
										$new_element->setAttribute('gap:density', $icon[4]);
										$new_element->setAttribute('gap:platform', $icon[3]);
										$new_element->setAttribute('src', 'icons/' . $icon[3] . '/' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icon[0]) . $extension);
										
										if(!empty($icon[5]))
										{
											$new_element->setAttribute('gap:role', $icon[5]);
										}
										if(!empty($icon[7]))
										{
											$new_element->setAttribute('gap:state', $icon[7]);
										}
									
										// Add new element
										$xmlDoc->getElementsByTagName( "widget" )->item(0)->appendChild($new_element);
									}
									
									// Check if icon has platform
									else if(!empty($icon[3]) && !$icon[8])
									{
										$new_element->setAttribute('gap:platform', $icon[3]);
										$new_element->setAttribute('src', 'icons/' . $icon[3] . '/' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icon[0]) . $extension);
							
										if(!empty($icon[5]))
										{
											$new_element->setAttribute('gap:role', $icon[5]);
										}
										if(!empty($icon[7]))
										{
											$new_element->setAttribute('gap:state', $icon[7]);
										}
										
										// Add new element
										$xmlDoc->getElementsByTagName( "widget" )->item(0)->appendChild($new_element);
									}
									
									// Default icon
									else
									{
										$new_element->setAttribute('src', 'icons/' . preg_replace('/[^A-Za-z0-9-]+/', '-', $icon[0]) . $extension);
										
										// Add new element
										$xmlDoc->getElementsByTagName( "widget" )->item(0)->appendChild($new_element);
									}
								}
							}
							// Delete uploaded file from temp dir
							$this->deletequeue[] = $imagename;
						}
					}
				}
				
				// Set Splashscreens
				$config_splashscreens = array();
				$elements = $xmlDoc->getElementsByTagName( "splash" );
				if(count($elements))
				{
					foreach( $elements as $element ) 
					{
						$src		=	$element->getAttribute('src');
						$width		=	$element->getAttribute('width');
						$height		=	$element->getAttribute('height');
						$platform	=	$element->getAttribute('gap:platform');
						$density	=	$element->getAttribute('gap:density');
						$config_splashscreens[] = array("", $width, $height, $platform, $density, $src);
					}
				}

				// Get existing splashscreens from array
				foreach($this->splashscreens as $splash)
				{
					if(isset($_POST['splash-remove-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splash[0])]) && $_POST['splash-remove-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splash[0])] == "true")
					{
						// Check if splash exists in config array
						$found = false;
						foreach($config_splashscreens as $config_splash)
						{
							// Check if splash has width and height
							if(!empty($splash[1]) && !empty($splash[2]) && !empty($splash[3]) && $splash[6])
							{
								// Check if matches on width and height and platform
								if($splash[1] == $config_splash[1] && $splash[2] == $config_splash[2] && $splash[3] == $config_splash[3])
								{
									$found = true;
								}
							}
							
							// Check if splash has platform and density
							else if(!empty($splash[4]) && !empty($splash[3]) && !$splash[6])
							{
								// Check if matches on density and platform
								if($splash[4] == $config_splash[4] && $splash[3] == $config_splash[3])
								{
									$found = true;
								}
							}
							
							// Check if splash has platform
							else if(!empty($splash[3]) && !$splash[6])
							{
								// Check if matches on platform
								if($splash[3] == $config_splash[3])
								{
									$found = true;
								}
							}
							
							// Check if splash is default
							else if(!empty($splash[1]) && !empty($splash[2]) && !$splash[6])
							{
								// Check if matches on platform
								if(!empty($config_splash[5]))
								{
									$found = true;
								}
							}
							
							// Existing splash found
							if($found)
							{
								// Remove current image from zip if exists
								$zip->deleteName($location . $config_splash[5]);
								
								// Remove entry from config if exists
								foreach($elements as $element)
								{
									$src = $element->getAttribute('src');
									if($config_splash[5] == $src)
									{
										$xmlDoc->getElementsByTagName( "widget" )->item(0)->removeChild($element);
									}
								}
								break;
							}
						}
					}
					
					// If splashscreen has been submitted ...
					else if(isset($_FILES['splash-input-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splash[0])]))
					{
						// ... and correctly uploaded
						if($_FILES['splash-input-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splash[0])]["error"] == UPLOAD_ERR_OK)
						{
							$extension = strtolower(strrchr($_FILES['splash-input-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splash[0])]['name'], '.'));
							$imagename = __TEMP_DIR__ . "temp_" . preg_replace('/[^A-Za-z0-9-]+/', '-', $splash[0]) . $extension;

							// Move the splash to a temporary directory
							if(move_uploaded_file($_FILES['splash-input-' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splash[0])]['tmp_name'], $imagename))	
							{	
								// Resize to correct size
								$imageeditor = new Imageeditor($imagename);  
								$imageeditor -> resizeImage($splash[1], $splash[2]);
								$imageeditor -> saveImage($imagename);
								
								// Check if splash exists in config array
								$found = false;
								foreach($config_splashscreens as $config_splash)
								{
									// Check if splash has width and height
									if(!empty($splash[1]) && !empty($splash[2]) && !empty($splash[3]) && $splash[6])
									{
										// Check if matches on width and height and platform
										if($splash[1] == $config_splash[1] && $splash[2] == $config_splash[2] && $splash[3] == $config_splash[3])
										{
											$found = true;
										}
									}
									
									// Check if splash has platform and density
									else if(!empty($splash[4]) && !empty($splash[3]) && !$splash[6])
									{
										// Check if matches on density and platform
										if($splash[4] == $config_splash[4] && $splash[3] == $config_splash[3])
										{
											$found = true;
										}
									}
									
									// Check if splash has platform
									else if(!empty($splash[3]) && !$splash[6])
									{
										// Check if matches on platform
										if($splash[3] == $config_splash[3])
										{
											$found = true;
										}
									}
									
									// Check if splash is default
									else if(!empty($splash[1]) && !empty($splash[2]) && !$splash[6])
									{
										// Check if matches on platform
										if(!empty($config_splash[5]))
										{
											$found = true;
										}
									}
									
									// Existing splash found
									if($found)
									{
										// Remove current image from zip
										$zip->deleteName($location . $config_splash[5]);
										
										// Add temp image to zip (splashscreens/platform/name)
										if(!empty($splash[3]))
										{
											$zip->addFile($imagename, $location . 'splashscreens/' . $splash[3] . '/' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splash[0]) . $extension);
										}
										else
										{
											$zip->addFile($imagename, $location . 'splashscreens/' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splash[0]) . $extension);
										}
										
										// Change element
										foreach($elements as $element)
										{
											$src = $element->getAttribute('src');
											$width = $element->getAttribute('width');
											$height = $element->getAttribute('height');
											$platform = $element->getAttribute('gap:platform');
											$density = $element->getAttribute('gap:density');

											// Check if config splash has width and height and platform
											if(!empty($config_splash[1]) && !empty($config_splash[2]) && !empty($config_splash[3]))
											{
												// Check if matches on width and height and platform
												if($width == $config_splash[1] && $height == $config_splash[2] && $platform = $config_splash[3])
												{
													$element->setAttribute('width', $splash[1]);
													$element->setAttribute('height', $splash[2]);
													$element->setAttribute('gap:platform', $splash[3]);
													$element->setAttribute('src', 'splashscreens/' . $splash[3] . '/' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splash[0]) . $extension);
													break;
												}
											}
											
											// Check if config splash has platform and density
											else if(!empty($config_splash[4]) && !empty($config_splash[3]))
											{
												// Check if matches on density and platform
												if($density == $config_splash[4] && $platform == $config_splash[3])
												{
													$element->setAttribute('gap:platform', $splash[3]);
													$element->setAttribute('gap:density', $splash[4]);
													$element->setAttribute('src', 'splashscreens/' . $splash[3] . '/' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splash[0]) . $extension);
													break;
												}
											}
											
											// Check if config splash has platform
											else if(!empty($config_splash[3]))
											{
												// Check if matches on platform
												if($platform == $config_splash[3])
												{
													$element->setAttribute('gap:platform', $splash[3]);
													$element->setAttribute('src', 'splashscreens/' . $splash[3] . '/' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splash[0]) . $extension);
													break;
												}
											}
											
											// Check if config has src (default)
											else if(!empty($config_splash[5]))
											{
												$element->setAttribute('src', 'splashscreens/' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splash[0]) . $extension);
												break;
											}
										}
										break;
									}
								}
								
								if(!$found)
								{
									// Add temp image to zip (splashscreens/platform/name)
									if(!empty($splash[3]))
									{
										$zip->addFile($imagename, $location . 'splashscreens/' . $splash[3] . '/' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splash[0]) . $extension);
									}
									else
									{
										$zip->addFile($imagename, $location . 'splashscreens/' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splash[0]) . $extension);
									}
									
									// Create new element
									$new_element = $xmlDoc->createElement("gap:splash");
									
									// Check if splash has width and height and platform
									if(!empty($splash[1]) && !empty($splash[2]) && !empty($splash[3]) && $splash[6])
									{
										$new_element->setAttribute('width', $splash[1]);
										$new_element->setAttribute('height', $splash[2]);
										$new_element->setAttribute('gap:platform', $splash[3]);
										$new_element->setAttribute('src', 'splashscreens/' . $splash[3] . '/' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splash[0]) . $extension);
										
										// Add new element
										$xmlDoc->getElementsByTagName( "widget" )->item(0)->appendChild($new_element);
									}
									
									// Check if splash has platform and density
									else if(!empty($splash[4]) && !empty($splash[3]) && !$splash[6])
									{
										$new_element->setAttribute('gap:density', $splash[4]);
										$new_element->setAttribute('gap:platform', $splash[3]);
										$new_element->setAttribute('src', 'splashscreens/' . $splash[3] . '/' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splash[0]) . $extension);
										
										// Add new element
										$xmlDoc->getElementsByTagName( "widget" )->item(0)->appendChild($new_element);
									}
									
									// Check if icon has platform
									else if(!empty($splash[3]) && !$splash[6])
									{
										$new_element->setAttribute('gap:platform', $splash[3]);
										$new_element->setAttribute('src', 'splashscreens/' . $splash[3] . '/' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splash[0]) . $extension);

										// Add new element
										$xmlDoc->getElementsByTagName( "widget" )->item(0)->appendChild($new_element);
									}
									
									// Default
									else
									{
										$new_element->setAttribute('src', 'splashscreens/' . preg_replace('/[^A-Za-z0-9-]+/', '-', $splash[0]) . $extension);
											
										// Add new element
										$xmlDoc->getElementsByTagName( "widget" )->item(0)->appendChild($new_element);
									}
								}
							}
							// Delete uploaded file from temp dir
							$this->deletequeue[] = $imagename;
						}
					}
				}
			}
			
			// Save config to temp directory
			$xmlDoc->encoding = 'utf-8';
			$xmlDoc->save(__TEMP_DIR__ . 'config.xml');

			// Add config to archive
			$zip->addFile(__TEMP_DIR__ . 'config.xml', $location . 'config.xml');
			
			// Add config duplicate to archive (original will be removed on build by phonegap, and we need it :-))
			$zip->addFile(__TEMP_DIR__ . 'config.xml', $location . 'bt_config.xml');
			
			// Close archive
			$zip->close();
			
			// Remove config from temp directory
			@unlink(__TEMP_DIR__ . 'config.xml');
			
			// Remove index from temp directory
			@unlink(__TEMP_DIR__ . 'index' . $ext);
			
			// Remove all files in delete array
			foreach($this->deletequeue as $del)
			{
				@unlink($del);
			}
			
			// Empty deletequeue
			$this->deletequeue = array();
		}
	}
	
}
?>