<?php

/* --------------------------------------------------------------------------------------------------- 
 * BuildTool - App Builder
 * 
 * @author	AppResponsive <http://robinbonnes.nl/>
 * @version	1.5
 *
 * Copyright (C) 2013 - 2014 AppResponsive. All rights reserved.
 * 
 * -------------------------------------------------------------------------------------------------- */

/* Check access */
if(!defined('access') or !access) die('This file cannot be directly accessed.');

class Templates {

	/* Database connection */
	private $db;
	
	/* Templates array */
	public $templates;
	
	/* Constructor */
	public function __construct()
	{
		/* Assign Database */
		$this->db = Database::getInstance();
		
		/* Check if POST/GET is done. */
		$this->check();
		
		/* Get all the values needed to display on the page */
		$this->getTemplates();
		
		/* Show Templates Overview. */
		$this->showTemplatesOverview();
	}
	
	/* Check if some post is done. */
	private function check()
	{
		// Logout user
		if(isset($_GET['logout']))
		{
			// Destroy Session
			session_destroy();
			$host	=	"http://" . $_SERVER["HTTP_HOST"] . rtrim(dirname($_SERVER['PHP_SELF']), '/\\');
			header("Location: $host");
		}
		
		// Do action
		if(isset($_GET['action']))
		{
			// Add Template
			if($_GET['action'] == "createnew")
			{
				// Check template
				if(isset($_POST['template_name']))
				{
					// Check name
					if($_POST['template_name'] != "")
					{					
						// Check file
						if($_FILES["template_package"]["error"] == UPLOAD_ERR_OK)
						{
							// Check extension						
							if(strchr($_FILES["template_package"]['name'],'.zip'))
							{
								$zip = new ZipArchive;
								$res = $zip->open($_FILES["template_package"]["tmp_name"]);
								
								// Check content
								if ($res === TRUE)
								{
									// Check if file contains index.html file
									if(is_numeric($zip->locateName("www/index.html")) || is_numeric($zip->locateName("index.html")))
									{
										// Check if string <script src="phonegap.js"></script> is in file
										if((strpos($zip->getFromName('www/index.html'), 'phonegap.js') !== false) || (strpos($zip->getFromName('index.html'), 'phonegap.js') !== false))
										{
											// Check if file already exists
											if(!file_exists(__UPLOAD_DIR__ . "templates/" . basename($_FILES['template_package']['name'])))
											{
												if(move_uploaded_file($_FILES['template_package']['tmp_name'], __UPLOAD_DIR__ . "templates/" . basename($_FILES['template_package']['name'])))
												{
													// Add database
													$this->db->prepare("INSERT INTO templates(template_name, template_description, template_package) VALUES (?, ?, ?)");
													$this->db->bindParam(1, $_POST['template_name']);
													$this->db->bindParam(2, $_POST['template_description']);
													$this->db->bindParam(3, $_FILES["template_package"]['name']);
													$this->db->execute();
													
													// Output
													$header	= new Template("header.tpl.php");
													$header->set("title", "BuildTool - Templates Overview");
													$header->set("subtitle", "Overview of your app templates.");
													$footer = new Template("footer.tpl.php");
													$body = new Template("templates.tpl.php");
													$this->getTemplates();
													$body->set("templates", $this->templates);
													$body->set("success", "SUCCESS: Template has been saved to the database.");
												}
												else
												{
													$header	= new Template("header.tpl.php");
													$header->set("title", "BuildTool - New Template");
													$header->set("subtitle", "Add a new template.");
													$footer = new Template("footer.tpl.php");
													$body = new Template("template_new.tpl.php");
													$body->set("error", "ERROR: The upload was not successful!");
												}
											}
											else
											{
												$header	= new Template("header.tpl.php");
												$header->set("title", "BuildTool - New Template");
												$header->set("subtitle", "Add a new template.");
												$footer = new Template("footer.tpl.php");
												$body = new Template("template_new.tpl.php");
												$body->set("error", "ERROR: The uploaded file already exists!");
											}
										}
										else
										{
											$header	= new Template("header.tpl.php");
											$header->set("title", "BuildTool - New Template");
											$header->set("subtitle", "Add a new template.");
											$footer = new Template("footer.tpl.php");
											$body = new Template("template_new.tpl.php");
											$body->set("error", "ERROR: index.html doesn't contain: '&lt;script src='phonegap.js'&gt;&lt;/script&gt;'. Please check the Phonegap API for more info!");
										}
									}
									else
									{
										$header	= new Template("header.tpl.php");
										$header->set("title", "BuildTool - New Template");
										$header->set("subtitle", "Add a new template.");
										$footer = new Template("footer.tpl.php");
										$body = new Template("template_new.tpl.php");
										$body->set("error", "ERROR: Uploaded zip archive is missing the index.html file, or index.html is not in root(/www)!");
									}
									$zip->close();
								}
								else
								{
									$header	= new Template("header.tpl.php");
									$header->set("title", "BuildTool - New Template");
									$header->set("subtitle", "Add a new template.");
									$footer = new Template("footer.tpl.php");
									$body = new Template("template_new.tpl.php");
									$body->set("error", "ERROR: Could not open uploaded zip archive!");
								}
							}
							else
							{
								$header	= new Template("header.tpl.php");
								$header->set("title", "BuildTool - New Template");
								$header->set("subtitle", "Add a new template.");
								$footer = new Template("footer.tpl.php");
								$body = new Template("template_new.tpl.php");
								$body->set("error", "ERROR: Uploaded file is not a zip archive!");
							}
						}
						else
						{
							$header	= new Template("header.tpl.php");
							$header->set("title", "BuildTool - New Template");
							$header->set("subtitle", "Add a new template.");
							$footer = new Template("footer.tpl.php");
							$body = new Template("template_new.tpl.php");
							$body->set("error", "ERROR: The upload was not successful!");
						}
					}
					else
					{
						$header	= new Template("header.tpl.php");
						$header->set("title", "BuildTool - New Template");
						$header->set("subtitle", "Add a new template.");
						$footer = new Template("footer.tpl.php");
						$body = new Template("template_new.tpl.php");
						$body->set("error", "ERROR: Template name can't be empty!");
					}
					
					$body->set("header", $header->parse());
					$body->set("footer", $footer->parse());
					$body->set("username", $_SESSION["user"]);
					$body->render();
				}
				else
				{
					$header = new Template("header.tpl.php");
					$header->set("title", "BuildTool - New Template");
					$header->set("subtitle", "Add a new template.");
					$footer = new Template("footer.tpl.php");
					$body = new Template("template_new.tpl.php");
					$body->set("header", $header->parse());
					$body->set("footer", $footer->parse());
					$body->set("username", $_SESSION["user"]);
					$body->render();
				}
			}
			
			// Delete template
			if($_GET['action'] == "delete")
			{
				if(isset($_GET['id']))
				{		
					// Delete file from uploads folder
					$this->db->prepare("SELECT * FROM templates WHERE id = ?");
					$this->db->bindParam(1, $_GET['id']);
					$this->db->execute();
					$fileentry = $this->db->fetch();
						
					if($fileentry != 0)
					{
						// Delete template from uploads folder
						@unlink(__UPLOAD_DIR__ . "templates/" . $fileentry['template_package']);
						
						// Delete entry from database
						$this->db->prepare("DELETE FROM templates WHERE id = ?");
						$this->db->bindParam(1, $_GET['id']);
						$this->db->execute();
						
						$header	= new Template("header.tpl.php");
						$header->set("title", "BuildTool - Templates Overview");
						$header->set("subtitle", "Overview of your app templates.");
						$footer = new Template("footer.tpl.php");
						$body = new Template("templates.tpl.php");
						$this->getTemplates();
						$body->set("templates", $this->templates);
						$body->set("success", "SUCCESS: Template has been deleted!");
						$body->set("header", $header->parse());
						$body->set("footer", $footer->parse());
						$body->set("username", $_SESSION["user"]);
						$body->render();	
					}
					else
					{
						$header	= new Template("header.tpl.php");
						$header->set("title", "BuildTool - Templates Overview");
						$header->set("subtitle", "Overview of your app templates.");
						$footer = new Template("footer.tpl.php");
						$body = new Template("templates.tpl.php");
						$this->getTemplates();
						$body->set("templates", $this->templates);
						$body->set("error", "ERROR: Template doesn't exist!");
						$body->set("header", $header->parse());
						$body->set("footer", $footer->parse());
						$body->set("username", $_SESSION["user"]);
						$body->render();
					}
				}
				else
				{
					$header	= new Template("header.tpl.php");
					$header->set("title", "BuildTool - Templates Overview");
					$header->set("subtitle", "Overview of your app templates.");
					$footer = new Template("footer.tpl.php");
					$body = new Template("templates.tpl.php");
					$this->getTemplates();
					$body->set("templates", $this->templates);
					$body->set("error", "ERROR: No template ID specified.");
					$body->set("header", $header->parse());
					$body->set("footer", $footer->parse());
					$body->set("username", $_SESSION["user"]);
					$body->render();
				}
			}
			
			// Edit Template
			if($_GET['action'] == "edit")
			{
				if(isset($_GET['id']))
				{
					// Check POST
					if(isset($_POST['template_name']))
					{
						// Update template name and description
						$this->db->prepare("UPDATE templates SET template_name = ?, template_description = ? WHERE id = ?");
						$this->db->bindParam(1, $_POST['template_name']);
						$this->db->bindParam(2, $_POST['template_description']);
						$this->db->bindParam(3, $_GET['id']);
						$this->db->execute();
						
						// Check file
						if(isset($_FILES["template_package"]))
						{
							if($_FILES["template_package"]["error"] == UPLOAD_ERR_OK)
							{
								// Check extension						
								if(strchr($_FILES["template_package"]['name'],'.zip'))
								{
									$zip = new ZipArchive;
									$res = $zip->open($_FILES["template_package"]["tmp_name"]);
									
									// Check content
									if ($res === TRUE)
									{
										// Check if file contains index.html file
										if(is_numeric($zip->locateName("www/index.html")) || is_numeric($zip->locateName("index.html")))
										{
											// Check if string <script src="phonegap.js"></script> is in file
											if((strpos($zip->getFromName('www/index.html'), 'phonegap.js') !== false) || (strpos($zip->getFromName('index.html'), 'phonegap.js') !== false))
											{
												// Check if file already exists
												if(!file_exists(__UPLOAD_DIR__ . "templates/" . basename($_FILES['template_package']['name'])))
												{
													// Save file
													if(move_uploaded_file($_FILES['template_package']['tmp_name'], __UPLOAD_DIR__ . "templates/" . basename($_FILES['template_package']['name'])))
													{
														// Edit Database
														$this->db->prepare("UPDATE templates SET template_package = ? WHERE id = ?");
														$this->db->bindParam(1, $_FILES['template_package']['name']);
														$this->db->bindParam(2, $_GET['id']);
														$this->db->execute();
													}
													else
													{
														$fileerror = "ERROR: The upload was not successful!";
													}
												}
												else
												{
													$fileerror = "ERROR: The uploaded file already exists!";
												}
											}
											else
											{
												$fileerror = "ERROR: index.html doesn't contain: '&lt;script src='phonegap.js'&gt;&lt;/script&gt;'. Please check the Phonegap API for more info!";
											}
										}
										else
										{
											$fileerror = "ERROR: Uploaded zip archive is missing the index.html file, or index.html is not in root(/www)!";
										}
										$zip->close();
									}
									else
									{
										$fileerror = "ERROR: Could not open uploaded zip archive!";
									}
								}
								else
								{
									$fileerror = "ERROR: Uploaded file is not a zip archive!";
								}
							}
						}
						
						$header	= new Template("header.tpl.php");
						$header->set("title", "BuildTool - Templates Overview");
						$header->set("subtitle", "Overview of your app templates.");
						$footer = new Template("footer.tpl.php");
						$body = new Template("templates.tpl.php");

						if(isset($fileerror))
						{
							$body->set("success", "Template details successfully updated, but the zip package hasn't changed because:<br>" . $fileerror);
						}
						else
						{
							$body->set("success", "Template details successfully updated!");
						}
						
						$this->getTemplates();
						$body->set("templates", $this->templates);
						$body->set("header", $header->parse());
						$body->set("footer", $footer->parse());
						$body->set("username", $_SESSION["user"]);
						$body->render();
					}
					else
					{
						// Get Template
						$this->db->prepare("SELECT * FROM templates WHERE id = ?");
						$this->db->bindParam(1, $_GET['id']);
						$this->db->execute();
						$template = $this->db->fetch();
						
						// Get Template Options
						$zip = new ZipArchive;
						$res = $zip->open(__UPLOAD_DIR__ . "templates/" . $template['template_package']);
						$templateoptions = '';
						
						// Check content
						if($res === TRUE)
						{
							$xmlDoc = new DOMDocument(); 
							if(is_numeric($zip->locateName("www/config.xml")))
							{
								$xmlDoc->loadXML($zip->getFromName('www/config.xml'));
							}
							elseif(is_numeric($zip->locateName("config.xml")))
							{
								$xmlDoc->loadXML($zip->getFromName('config.xml'));
							}

							$elements = $xmlDoc->getElementsByTagName( "option" );
							
							if(count($elements))
							{
								$templateoptions .= '<div class="divider"></div>';
								$templateoptions .= '<div class="message">This template has the following options. These options can be changed per app.</div>';
								$templateoptions .= '<div class="divider"></div>';
							}
							
							foreach( $elements as $element ) 
							{
								$option_name 		=	$element->getAttribute('name');
								$option_required 	=	$element->getAttribute('required');
								$option_type	 	=	$element->getAttribute('type');
								$option_value	 	=	$element->getAttribute('value');
								
								$div	=	'<div class="field">';
								
								if($option_required == "true")
								{
									$div 	.=	'<label class="fullwidth_label" for="' . $option_name . '">' . $option_name . '*:</label>';
								}
								else
								{
									$div 	.=	'<label class="fullwidth_label" for="' . $option_name . '">' . $option_name . ':</label>';
								}
								
								if($option_type == "textfield")
								{
									if($option_required == "true")
									{
										$div .= '<input type="text" class="required" id="' . $option_name . '" name="' . $option_name . '" value="' . $option_value . '" disabled>';
									}
									else
									{
										$div .= '<input type="text" id="' . $option_name . '" name="' . $option_name . '" value="' . $option_value . '" disabled>';
									}
								}
								if($option_type == "textarea")
								{
									if($option_required == "true")
									{
										$div .= '<textarea class="required" id="' . $option_name . '" name="' . $option_name . '" disabled>' . $option_value . '</textarea>';
									}
									else
									{
										$div .= '<textarea id="' . $option_name . '" name="' . $option_name . '" disabled>' . $option_value . '</textarea>';
									}
								}
								if($option_type == "select")
								{
									$option_options		=	$element->getAttribute('options');
									$div .= '<span class="dropdown" disabled><select class="required" id="' . $option_name . '" name="' . $option_name . '" disabled>';
									
										$values = explode("|", $option_options);
										reset($values);
										foreach ($values as $option)
										{
											if($option == $option_value)
											{
												$div .= '<option value="' . $option .'" selected>' . $option .'</option>';
											}
											else
											{
												$div .= '<option value="' . $option .'">' . $option .'</option>';
											}
										}
										
									$div .= '</select></span>';
								}
								if($option_type == "checkbox")
								{
									if($option_value == "1")
									{
										$div .= '<div class="toggle fullwidth_toggle"><input type="checkbox" id="' . $option_name . '" name="' . $option_name . '" checked disabled><b class="b switch" disabled></b><b class="b track"></b></div>';
									}
									else
									{
										$div .= '<div class="toggle fullwidth_toggle"><input type="checkbox" id="' . $option_name . '" name="' . $option_name . '" disabled/><b class="b switch" disabled></b><b class="b track"></b></div>';
									}
								}

								$div .=	'</div>';
								
								$templateoptions .= $div;
							}
							$zip->close();
						}
					
						$header = new Template("header.tpl.php");
						$header->set("title", "BuildTool - Edit Template");
						$header->set("subtitle", "Edit this template.");
						$footer = new Template("footer.tpl.php");
						$body = new Template("template_edit.tpl.php");
						$body->set("template_name", $template['template_name']);
						$body->set("template_options", $templateoptions);
						$body->set("template_description", $template['template_description']);
						$body->set("template_package", $template['template_package']);
						$body->set("header", $header->parse());
						$body->set("footer", $footer->parse());
						$body->set("username", $_SESSION["user"]);
						$body->render();
					}
				}
				else
				{
					$header	= new Template("header.tpl.php");
					$header->set("title", "BuildTool - Templates Overview");
					$header->set("subtitle", "Overview of your app templates.");
					$footer = new Template("footer.tpl.php");
					$body = new Template("templates.tpl.php");
					$this->getTemplates();
					$body->set("templates", $this->templates);
					$body->set("error", "ERROR: No template ID specified.");
					$body->set("header", $header->parse());
					$body->set("footer", $footer->parse());
					$body->set("username", $_SESSION["user"]);
					$body->render();
				}
			}
			
			die();
		}
		
		// Load page
		if(isset($_GET['page']))
		{
			if(file_exists(__CONTROLLERS_DIR__ .'/' . $_GET['page'] . '.php'))
			{
				require_once(__CONTROLLERS_DIR__ .'/' . $_GET['page'] . '.php');
				$classname = ucfirst(strtolower($_GET['page']));
				if(get_class($this) != $classname)
				{
					if(isset($_GET[1]))
					{
						new $classname($_GET[1]);
					}
					else
					{
						new $classname();
					}
					die();
				}
			}
		}
		
	}
	
	/* Get all templates */
	private function getTemplates()
	{
		$this->db->prepare("SELECT * FROM templates");
		$this->db->execute();
		$templates = $this->db->fetchAll();

		foreach ($templates as $temp)
		{
			$template['template_name']			=	$temp['template_name'];
			$template['template_package']		=	"<a href='" . __URL__ . "/uploads/templates/" . $temp['template_package'] . "'>" . $temp['template_package'] . "</a>";
			$template['template_description']	=	$temp['template_description'];
			$template['template_actions']		=	'<a class="button button-rounded button-primary" href="?page=templates&amp;action=edit&amp;id=' . $temp['id'] . '"><i class="icon-cog"></i></a>
													<a class="button button-rounded button-caution" href="?page=templates&amp;action=delete&amp;id=' . $temp['id'] . '" onclick="return confirm(\'Are you sure you want to delete this template?\')"><i class="icon-trash"></i></a>';
			$this->templates[]	= $template;
		}
		
	}
	
	/* Show Templates Overview. */
	private function showTemplatesOverview()
	{
		$header = new Template("header.tpl.php");
		$header->set("title", "BuildTool - Templates Overview");
		$header->set("subtitle", "Overview of your app templates.");
		$footer = new Template("footer.tpl.php");
		$body = new Template("templates.tpl.php");
		$body->set("header", $header->parse());
		$body->set("footer", $footer->parse());
		$body->set("username", $_SESSION["user"]);
		$body->set("templates", $this->templates);
		$body->render();
	}
	
}
?>