<?php echo $this->header ?>

		<!-- Container -->
		<div id="container">
			
			<!-- Navigation -->
			<nav>
				<ul class="navigation">
					<li id="dashboard">
						<a href="?page=dashboard"><i class="icon-dashboard"></i>Dashboard</a>
					</li>
					<li id="templates">
						<a href="?page=templates"><i class="icon-file"></i>Templates</a>
					</li>
					<li id="apps" class="current">
						<a href="?page=apps"><i class="icon-mobile-phone"></i>Apps</a>
					</li>
					<li id="settings">
						<a href="?page=settings"><i class="icon-cog"></i>Settings</a>
					</li>
				</ul>
			</nav>
			
			<!-- Content -->
			<div class="content">
				
				<form method="post" enctype="multipart/form-data" id="addapp_form" autocomplete="off">
				
					<div class="title">
						<p class="user">Welcome, <b><?php echo $this->username ?></b></p>
						<p class="logout"><a href="?page=settings&amp;action=user-edit&amp;name=<?php echo $this->username ?>">Edit</a> | <a href="?logout">Logout</a>
					</div>
					
					<div class="divider"></div>
					
					<div class="message">
						<?php if(isset($this->error)): ?>
						<img class="message-icon" src="./assets/images/icons/cross.png"><?php echo $this->error ?>
						<?php else: ?>
						<b>Global Settings</b><br><br>
						Add your new app here. First provide some global information.
						<?php endif; ?>
					</div>
					
					<div class="divider"></div>
					
					<div class="field">
						<label for="app_name">App Name*:</label>
						<input type="text" id="app_name" name="app_name" class="required">

						<label for="app_identifier">Package Identifier*:</label>
						<a href="#" class="tooltip" title="The package/bundle identifier, it has to be the same as your App ID in Apple when you want to publish your app to the App Store. This identifier may only contain uppercase letters, lowercase letters and underscores. Once you published your application, this identifier can't be changed."><i class="icon-question-sign"></i></a>
						<input type="text" id="app_identifier" name="app_identifier" class="required">
					</div>
				
					<div class="field">
						<label for="app_version">Version*:</label>
						<a href="#" class="tooltip" title="The version number of your app. It's the number shown to the users that download your app. Make sure you raise this number on each app update. (For example from '1.0' to '2.0')."><i class="icon-question-sign"></i></a>
						<input type="text" id="app_version" name="app_version" class="required">

						<label for="app_versioncode">Version Code*:</label>
						<a href="#" class="tooltip" title="The version code is an internal version number, used to determine whether one version is more recent than another. Make sure each time you update your app, you raise this number. (For example from '1' to '2')."><i class="icon-question-sign"></i></a>
						<input type="text" id="app_versioncode" name="app_versioncode" class="required">
					</div>
				
					<div class="field">
						<label for="app_description">App Description:</label><br>
						<textarea id="app_description" name="app_description"></textarea>
					</div>
					
					<div class="field">
						<label for="app_template">Template:</label>
						<span class="dropdown">
							<script type="text/javascript">
							$(function(){
								$("#app_templateid").change();
							});
							</script>
							<select class="required" id="app_templateid" name="app_templateid" onChange="getTemplateOptions(this, '')">
								<?php foreach ($this->templates as $template): ?>
								<option value="<?php echo $template['id'] ?>"><?php echo $template['template_name'] ?></option>
								<?php endforeach; ?>
							</select>
						</span>

						<label for="app_debug">Debug:</label>
						<a href="#" class="tooltip" title="You can set your app to 'Debug Mode'. Which will allow you to debug your app. Disable this when your going to publish your app to the stores."><i class="icon-question-sign"></i></a>
						<div class="toggle right_toggle">
							<input type="checkbox" id="app_debug" name="app_debug"/>
							<b class="b switch"></b>
							<b class="b track"></b>
						</div>
					</div>
					
					<div id="template_settings"></div>
					
					<div class="divider"></div>

					<div class="message">
						<b>Certificates</b><br><br>
						If you want to publish your app to the stores, you need to provide your certificates and keys for certain platforms. Read the documentation to get more information about signing your apps.
					</div>

					<div class="divider"></div>
					
					<div id="advanced-options">
						<a href="#android-certificates" class="button button-rounded button-flat-action call-modal"><i class="icon-android"></i> Android</a>
						<a href="#ios-certificates" class="button button-rounded button-flat-action call-modal"><i class="icon-apple"></i> iOS</a>
						<a href="#blackberry-certificates" class="button button-rounded button-flat-action call-modal"><i class="icon-blackberry"></i> BlackBerry</a>
					</div>
					
					<section class="semantic-content" id="android-certificates" tabindex="-1" role="dialog" aria-labelledby="modal-label" aria-hidden="true">
						<div class="modal-inner">
							<header>
								<h1 id="modal-label">Android Certificates</h1>
							</header>
							<div class="modal-content">
								<div class="field">
									<label for="certificate-title">Title:</label>
									<a href="#" class="tooltip" title="The title of your key, keep this unique. "><i class="icon-question-sign"></i></a>
									<input type="text" id="certificate-title" name="android-certificate-title" class="modal_input">
								</div>
								<div class="field">
									<label for="certificate-alias">Alias:</label>
									<a href="#" class="tooltip" title="The alias of your key, you've created this when generating the key. "><i class="icon-question-sign"></i></a>
									<input type="text" id="certificate-alias" name="android-certificate-alias" class="modal_input" value="">
								</div>
								<div class="field">
									<label for="certificate-keypass">Key Password:</label>
									<a href="#" class="tooltip" title="The password you've entered when generating the Key. "><i class="icon-question-sign"></i></a>
									<input type="password" id="certificate-keypass" name="android-certificate-keypass" class="modal_input" value="">
								</div>
								<div class="field">
									<label for="certificate-keystorepass">Keystore Password:</label>
									<a href="#" class="tooltip" title="The password you've entered when generating the Keystore. "><i class="icon-question-sign"></i></a>
									<input type="password" id="certificate-keystorepass" name="android-certificate-keystorepass" class="modal_input">
								</div>
								<div class="field">
									<label for="android-keystore-input">Keystore:</label>
									<a href="#" class="tooltip" title="The keystore containing the sign Key. "><i class="icon-question-sign"></i></a>
									<input type="file" class="hidden" accept=".keystore,.jks" id="android-keystore-input" name="android-keystore-input">
									<input type="text" id="android-keystore" name="android-keystore" readonly class="modal_file_input">
									<a onclick="$('input[id=android-keystore-input]').click();" class="button button-rounded button-flat-action modal_file_button"><i class='icon-upload'></i></a>
								</div>
								<div class="modal_buttons">
									<a onClick="removeCert('android')" id="add-button" class="button button-rounded button-flat-caution"><i class="icon-remove"></i> REMOVE</a>
									<a href="#!" id="add-button" class="button button-rounded button-flat-action"><i class="icon-plus"></i> SAVE</a>
								</div>
							</div>
						</div>
						<a href="#!" class="modal-close" title="Close" data-dismiss="modal">&times;</a>
					</section>
					
					<section class="semantic-content" id="ios-certificates" tabindex="-1" role="dialog" aria-labelledby="modal-label" aria-hidden="true">
						<div class="modal-inner">
							<header>
								<h1 id="modal-label">iOS Certificates</h1>
							</header>
							<div class="modal-content">
								<div class="field">
									<label for="certificate-title">Title:</label>
									<a href="#" class="tooltip" title="The title of your certificate, keep this unique. "><i class="icon-question-sign"></i></a>
									<input type="text" id="certificate-title" name="ios-certificate-title" class="modal_input">
								</div>
								<div class="field">
									<label for="certificate-pass">Password:</label>
									<a href="#" class="tooltip" title="The password of your (p12) certificate. "><i class="icon-question-sign"></i></a>
									<input type="password" id="certificate-pass" name="ios-certificate-pass" class="modal_input">
								</div>
								<div class="field">
									<label for="ios-p12-input">P12 File:</label>
									<a href="#" class="tooltip" title="Your p12 certificate file, exported from your Keychain. "><i class="icon-question-sign"></i></a>
									<input type="file" class="hidden" accept=".p12" id="ios-p12-input" name="ios-p12-input">
									<input type="text" id="ios-p12" name="ios-p12" readonly class="modal_file_input">
									<a onclick="$('input[id=ios-p12-input]').click();" class="button button-rounded button-flat-action modal_file_button"><i class='icon-upload'></i></a>
								</div>
								<div class="field">
									<label for="ios-provisioning-input">Prov. Profile:</label>
									<a href="#" class="tooltip" title="Your provisioning profile, available from the Apple Developer Portal. "><i class="icon-question-sign"></i></a>
									<input type="file" class="hidden" accept=".mobileprovision" id="ios-provisioning-input" name="ios-provisioning-input">
									<input type="text" id="ios-provisioning" name="ios-provisioning" readonly class="modal_file_input">
									<a onclick="$('input[id=ios-provisioning-input]').click();" class="button button-rounded button-flat-action modal_file_button"><i class='icon-upload'></i></a>
								</div>
								<div class="modal_buttons">
									<a onClick="removeCert('ios')" id="add-button" class="button button-rounded button-flat-caution"><i class="icon-remove"></i> REMOVE</a>
									<a href="#!" id="add-button" class="button button-rounded button-flat-action"><i class="icon-plus"></i> SAVE</a>
								</div>
							</div>
						</div>
						<a href="#!" class="modal-close" title="Close" data-dismiss="modal">&times;</a>
					</section>
					
					<section class="semantic-content" id="blackberry-certificates" tabindex="-1" role="dialog" aria-labelledby="modal-label" aria-hidden="true">
						<div class="modal-inner">
							<header>
								<h1 id="modal-label">BlackBerry Certificates</h1>
							</header>
							<div class="modal-content">
								<div class="field">
									<label for="certificate-title">Title:</label>
									<a href="#" class="tooltip" title="The title of your certificate, keep this unique."><i class="icon-question-sign"></i></a>
									<input type="text" id="certificate-title" name="blackberry-certificate-title" class="modal_input">
								</div>
								<div class="field">
									<label for="certificate-pass">Password:</label>
									<a href="#" class="tooltip" title="The password of your Keystore. "><i class="icon-question-sign"></i></a>
									<input type="password" id="certificate-pass" name="blackberry-certificate-pass" class="modal_input">
								</div>
								<div class="field">
									<label for="blackberry-csk-input">CSK File:</label>
									<a href="#" class="tooltip" title="The generated CSK file from your CSJ file."><i class="icon-question-sign"></i></a>
									<input type="file" class="hidden" accept=".csk" id="blackberry-csk-input" name="blackberry-csk-input">
									<input type="text" id="blackberry-csk" name="blackberry-csk" readonly class="modal_file_input">
									<a onclick="$('input[id=blackberry-csk-input]').click();" class="button button-rounded button-flat-action modal_file_button"><i class='icon-upload'></i></a>
								</div>
								<div class="field">
									<label for="blackberry-db-input">DB File:</label>
									<a href="#" class="tooltip" title="The generated DB file from your CSJ file."><i class="icon-question-sign"></i></a>
									<input type="file" class="hidden" accept=".db" id="blackberry-db-input" name="blackberry-db-input">
									<input type="text" id="blackberry-db" name="blackberry-db" readonly class="modal_file_input">
									<a onclick="$('input[id=blackberry-db-input]').click();" class="button button-rounded button-flat-action modal_file_button"><i class='icon-upload'></i></a>
								</div>
								<div class="modal_buttons">
									<a onClick="removeCert('blackberry')" id="add-button" class="button button-rounded button-flat-caution"><i class="icon-remove"></i> REMOVE</a>
									<a href="#!" id="add-button" class="button button-rounded button-flat-action"><i class="icon-plus"></i> SAVE</a>
								</div>
							</div>
						</div>
						<a href="#!" class="modal-close" title="Close" data-dismiss="modal">&times;</a>
					</section>
					
					<div class="divider"></div>
					
					<div class="message">
						<b>Artwork</b><br><br>
						Here you can change your app icon and splash screen. Provide for each platform/device the artwork, or only provide the default icon/splashscreen.
						Your icons and splashscreen will be sized/scaled when their not provided in the correct format.
					</div>

					<div class="divider"></div>
					
					<div id="advanced-options">
						<a href="#icons" class="button button-rounded button-flat-action call-modal">Icon Management</a>
						<a href="#splashscreens" class="button button-rounded button-flat-action call-modal">Splashscreen Management</a>
					</div>
					
					<section class="semantic-content" id="icons" tabindex="-1" role="dialog" aria-labelledby="modal-label" aria-hidden="true">
						<div class="modal-inner">
							<header>
								<h1 id="modal-label">Icon Management</h1>
							</header>
							<div class="modal-content">
								<table id="icons_management">
									<thead>
										<tr>
											<th>Preview</th>
											<th>Platform / Device</th>
											<th>Required Size</th>
											<th class="action">Action</th>
										</tr>
									</thead>
									<tbody>
									</tbody>
								</table>
							</div>
							<footer>
								<div class="modal_buttons">
									<a href="#!" id="add-button" class="button button-rounded button-flat-action"><i class="icon-plus"></i> SAVE</a>
								</div>
							</footer>
						</div>
						<a href="#!" class="modal-close" title="Close" data-dismiss="modal">&times;</a>
					</section>
					
					<section class="semantic-content" id="splashscreens" tabindex="-1" role="dialog" aria-labelledby="modal-label" aria-hidden="true">
						<div class="modal-inner">
							<header>
								<h1 id="modal-label">Splashscreen Management</h1>
							</header>
							<div class="modal-content">
								<table id="splashscreen_management">
									<thead>
										<tr>
											<th>Preview</th>
											<th>Platform / Device</th>
											<th>Required Size</th>
											<th class="action">Action</th>
										</tr>
									</thead>
									<tbody>
									</tbody>
								</table>
							</div>
							<footer>
								<div class="modal_buttons">
									<a href="#!" id="add-button" class="button button-rounded button-flat-action"><i class="icon-plus"></i> SAVE</a>
								</div>
							</footer>
						</div>
						<a href="#!" class="modal-close" title="Close" data-dismiss="modal">&times;</a>
					</section>
					
					<div class="divider"></div>

					<div class="message">
						<b>Extra's</b><br><br>
						Here you can setup your app extras, like Push Notifications, Stats and Ads. Read the documentation to get more info on how to setup Push Notifications, Google Analytics, and Admob.
					</div>
					
					<div class="field">
						<div class="tabs">
							<ul>
								<li><a href="#tabs-1" title="">Push Notifications</a></li>
								<li><a href="#tabs-2" title="">Stats</a></li>
								<li><a href="#tabs-3" title="">Ads</a></li>
								<li><a href="#tabs-4" title="">Preferences</a></li>
								<li><a href="#tabs-5" title="">Plugins</a></li>
								<li><a href="#tabs-6" title="">iOS</a></li>
								<li><a href="#tabs-7" title="">Android</a></li>								
							</ul>
							<div id="tabs_container">
								<div id="tabs-1">
									<div class="message">
										Setup <b>unlimited</b> Push Notifications. Please fill in the required fields and, you will be able to send notifications in BuildTool after building your app.
									</div>
									
									<div class="divider"></div>
									
									<div class="field">
										<label class="fullwidth_label" for="push_android_enable">Enable Android Push Notifications:
										<a href="#" class="fullwidth_tooltip" title="Enable Push Notifications for Android devices."><i class="icon-question-sign"></i></a>
										</label>
										<div class="toggle fullwidth_toggle"><input type="checkbox" id="push_android_enable" name="push_android_enable" onchange="togglePushAndroid()">
											<b class="b switch"></b>
											<b class="b track"></b>
										</div>
									</div>
									
									<div class="field">
										<label class="fullwidth_label" for="push_android_senderid">Android GCM Sender ID:
										<a href="#" class="fullwidth_tooltip" title="The Android Sender/Project ID, that you can find on the <a href='https://code.google.com/apis/console' target='_blank'>Google Developer Console</a>. Read more about this in the BuildTool Documentation."><i class="icon-question-sign"></i></a>
										</label>
										<input type="text" id="push_android_senderid" name="push_android_senderid" disabled>
									</div>
									
									<div class="field">
										<label class="fullwidth_label" for="push_android_apikey">Android GCM API Key:
										<a href="#" class="fullwidth_tooltip" title="The Android Push GCM API Key, that also can be found on the <a href='https://code.google.com/apis/console' target='_blank'>Google Developer Console</a>. Read more about this in the BuildTool Documentation."><i class="icon-question-sign"></i></a>
										</label>
										<input type="text" id="push_android_apikey" name="push_android_apikey" disabled>
									</div>
									
									<div class="field">
										<label class="fullwidth_label" for="push_ios_enable">Enable iOS Push Notifications:
										<a href="#" class="fullwidth_tooltip" title="Enable Push Notifications for iOS devices."><i class="icon-question-sign"></i></a>
										</label>
										<div class="toggle fullwidth_toggle"><input type="checkbox" id="push_ios_enable" name="push_ios_enable" onchange="togglePushIOS()">
											<b class="b switch"></b>
											<b class="b track"></b>
										</div>
									</div>
									
									<div class="field">
										<label class="fullwidth_label" for="push_ios_certificate">iOS Push Certificate (.cer):
										<a href="#" class="fullwidth_tooltip" title="The iOS Push Certificate that you can find on the <a href='https://developer.apple.com/devcenter/ios/index.action' target='_blank'>iOS Dev Center</a>. Read more about how to generate one in the BuildTool Documentation."><i class="icon-question-sign"></i></a>
										</label>
										<input type="file" class="hidden" accept=".cer" id="push_ios_certificate" name="push_ios_certificate">
										<a id="push_ios_certificate_button" onclick="if(!$(this).hasClass('disabled')) $('input[id=push_ios_certificate]').click();" class="button disabled button-rounded button-flat-action filebutton">Browse</a>
										<input type="text" id="push_ios_certificate_name" name="push_ios_certificate_name" class="fileinput" disabled="">
									</div>

									<div class="field">
										<label class="fullwidth_label" for="push_ios_privatekey">iOS Push Private Key (.pem):
										<a href="#" class="fullwidth_tooltip" title="The iOS Push Private Key that you have to export from your Mac computer. Read more about how to do so, in the BuildTool Documentation."><i class="icon-question-sign"></i></a>
										</label>
										<input type="file" class="hidden" accept=".pem" id="push_ios_privatekey" name="push_ios_privatekey">
										<a id="push_ios_privatekey_button" onclick="if(!$(this).hasClass('disabled')) $('input[id=push_ios_privatekey]').click();" class="button disabled button-rounded button-flat-action filebutton">Browse</a>
										<input type="text" id="push_ios_privatekey_name" name="push_ios_privatekey_name" class="fileinput" disabled="">
										</div>
									
									<div class="field">
										<label class="fullwidth_label" for="push_ios_privatekey_password">iOS Push Private Key Password:
										<a href="#" class="fullwidth_tooltip" title="The private key password you've used to export the private key."><i class="icon-question-sign"></i></a>
										</label>
										<input type="text" id="push_ios_privatekey_password" name="push_ios_privatekey_password" disabled>
									</div>
									
									<div class="field">
										<label class="fullwidth_label" for="push_ios_developmentmode">iOS Development Mode:
										<a href="#" class="fullwidth_tooltip" title="By default push notifications are in Production mode, this means the app will be packaged for App Store publication. If not, check this so it can be tested in Development Mode (Sandbox)."><i class="icon-question-sign"></i></a>
										</label>
										<div class="toggle fullwidth_toggle"><input type="checkbox" id="push_ios_developmentmode" name="push_ios_developmentmode">
											<b class="b switch"></b>
											<b class="b track"></b>
										</div>
									</div>
									
								</div>
								<div id="tabs-2">
									<div class="message">
										Setup Google Analytics to retrieve usage information from your app on Android and iOS. Please fill in the required fields and, you will be able to get all your app statistics in BuildTool after building your app.
									</div>
									
									<div class="divider"></div>
									
									<div class="field">
										<label class="fullwidth_label" for="stats_ga_enable">Enable Google Analytics:
										<a href="#" class="fullwidth_tooltip" title="Enable Google Analytics for your app statistics."><i class="icon-question-sign"></i></a>
										</label>
										<div class="toggle fullwidth_toggle"><input type="checkbox" id="stats_ga_enable" name="stats_ga_enable" onchange="toggleStats()">
											<b class="b switch"></b>
											<b class="b track"></b>
										</div>
									</div>
									
									<div class="field">
										<label class="fullwidth_label" for="stats_ga_accountid">Google Analytics Account ID:
										<a href="#" class="fullwidth_tooltip" title="The Google Analytics Account ID. Read the BuildTool Documentation about how to generate this."><i class="icon-question-sign"></i></a>
										</label>
										<input type="text" id="stats_ga_accountid" name="stats_ga_accountid" disabled>
									</div>

								</div>
								<div id="tabs-3">
									<div class="message">
										Add Ads to your app. Currently only iAds are available for iOS. Due too Phonegap Build not (yet) allowing Admob as plugin, it isn't available in Buildtool.
									</div>
									
									<div class="divider"></div>
									
									<div class="field">
										<label class="fullwidth_label" for="ads_iads_enable">Enable iAds:
										<a href="#" class="fullwidth_tooltip" title="Enable iAds to monitize your app."><i class="icon-question-sign"></i></a>
										</label>
										<div class="toggle fullwidth_toggle"><input type="checkbox" id="ads_iads_enable" name="ads_iads_enable" onchange="toggleAds()">
											<b class="b switch"></b>
											<b class="b track"></b>
										</div>
									</div>
									
									<div class="field">
										<label class="fullwidth_label" for="ads_iads_position">Position of ads:
										<a href="#" class="fullwidth_tooltip" title="The position of the iAds."><i class="icon-question-sign"></i></a>
										</label>
										<span class="dropdown" disabled>
											<select id="ads_iads_position" name="ads_iads_position" disabled>
												<option value="top">Top</option>
												<option value="bottom">Bottom</option>
											</select>
										</span>
									</div>
									
								</div>
								<div id="tabs-4">
									<div class="message">
										Change the template's default Phonegap preferences, but beaware: <b>Removing, adding or changing any preferences might crash your app.</b>
									</div>
									
									<div class="divider"></div>
									
									<center><a href="#preferences" class="button button-rounded button-flat-action call-modal">Preferences Management</a></center>
										
								</div>
								<div id="tabs-5">
									<div class="message">
										Change the template's default Phonegap plugins but beaware: <b>Removing any of these plugins might crash your app.</b>
									</div>
									
									<div class="divider"></div>
									
									<center><a href="#plugins" class="button button-rounded button-flat-action call-modal">Plugins Management</a></center>
									
								</div>
								<div id="tabs-6">
									<div class="message">
										Change any iOS specific options.
									</div>
									
									<div class="divider"></div>
									
									<div class="field">
										<label class="fullwidth_label" for="specific_ios_showstatusbar">Show Statusbar (iOS 7+):
										<a href="#" class="fullwidth_tooltip" title="Show the iOS statusbar in your app."><i class="icon-question-sign"></i></a>
										</label>
										<div class="toggle fullwidth_toggle"><input type="checkbox" id="specific_ios_showstatusbar" name="specific_ios_showstatusbar" checked="">
											<b class="b switch"></b>
											<b class="b track"></b>
										</div>
									</div>
									
									<div class="field">
										<label class="fullwidth_label" for="specific_ios_overlaystatusbar">Overlay Statusbar (iOS 7+):
										<a href="#" class="fullwidth_tooltip" title="If this is enabled, your statusbar will overlay the webview. If its disabled the statusbar will appear as in iOS 6."><i class="icon-question-sign"></i></a>
										</label>
										<div class="toggle fullwidth_toggle"><input type="checkbox" id="specific_ios_overlaystatusbar" name="specific_ios_overlaystatusbar" onchange="toggleStatusbarstyle()">
											<b class="b switch"></b>
											<b class="b track"></b>
										</div>
									</div>
									
									<div class="field">
										<label class="fullwidth_label" for="specific_ios_statusbarstyle">Statusbar Style (iOS 7+):
										<a href="#" class="fullwidth_tooltip" title="The style of the statusbar when overlaying your webview."><i class="icon-question-sign"></i></a>
										</label>
										<span class="dropdown" disabled>
											<select id="specific_ios_statusbarstyle" name="specific_ios_statusbarstyle" disabled>
												<option value="default">Default (Dark Text)</option>
												<option value="lightcontent">Light Content (Light Text)</option>
												<option value="blackopaque">Black Opaque (Light Text)</option>
												<option value="blacktranslucent">Black Translucent (Light Text)</option>
											</select>
										</span>
									</div>
								</div>
								<div id="tabs-7">
									<div class="message">
										Change any Android specific options. None available yet.
									</div>
								</div>
							</div>
						</div>
					</div>
					
					<!-- Preferences Modal -->
					<section class="semantic-content" id="preferences" tabindex="-1" role="dialog" aria-labelledby="modal-label" aria-hidden="true">
						<div class="modal-inner">
							<header>
								<h1 id="modal-label">Preferences Management</h1>
							</header>
							<div class="modal-content">
								<table id="preferences_management">
									<thead>
										<tr>
											<th>Preference</th>
											<th>Value</th>
											<th>Action</th>
										</tr>
									</thead>
									<tbody>												
									</tbody>
								</table>
							</div>
							<footer>
								Add:
								<div class="field">
									<label for="name">Name:</label>
									<label id="value-label" for="value">Value:</label>
									<br><br>
									<input type="text" id="name" name="name">
									<input type="text" id="value" name="value">
									<a href="#preferences" onClick="addItem(this)" id="add-button" class="button button-rounded button-flat-action"><i class="icon-plus"></i> ADD</a>
								</div>
							</footer>
						</div>
						<a href="#!" class="modal-close" title="Close" data-dismiss="modal">&times;</a>
					</section>
					
					<!-- Plugins Modal -->
					<section class="semantic-content" id="plugins" tabindex="-1" role="dialog" aria-labelledby="modal-label" aria-hidden="true">
						<div class="modal-inner">
							<header>
								<h1 id="modal-label">Plugins Management</h1>
							</header>
							<div class="modal-content">
								<table id="plugins_management">
									<thead>
										<tr>
											<th>Plugin</th>
											<th>Action</th>
										</tr>
									</thead>
									<tbody>												
									</tbody>
								</table>
							</div>
							<footer>
								Add:
								<div class="field">
									<label for="name">Plugin:</label>
									<input type="text" id="name" name="name">
									<input type="hidden" id="value" name="value" value="-">
									<a href="#plugins" onClick="addItem(this)" id="add-button" class="button button-rounded button-flat-action"><i class="icon-plus"></i> ADD</a>
								</div>
							</footer>
						</div>
						<a href="#!" class="modal-close" title="Close" data-dismiss="modal">&times;</a>
					</section>
					
					<!-- Features Modal (not necessary yet) -->
					<!-- <section class="semantic-content" id="features" tabindex="-1" role="dialog" aria-labelledby="modal-label" aria-hidden="true">
						<div class="modal-inner">
							<header>
								<h1 id="modal-label">Features Management</h1>
							</header>
							<div class="modal-content">
								<table id="features_management">
									<thead>
										<tr>
											<th>Feature</th>
											<th>Value</th>
											<th>Action</th>
										</tr>
									</thead>
									<tbody>												
									</tbody>
								</table>
							</div>
							<footer>
								Add:
								<div class="field">
									<label for="name">Name:</label>
									<label id="value-label" for="value">Value:</label>
									<br><br>
									<input type="text" id="name" name="name" class="required">
									<input type="text" id="value" name="value" class="required">
									<a href="#features" onClick="addItem(this)" id="add-button" class="button button-rounded button-flat-action"><i class="icon-plus"></i> ADD</a>
								</div>
							</footer>
						</div>
						<a href="#!" class="modal-close" title="Close" data-dismiss="modal">&times;</a>
					</section> -->

					<div class="divider"></div>
					
					<div class="nextstep">
						<a href="?page=apps" class="button button-rounded button-flat-caution">CANCEL</a>
						<input type="submit" value="SAVE" class="button button-rounded button-flat-primary">
					</div>
					
				</form>
					
			</div>
			
		</div>

<?php echo $this->footer ?>