<?php echo $this->header ?>

		<!-- Container -->
		<div id="container">
			
			<!-- Navigation -->
			<nav>
				<ul class="navigation">
					<li id="dashboard">
						<a href="?page=dashboard"><i class="icon-dashboard"></i>Dashboard</a>
					</li>
					<li id="templates">
						<a href="?page=templates"><i class="icon-file"></i>Templates</a>
					</li>
					<li id="apps" class="current">
						<a href="?page=apps"><i class="icon-mobile-phone"></i>Apps</a>
					</li>
					<li id="settings">
						<a href="?page=settings"><i class="icon-cog"></i>Settings</a>
					</li>
				</ul>
			</nav>
			
			<!-- Content -->
			<div class="content">
				
				<div class="title">
					<p class="user">Welcome, <b><?php echo $this->username ?></b></p>
					<p class="logout"><a href="?page=settings&amp;action=user-edit&amp;name=<?php echo $this->username ?>">Edit</a> | <a href="?logout">Logout</a>
				</div>
				
				<div class="divider"></div>
				
				<div class="message">
				<a href="?page=apps&amp;action=new" class="button button-rounded button-flat-action newbutton">Create App</a>
				<?php if(isset($this->success)): ?>
				<img class="message-icon" src="./assets/images/icons/tick.png"><?php echo $this->success ?>
				<?php elseif(isset($this->error)): ?>
				<img class="message-icon" src="./assets/images/icons/cross.png"><?php echo $this->error ?>
				<?php else: ?>
					Overview of all your created apps. Press the button on the right to create a new one.
				<?php endif; ?>
				</div>
				
				<div class="divider"></div>
				
				<?php if(count($this->apps) > 0): ?>
				<table>
			
					<thead>
						<tr>
							<th>App Name</th>
							<th>App Template</th>
							<th>App Description</th>
							<th class="actions">Actions</th>
						</tr>
					</thead>
					
					<tbody>
						<?php foreach ($this->apps as $app): ?>
						<tr>
							<td><?php echo $app['app_name']; ?></td>
							<td><?php echo $app['app_template']; ?></td>
							<td><?php echo $app['app_description']; ?></td>
							<td><?php echo $app['app_actions']; ?></td>
						</tr>
						<?php endforeach; ?>					
					</tbody>
				
				</table>
				<?php endif; ?>
				
				<div id="loader">
					<div id="loader-inner">
						<span class="circle"></span>
						<span class="circle"></span>
						<span class="circle"></span>
					</div>
				</div>
				
				<section class="semantic-content" id="build" tabindex="-1" role="dialog" aria-labelledby="modal-label" aria-hidden="true">
					<div class="modal-inner">
						<header>
							<h1 id="modal-label">Download App</h1>
						</header>
						<div class="modal-content" id="build_downloads">
						</div>
					</div>
					<a href="#!" class="modal-close" title="Close" data-dismiss="modal">&times;</a>
				</section>
				
			</div>
			
		</div>

<?php echo $this->footer ?>