<?php echo $this->header ?>

		<!-- Check for updates -->
		<script type="text/javascript">checkUpdates();</script>

		<!-- Container -->
		<div id="container">
			
			<!-- Navigation -->
			<nav>
				<ul class="navigation">
					<li id="dashboard" class="current">
						<a href="?page=dashboard"><i class="icon-dashboard"></i>Dashboard</a>
					</li>
					<li id="templates">
						<a href="?page=templates"><i class="icon-file"></i>Templates</a>
					</li>
					<li id="apps">
						<a href="?page=apps"><i class="icon-mobile-phone"></i>Apps</a>
					</li>
					<li id="settings">
						<a href="?page=settings"><i class="icon-cog"></i>Settings</a>
					</li>
				</ul>
			</nav>
			
			<!-- Content -->
			<div class="content">
				
				<div class="title">
					<p class="user">Welcome, <b><?php echo $this->username ?></b></p>
					<p class="logout"><a href="?page=settings&amp;action=user-edit&amp;name=<?php echo $this->username ?>">Edit</a> | <a href="?logout">Logout</a>
				</div>
				
				<div class="divider"></div>
				
				<div class="message">
				<?php if(isset($this->success)): ?>
				<img class="message-icon" src="./assets/images/icons/tick.png"><?php echo $this->success ?>
				<?php elseif(isset($this->error)): ?>
				<img class="message-icon" src="./assets/images/icons/cross.png"><?php echo $this->error ?>
				<?php else: ?>
					Welcome to BuildTool! With BuildTool you can create your own cross-platform apps within minutes.
					Your app will support Android, iOS, BlackBerry, Windows Phone, Web OS and Symbian.
					After creating your app, you will be able to download and publish it to the app stores.
					Your HTML(5)/CSS(3) app will make use of all native functions using PhoneGap.
				<?php endif; ?>
				</div>
				
				<div class="divider"></div>
				
				<div class="message">
					<b>So, how does it work?</b><br><br>
					1. Create an account at the <a href="http://build.phonegap.com"><b>PhoneGap Build Service</b></a> and fill in your authentication credentials under '<b><a href="?page=settings">Settings</a></b>'.<br>
					2. Create and upload an custom made template under '<a href="?page=templates"><b>Templates</b></a>', or install a free/paid one from below.<br>
					3. Create your app on the '<a href="?page=apps&action=new"><b>Apps</b></a>' page. Fill in your app details, select your template and upload your artwork and certificates.<br>
					4. The final step is to download your app on the '<a href="?page=apps"><b>Apps</b></a>' page and test or publish it to the stores.<br><br>
				</div>
				
				<?php if(count($this->templates) > 0): ?>
				<div class="divider"></div>
				
				<table>
			
					<caption>Latest Templates</caption>
					
					<tbody>
						
						<?php
						$i = 0; 
						foreach ($this->templates as $template): ?>
						<tr>
							<td><?php echo $template['date']; ?></td>
							<td><b><?php echo $template['title']; ?></b><br><br><?php echo $template['description']; ?></td>
							<td><?php echo $template['action']; ?></td>
						</tr>
						<?php 
						if (++$i == 3) break;
						endforeach; ?>
						
					</tbody>
				
				</table>	
				<?php endif; ?>
				
				<a href="#show-templates" class="button button-rounded button-flat-action templatesbutton">Show All Downloadable Templates</a>
				
				<section class="semantic-content" id="show-templates" tabindex="-1" role="dialog" aria-labelledby="modal-label" aria-hidden="true">
					<div class="modal-inner">
						<header>
							<h1 id="modal-label">Downloadable Templates</h1>
						</header>
						<div class="modal-content">
							<?php if(count($this->templates) > 0): ?>
							<table>
								<tbody>
									<?php foreach ($this->templates as $template): ?>
									<tr>
										<td><?php echo $template['date']; ?></td>
										<td><b><?php echo $template['title']; ?></b><br><br><?php echo $template['description']; ?></td>
										<td><?php echo $template['action']; ?></td>
									</tr>
									<?php endforeach; ?>
								</tbody>
							</table>	
							<?php endif; ?>
						</div>
					</div>
					<a href="#!" class="modal-close" title="Close" data-dismiss="modal">&times;</a>
				</section>
				<div class="divider"></div>
				
				<div class="stats">
					<a href="?page=settings" class="button button-rounded button-flat-action"><i class="icon-user"></i> USERS: <?php echo $this->stats['users']; ?></a>
					<a href="?page=templates" class="button button-rounded button-flat-highlight"><i class="icon-file"></i> TEMPLATES: <?php echo $this->stats['templates']; ?></a>
					<a href="?page=apps" class="button button-rounded button-flat-caution"><i class="icon-mobile-phone"></i> APPS: <?php echo $this->stats['apps']; ?></a>
				</div>
				
			</div>
			
		</div>

<?php echo $this->footer ?>