<?php echo $this->header ?>

		<!-- Container -->
		<div id="container">
			
			<!-- Navigation -->
			<nav>
				<ul class="navigation">
					<li id="welcome" <?=($this->step == 1 ? "class=\"current\"" : "class=\"disabled\"")?>>
						<a href="#"><i <?=($this->step > 0 ? "class=\"icon-check\"" : "class=\"icon-check-empty\"")?>></i>1. Welcome</a>
					</li>
					<li id="requirements" <?=($this->step == 2 ? "class=\"current\"" : "class=\"disabled\"")?>>
						<a href="#"><i <?=($this->step > 1 ? "class=\"icon-check\"" : "class=\"icon-check-empty\"")?>></i>2. Requirements</a>
					</li>
					<li id="database" <?=($this->step == "3" ? "class=\"current\"" : "class=\"disabled\"")?>>
						<a href="#"><i <?=($this->step > 2 ? "class=\"icon-check\"" : "class=\"icon-check-empty\"")?>></i>3. Database</a>
					</li>
					<li id="finish" <?=($this->step == "4" ? "class=\"current\"" : "class=\"disabled\"")?>>
						<a href="#"><i <?=($this->step > 3 ? "class=\"icon-check\"" : "class=\"icon-check-empty\"")?>></i>4. Finish</a>
					</li>
				</ul>
			</nav>
			
			<!-- Content -->
			<div class="content">
			
				<?php if ($this->step == 1): ?>
				
				<form method="post">
				
					<div class="title">
						<p>Step 1: Welcome</p>
					</div>
					
					<div class="divider"></div>
					
					<div class="message">
					Welcome to BuildTool! With BuildTool you can create your own cross-platform apps within minutes.
					Your app will support Android, iOS, BlackBerry, Windows Phone, Web OS and Symbian.
					After creating your app, you will be able to download and publish it to the app stores.
					Your HTML(5)/CSS(3) app will make use of all native functions using PhoneGap.<br><br>
					
					Be sure to check the documentation. Press next to continue this 1 minute installation and have fun building apps!
					</div>
					
					<div class="divider"></div>
					
					<div class="nextstep">
						<input type="hidden" name="step1">
						<input type="submit" value="next" class="button button-rounded button-flat-primary">
					</div>
					
				</form>
				
				<?php elseif ($this->step == 2): ?>
				
				<form method="post">
				
					<div class="title">
						<p>Step 2: Requirements Check</p>
					</div>
					
					<div class="divider"></div>
					
					<div class="message">
					<?php if($this->passed): ?>
					<img class="message-icon" src="./assets/images/icons/tick.png">Buildtool just checked your requirements, and your server <font color="#006400">does</font> meet the requirements!<br>Move on to the next step.
					<?php else: ?>
					<img class="message-icon" src="./assets/images/icons/cross.png">Buildtool just checked your requirements, but unfortunately your server <font color="#FF0000">doesn't</font> meet the requirements.<br>Please fix them and recheck again or move on and risk something is not working.
					<?php endif; ?>
					</div>
					
					<div class="divider"></div>
					
					<table id="pages">
				
						<thead>
							<tr>
								<th>Requirement</th>
								<th>Result</th>
							</tr>
						</thead>

						<tbody>
							
							<?php foreach ($this->requirements as $req => $result): ?>
							<tr>
								<td><?php echo $req; ?></td>
								<td><?php echo $result; ?></td>
							</tr>
							<?php endforeach; ?>
							
						</tbody>
					
					</table>
					
					<div class="divider"></div>
					
					<div class="nextstep">
						<?php if($this->passed): ?>
						<input type="submit" name="step2" value="next" class="button button-rounded button-flat-primary">
						<?php else: ?>
						<input type="button" value="recheck" onClick="window.location.reload()" class="button button-rounded button-flat-primary">
						<input type="submit" name="step2" value="next" class="button button-rounded button-flat-primary">
						<?php endif; ?>
					</div>
					
				</form>
				
				<?php elseif ($this->step == 3): ?>
				
				<form method="post" id="database_form">
				
					<div class="title">
						<p>Step 3: Database Settings</p>
					</div>
					
					<div class="divider"></div>
					
					<?php if(!isset($this->errorarray) || !count($this->errorarray)): ?>
					
					<div class="message">
						Please provide your database details.
					</div>
					
					<?php else: ?>
				
					<div class="message">
						<img class="message-icon" src="./assets/images/icons/cross.png">Buildtool <font color="#FF0000">can't</font> be installed. Please try again.<br>The following errors occured:
					</div>

					<div class="divider"></div>
					
					<table id="pages">
				
						<thead>
							<tr>
								<th>Step</th>
								<th>Error</th>
							</tr>
						</thead>

						<tbody>
							
							<?php foreach ($this->errorarray as $step => $error): ?>
							<tr>
								<td><?php echo $step; ?></td>
								<td><?php echo $error; ?></td>
							</tr>
							<?php endforeach; ?>
							
						</tbody>
					
					</table>
						
					<?php endif; ?>
					
					<div class="divider"></div>
					
					<div class="field">
						<label for="db_host">Host:</label>
						<input type="text" id="db_host" name="db_host" value="localhost" onfocus="if(this.value == 'localhost') { this.value = ''; }">
						<label for="db_database">Database:</label>
						<input type="text" id="db_database" name="db_database" value="database" onfocus="if(this.value == 'database') { this.value = ''; }">
					</div>
					
					<div class="field">
						<label for="db_username">Username:</label>
						<input type="text" id="db_username" name="db_username" value="root" onfocus="if(this.value == 'root') { this.value = ''; }">
						<label for="db_password">Password:</label>
						<input type="text" id="db_password" name="db_password" value="">
					</div>
					
					<div class="divider"></div>
					
					<div class="message">
						Please provide your account login details.
					</div>
					
					<div class="divider"></div>
					
					<div class="field">
						<label for="account_username">Account Username:</label>
						<input type="text" id="account_username" name="account_username" value="admin" onfocus="if(this.value == 'admin') { this.value = ''; }">
						<label for="account_password">Account Password:</label>
						<input type="password" id="account_password" name="account_password" value="">
					</div>

					<div class="field">
						<label for="account_email">Account Email:</label>
						<input type="email" id="account_email" name="account_email" value="">
					</div>
					
					<div class="divider"></div>
					
					<div class="nextstep">
							<input type="hidden" name="step3">
							<input type="submit" value="next" class="button button-rounded button-flat-primary">
					</div>
				
				</form>
				
				<?php elseif ($this->step == 4): ?>
				
				<div class="title">
					<p>Step 4: Finish</p>
				</div>
				
				<div class="divider"></div>
				
				<div class="message">
					
					<?php if(isset($this->update)): ?>
					<img class="message-icon" src="./assets/images/icons/tick.png">Buildtool has been successfully updated!<br>You can login on the homepage and enjoy building apps with BuildTool. Goodluck!
					<?php else: ?>
					<img class="message-icon" src="./assets/images/icons/tick.png">Buildtool has been successfully installed!<br>You can login on the homepage with username/password: <?php echo $this->login ?>. Enjoy building apps with BuildTool, goodluck!
					<?php endif; ?>
					
				</div>
				
				<div class="divider"></div>
				
				<div class="nextstep">
					<a href="#" onclick="location.reload();" class="button button-rounded button-flat-primary">LOGIN</a>
				</div>
				
				<?php else: ?>
				
				<div class="title">
					<p><?php echo $this->message_title ?></p>
				</div>
				
				<div class="divider"></div>
				
				<div class="message">
				<?php echo $this->message ?>
				</div>
				
				<?php endif; ?>
				
			</div>
			
		</div>

<?php echo $this->footer ?>