<?php echo $this->header ?>

		<!-- Container -->
		<div id="container">
			
			<!-- Navigation -->
			<nav>
				<ul class="navigation">
					<li id="dashboard">
						<a href="?page=dashboard"><i class="icon-dashboard"></i>Dashboard</a>
					</li>
					<li id="templates">
						<a href="?page=templates"><i class="icon-file"></i>Templates</a>
					</li>
					<li id="apps">
						<a href="?page=apps"><i class="icon-mobile-phone"></i>Apps</a>
					</li>
					<li id="settings" class="current">
						<a href="?page=settings"><i class="icon-cog"></i>Settings</a>
					</li>
				</ul>
			</nav>
			
			<!-- Content -->
			<div class="content">
			
				<form method="post" id="settings_form" autocomplete="off">
				
					<div class="title">
						<p class="user">Welcome, <b><?php echo $this->username ?></b></p>
						<p class="logout"><a href="?page=settings&amp;action=user-edit&amp;name=<?php echo $this->username ?>">Edit</a> | <a href="?logout">Logout</a>
					</div>
					
					<div class="divider"></div>
					
					<div class="message">
					<?php if(isset($this->success)): ?>
					<img class="message-icon" src="./assets/images/icons/tick.png"><?php echo $this->success ?>
					<?php elseif(isset($this->error)): ?>
					<img class="message-icon" src="./assets/images/icons/cross.png"><?php echo $this->error ?>
					<?php else: ?>
						<b>System Settings</b><br><br>
						Change the system settings, users and API keys here. Please provide your Envato purchase id, so BuildTool can check if there are any updates available.
					<?php endif; ?>
					</div>
					
					<div class="divider"></div>

					<div class="field">
						<label for="buildtool_purchaseid">Envato Purchase ID:</label>
						<input type="text" class="long" id="buildtool_purchaseid" name="buildtool_purchaseid" value="<?php echo $this->buildtool_purchaseid ?>">
					</div>
					
					<div class="divider"></div>

					<div class="message">
						<b>Phonegap Build API</b><br><br>
						Make sure you filled in your Phonegap Build account details, so your able to build and download your app.<br>
						<b>Username and Password authentication only works for Adobe accounts.</b>
					</div>

					<div class="divider"></div>
					
					<div class="field">
						<label for="phonegap_username">Phonegap Username:</label>
						<input type="text" id="phonegap_username" name="phonegap_username" value="<?php echo $this->phonegap_username ?>">
						<label for="template_name">Phonegap Password:</label>
						<input type="password" id="phonegap_password" name="phonegap_password" value="<?php echo $this->phonegap_password ?>">
					</div>
					<br><br>
					<div class="message">
					Or fill in the Phonegap Authentication Token. You can find it <b><a href="https://build.phonegap.com/people/edit">here</a></b>. If Authentication Token is filled in, it will authenticate by token.
					</div>
					<br>
					<div class="field">
						<label for="phonegap_token">Phonegap Authentication:</label>
						<input type="text" class="long" id="phonegap_token" name="phonegap_token" value="<?php echo $this->phonegap_token ?>">
					</div>
					
					<div class="divider"></div>

					<div class="message">
						<b>User Management</b><br><br>
						Manage the users that have access to the BuildTool system.
					</div>

					<div class="divider"></div>
					
					<div class="field">
						<label for="allow_registration">Allow Registration:</label>
						<a href="#" class="tooltip" title="Allow users to register for BuildTool on the login page. PLEASE NOTE: You have to buy an extended license if you charge users for using BuildTool"><i class="icon-question-sign"></i></a>
						<div class="toggle left_toggle">
							<input type="checkbox" id="allow_registration" name="allow_registration" <?php echo ($this->allow_registration == "1" ? "checked" : "") ?>>
							<b class="b switch"></b>
							<b class="b track"></b>
						</div>
						<a href="?page=settings&amp;action=adduser" class="button button-rounded button-flat-action newbutton">Add User</a>
					</div>
					<table id="users">
				
						<caption>Users</caption>
						
						<thead>
							<tr>
								<th>Username</th>
								<th>Account Type</th>
								<th>Email</th>
								<th>Actions</th>
							</tr>
						</thead>
						<tbody>
							
							<?php foreach ($this->users as $user): ?>
							<tr>
								<td><?php echo $user['user_name']; ?></td>
								<td><?php echo $user['user_type']; ?></td>
								<td><?php echo $user['user_email']; ?></td>
								<td><?php echo $user['user_actions']; ?></td>
							</tr>
							<?php endforeach; ?>
							
						</tbody>
					
					</table>

					<div class="divider"></div>
					
					<div class="nextstep">
						<input type="submit" value="Save Settings" class="button button-rounded button-flat-primary">
					</div>
					
				</form>
			
			</div>
			
		</div>

<?php echo $this->footer ?>