<?php echo $this->header ?>

		<!-- Container -->
		<div id="container">
			
			<!-- Navigation -->
			<nav>
				<ul class="navigation">
					<li id="dashboard">
						<a href="?page=dashboard"><i class="icon-dashboard"></i>Dashboard</a>
					</li>
					<li id="templates" class="current">
						<a href="?page=templates"><i class="icon-file"></i>Templates</a>
					</li>
					<li id="apps">
						<a href="?page=apps"><i class="icon-mobile-phone"></i>Apps</a>
					</li>
					<li id="settings">
						<a href="?page=settings"><i class="icon-cog"></i>Settings</a>
					</li>
				</ul>
			</nav>
			
			<!-- Content -->
			<div class="content">
				
				<div class="title">
					<p class="user">Welcome, <b><?php echo $this->username ?></b></p>
					<p class="logout"><a href="?page=settings&amp;action=user-edit&amp;name=<?php echo $this->username ?>">Edit</a> | <a href="?logout">Logout</a>
				</div>
				
				<div class="divider"></div>
				
				<div class="message">
					<a href="?page=templates&amp;action=createnew" class="button button-rounded button-flat-action newbutton">Add Template</a>
				<?php if(isset($this->success)): ?>
				<img class="message-icon" src="./assets/images/icons/tick.png"><?php echo $this->success ?>
				<?php elseif(isset($this->error)): ?>
				<img class="message-icon" src="./assets/images/icons/cross.png"><?php echo $this->error ?>
				<?php else: ?>
					Overview of all your available templates. Each template has its own options, the values of these options can be changed while creating a new app. Press the button on the right to create a new one.
				<?php endif; ?>
				</div>
				
				<div class="divider"></div>
				
				<?php if(count($this->templates) > 0): ?>
				<table>
			
					<thead>
						<tr>
							<th>Template Name</th>
							<th>Template Package</th>
							<th>Template Description</th>
							<th>Actions</th>
						</tr>
					</thead>
						
					<tbody>
						
						<?php foreach ($this->templates as $template): ?>
						<tr>
							<td><?php echo $template['template_name']; ?></td>
							<td><?php echo $template['template_package']; ?></td>
							<td><?php echo $template['template_description']; ?></td>
							<td><?php echo $template['template_actions']; ?></td>
						</tr>
						<?php endforeach; ?>
						
					</tbody>
				
				</table>
				<?php endif; ?>
			
			</div>
			
		</div>

<?php echo $this->footer ?>